import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from rspgenerator import genrsp_GECAM
from coordtrans import *
import numpy as np
from tools import TTtoUTC, strTransforCLI

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
from .GUI_plotbase_GECAM import MPLbase
from .GUI_plotbase_GECAM import MPLwrapper
from .GUI_messagebox_GECAM import GUI_message

#import GUI_plotbase_GECAM



class rspgenerator_gui(QWidget):
   signal_rspgenerator_to_status_box = pyqtSignal(str)
   def __init__(self):
       super(rspgenerator_gui,self).__init__()
       self.initUI()
       self.attfile=[]
       self.GUI_message= GUI_message(self)

   def initUI(self): 
       #layout

       #left panel
       layout=QVBoxLayout()

       #mode selection
       self.gridGroupBox =  QGroupBox("")
       gridlayout = QGridLayout()

       # linedit ra dec input
       self.sttimeLabel = QLabel("time(MET):")
       self.inputline_sttime=QLineEdit()
       self.inputline_sttime.setPlaceholderText('st:e.g. 60509643.8077161')
       #self.locinputline_sttime.isClearButtonEnabled(True)                            

       # linedit ra dec input
       self.raLabel = QLabel("[Ra, Dec] input:")
       self.locinputline_ra=QLineEdit()
       self.locinputline_ra.setPlaceholderText('[Ra,Dec]:')
       #self.locinputline_ra.isClearButtonEnabled(True)


       self.btn_chooseAttFile = QPushButton(self)
       self.btn_chooseAttFile.setObjectName("btn_chooseAttFile")
       self.btn_chooseAttFile.setText("Add Att file")
       self.btn_chooseAttFile.clicked.connect(self.selAttFile)


       # button  detector selection  
       self.btn_generateRSP = QPushButton()
       self.btn_generateRSP.setText("generate RSP")
       self.btn_generateRSP.clicked.connect(self.startgenrsp)


       gridlayout.addWidget(self.sttimeLabel,1,0)
       gridlayout.addWidget(self.inputline_sttime,1,1)
       gridlayout.addWidget(self.btn_chooseAttFile,2,0)
       gridlayout.addWidget(self.raLabel,3,0)
       gridlayout.addWidget(self.locinputline_ra,3,1)
       gridlayout.addWidget(self.btn_generateRSP,4,0)


       gridlayout.setColumnStretch(1, 1)
       gridlayout.setSpacing(5)

       self.gridGroupBox.setLayout(gridlayout)
       layout.addWidget(self.gridGroupBox)

       self.setLayout(layout)
   def setobsmode(self, btn):
       self.obsmode=btn.text()

   def startgenrsp(self):
       #try:
       if 1:
          sttime='none'
          locationJ2000=[]
          att='none'
          thetaphi_satA=[]
          thetaphi_satB=[]
          if self.inputline_sttime.text()!='':
             sttime=self.inputline_sttime.text()
          att=self.attfile[-2:]
          sttimeMET= float(sttime)
          rspOutputDir = glv.rspoutputdir
          detIDlist=glv.detID_selected
          try:
            locationJ2000= strTransforCLI.strTran2list_float(self.locinputline_ra.text())
          except:
              self.GUI_message.show_message_warning("warning", "please check if [ra,dec] is input correctly!")
          #try:
          if 1:
               if detIDlist==[]:
                  detIDlist=np.arange(100).tolist()
               print(detIDlist) 
               detAindex = np.where(np.array(detIDlist)<50)[0]
               idlist_A = np.array(detIDlist)[detAindex].tolist()
               detBindex = np.where(np.array(detIDlist)>=50)[0]
               idlist_B = np.array(detIDlist)[detBindex].tolist()
                

               thetaphi_satA,rspfileDirSatA =genrsp_GECAM.genrspGUI(locationJ2000, sttimeMET, att, rspOutputDir, idlist_A, Satlabel='a')
               thetaphi_satB,rspfileDirSatB =genrsp_GECAM.genrspGUI(locationJ2000, sttimeMET, att, rspOutputDir, idlist_B, Satlabel='j')
               self.signal_rspgenerator_to_status_box.emit(' theta phi in satA:' + str(thetaphi_satA)
                                                           + ' directory of RSP for satA:' + str(rspfileDirSatA))
               self.signal_rspgenerator_to_status_box.emit(' theta phi in satB:' + str(thetaphi_satB)
                                                           + ' directory of RSP for satB:' + str(rspfileDirSatB))
         #except:
         #     self.GUI_message.show_message_warning("warning",'please check if para is input correctly! RSP generation failed! ')
       #except:
       #    self.GUI_message.show_message_warning("warning",
       #                                          "please check if para is input correctly!")

   def startrspgeneratorgui(self):
        if not self.isVisible():
            self.show()

   def selAttFile(self):
       files, filetype = QFileDialog.getOpenFileNames(self,
                                   "select Att file",
                                    os.getcwd(), # 起始路径 
                                   "All Files (*);;FITS Files (*.FITS);; fits Files (*.fits)")
       files.sort()
       #self.attfile.append(files[0])
       for ifilename in files:
             self.attfile.append(ifilename)
       self.signal_rspgenerator_to_status_box.emit('RSP generation: The choosen Att files are:' + str(self.attfile))
       QCoreApplication.instance().quit
       #self.close()










#if __name__ == '__main__':
#
#    app = QApplication(sys.argv)
#    ex = location_gui()
#    sys.exit(app.exec_())

   #def detecsel_loc(self):
   #def getlocinput_loc(self):
   #def getitertimesinput_loc(self):
   #def start_loc(self):
   #def save_loc(self)
