import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from tools import readrsp_GECAM, getindex_GECAM ,checkdir_GECAM, genRSPname_GECAM, strTransforCLI
from rspgenerator import *
from fitEdepos import fitspec_xspec_GUI_GECAM




from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
from .GUI_plotbase_GECAM import MPLbase
from .GUI_plotbase_GECAM import MPLwrapper
from .GUI_messagebox_GECAM import GUI_message
#import GUI_plotbase_GECAM
import time


class fitEdepos_gui(QWidget):
   signal_fitEdepos_to_status_box = pyqtSignal(str)
   def __init__(self):
       super(fitEdepos_gui,self).__init__()
       self.resize(520, 520)
       self.initUI()
       self.GUI_message= GUI_message(self)
       

   def initUI(self): 
       #layout
       
       layout=QVBoxLayout()
       layout.setSpacing(15)


       #RSP dir input box
       self.inputBox=QGroupBox("Location")
       inputgridlayout = QGridLayout() 
       self.thetaLabel = QLabel("theta, phi in SatA:")
       self.locinputline_theta=QLineEdit()
       self.locinputline_theta.setPlaceholderText('unit:degree, e.g. [100,200]')
       self.phiLabel = QLabel("theta, phi in SatB:")
       self.locinputline_phi=QLineEdit()
       self.locinputline_phi.setPlaceholderText('unit:degree, e.g. [31,20]')
       inputgridlayout.addWidget(self.thetaLabel,1,0)
       inputgridlayout.addWidget(self.locinputline_theta,1,1)
       inputgridlayout.addWidget(self.phiLabel,1,2)
       inputgridlayout.addWidget(self.locinputline_phi,1,3)
       self.inputBox.setLayout(inputgridlayout) 
       layout.addWidget(self.inputBox)



       #stylecombo & combine model box
       self.combogridGroupBox =  QGroupBox("fit models selection")
       combogridlayout = QGridLayout()
       self.fitmodelCombo = QComboBox(self)
       self.fitmodelCombo.addItem("None")
       self.fitmodelCombo.addItem("Power-law")
       self.fitmodelCombo.addItem("Band's GRB")
       self.fitmodelCombo.addItem("Comptonized")
       self.fitmodelCombo.addItem("Smoothly Broken Power law")
       self.fitmodelCombo.addItem("Black body")
       


       self.combmodelLabel = QLabel("combined model input:")
       self.combmodelinputline=QLineEdit()
       self.combmodelinputline.setPlaceholderText('e.g. phabs*po + ga')

       self.DIYmodelLabel = QLabel("DIY model input:")
       self.DIYmodelinputline=QLineEdit()
       self.DIYmodelinputline.setPlaceholderText('e.g. Mymodelname')


       combogridlayout.addWidget(self.fitmodelCombo,1,0)
       combogridlayout.addWidget(self.combmodelLabel,1,1)
       combogridlayout.addWidget(self.combmodelinputline,1,2)
       combogridlayout.addWidget(self.DIYmodelLabel,2,1)
       combogridlayout.addWidget(self.DIYmodelinputline,2,2)
       self.combogridGroupBox.setLayout(combogridlayout)
       layout.addWidget(self.combogridGroupBox)

       # radiobutton fitmethod  box
       self.gridGroupBox =  QGroupBox("fitting method")  
       gridlayout = QGridLayout()
       self.rb_chisq = QRadioButton('chi square',  self) 
       self.rb_chisq.toggled.connect(lambda: self.setfitmethod(self.rb_chisq))
       self.rb_chisq.toggle()


       self.rb_lstat = QRadioButton('lstat',  self)
       self.rb_lstat.toggled.connect(lambda: self.setfitmethod(self.rb_lstat))


       self.rb_Cstat = QRadioButton('Cstat',  self)
       self.rb_Cstat.toggled.connect(lambda: self.setfitmethod(self.rb_Cstat))

       self.rb_pstat = QRadioButton('pstat',  self)
       self.rb_pstat.toggled.connect(lambda: self.setfitmethod(self.rb_pstat))


       gridlayout.addWidget(self.rb_chisq,1,0)
       gridlayout.addWidget(self.rb_lstat,1,1)
       gridlayout.addWidget(self.rb_Cstat,1,2)
       gridlayout.addWidget(self.rb_pstat,1,3)
       gridlayout.setColumnStretch(1, 1)
       gridlayout.setSpacing(5)
        
       self.gridGroupBox.setLayout(gridlayout)
       layout.addWidget(self.gridGroupBox)


       #para set box

       self.gridGroupBox2 =  QGroupBox("parameters setting")
       gridlayout2 = QGridLayout()

       self.paralistLabel = QLabel("parameter list")
       self.froze_Label = QLabel("frozen")
       self.initialvalue_Label = QLabel("initial value")
       self.delta_Label = QLabel("delta")
       self.softmin_Label = QLabel("softmin")
       self.softmax_Label = QLabel("softmax")
       self.hardmin_Label = QLabel("hardmin")
       self.hardmax_Label = QLabel("hardmax")

       gridlayout2.addWidget(self.paralistLabel,1,0)
       gridlayout2.addWidget(self.froze_Label,1,1)
       gridlayout2.addWidget(self.initialvalue_Label,1,2)
       gridlayout2.addWidget(self.delta_Label,1,3)
       gridlayout2.addWidget(self.softmin_Label,1,4)
       gridlayout2.addWidget(self.softmax_Label,1,5)
       gridlayout2.addWidget(self.hardmin_Label,1,6)
       gridlayout2.addWidget(self.hardmax_Label,1,7)




       #para0
       self.para0Label = QLabel("1st para:")
       self.checkBox_para0 = QCheckBox(self.gridGroupBox2)
       self.para0_initialvalue_inputline=QLineEdit()
       self.para0_initialvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para0_delta_inputline=QLineEdit()
       self.para0_delta_inputline.setPlaceholderText('e.g. 0.01')
       self.para0_softminvalue_inputline=QLineEdit()
       self.para0_softminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para0_softmaxvalue_inputline=QLineEdit()
       self.para0_softmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para0_hardminvalue_inputline=QLineEdit()
       self.para0_hardminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para0_hardmaxvalue_inputline=QLineEdit()
       self.para0_hardmaxvalue_inputline.setPlaceholderText('e.g. 0.01')


       gridlayout2.addWidget(self.para0Label,2,0)
       gridlayout2.addWidget(self.checkBox_para0,2,1)
       gridlayout2.addWidget(self.para0_initialvalue_inputline,2,2)
       gridlayout2.addWidget(self.para0_delta_inputline,2,3)
       gridlayout2.addWidget(self.para0_softminvalue_inputline,2,4)
       gridlayout2.addWidget(self.para0_softmaxvalue_inputline,2,5)
       gridlayout2.addWidget(self.para0_hardminvalue_inputline,2,6)
       gridlayout2.addWidget(self.para0_hardmaxvalue_inputline,2,7)



       #para1
       self.para1Label = QLabel("2nd para:")
       self.checkBox_para1 = QCheckBox(self.gridGroupBox2)
       self.para1_initialvalue_inputline=QLineEdit()
       self.para1_initialvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para1_delta_inputline=QLineEdit()                     
       self.para1_delta_inputline.setPlaceholderText('e.g. 0.01')
       self.para1_softminvalue_inputline=QLineEdit()
       self.para1_softminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para1_softmaxvalue_inputline=QLineEdit()
       self.para1_softmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para1_hardminvalue_inputline=QLineEdit()
       self.para1_hardminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para1_hardmaxvalue_inputline=QLineEdit()
       self.para1_hardmaxvalue_inputline.setPlaceholderText('e.g. 0.01')


       gridlayout2.addWidget(self.para1Label,3,0)
       gridlayout2.addWidget(self.checkBox_para1,3,1)
       gridlayout2.addWidget(self.para1_initialvalue_inputline,3,2)
       gridlayout2.addWidget(self.para1_delta_inputline,3,3)
       gridlayout2.addWidget(self.para1_softminvalue_inputline,3,4)
       gridlayout2.addWidget(self.para1_softmaxvalue_inputline,3,5)
       gridlayout2.addWidget(self.para1_hardminvalue_inputline,3,6)
       gridlayout2.addWidget(self.para1_hardmaxvalue_inputline,3,7)



       #para2
       self.para2Label = QLabel("3rd para:")
       self.checkBox_para2 = QCheckBox(self.gridGroupBox2)
       self.para2_initialvalue_inputline=QLineEdit()
       self.para2_initialvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para2_delta_inputline=QLineEdit()
       self.para2_delta_inputline.setPlaceholderText('e.g. 0.01')
       self.para2_softminvalue_inputline=QLineEdit()
       self.para2_softminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para2_softmaxvalue_inputline=QLineEdit()
       self.para2_softmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para2_hardminvalue_inputline=QLineEdit()
       self.para2_hardminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para2_hardmaxvalue_inputline=QLineEdit()
       self.para2_hardmaxvalue_inputline.setPlaceholderText('e.g. 0.01')


       gridlayout2.addWidget(self.para2Label,4,0)
       gridlayout2.addWidget(self.checkBox_para2,4,1)
       gridlayout2.addWidget(self.para2_initialvalue_inputline,4,2)
       gridlayout2.addWidget(self.para2_delta_inputline,4,3)
       gridlayout2.addWidget(self.para2_softminvalue_inputline,4,4)
       gridlayout2.addWidget(self.para2_softmaxvalue_inputline,4,5)
       gridlayout2.addWidget(self.para2_hardminvalue_inputline,4,6)
       gridlayout2.addWidget(self.para2_hardmaxvalue_inputline,4,7)



       #para3
       self.para3Label = QLabel("4th para:")
       self.checkBox_para3 = QCheckBox(self.gridGroupBox2)
       self.para3_initialvalue_inputline=QLineEdit()
       self.para3_initialvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para3_delta_inputline=QLineEdit()
       self.para3_delta_inputline.setPlaceholderText('e.g. 0.01')
       self.para3_softminvalue_inputline=QLineEdit()
       self.para3_softminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para3_softmaxvalue_inputline=QLineEdit()
       self.para3_softmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para3_hardminvalue_inputline=QLineEdit()
       self.para3_hardminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para3_hardmaxvalue_inputline=QLineEdit()
       self.para3_hardmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
                                                                         
                                                                         
       gridlayout2.addWidget(self.para3Label,5,0)
       gridlayout2.addWidget(self.checkBox_para3,5,1)
       gridlayout2.addWidget(self.para3_initialvalue_inputline,5,2)
       gridlayout2.addWidget(self.para3_delta_inputline,5,3)
       gridlayout2.addWidget(self.para3_softminvalue_inputline,5,4)
       gridlayout2.addWidget(self.para3_softmaxvalue_inputline,5,5)
       gridlayout2.addWidget(self.para3_hardminvalue_inputline,5,6)
       gridlayout2.addWidget(self.para3_hardmaxvalue_inputline,5,7)



       #para4
       self.para4Label = QLabel("5th para:")
       self.checkBox_para4 = QCheckBox(self.gridGroupBox2)
       self.para4_initialvalue_inputline=QLineEdit()
       self.para4_initialvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para4_delta_inputline=QLineEdit()
       self.para4_delta_inputline.setPlaceholderText('e.g. 0.01')
       self.para4_softminvalue_inputline=QLineEdit()
       self.para4_softminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para4_softmaxvalue_inputline=QLineEdit()
       self.para4_softmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para4_hardminvalue_inputline=QLineEdit()
       self.para4_hardminvalue_inputline.setPlaceholderText('e.g. 0.01')
       self.para4_hardmaxvalue_inputline=QLineEdit()
       self.para4_hardmaxvalue_inputline.setPlaceholderText('e.g. 0.01')
                                                                         
                                                                         
       gridlayout2.addWidget(self.para4Label,6,0)
       gridlayout2.addWidget(self.checkBox_para4,6,1)
       gridlayout2.addWidget(self.para4_initialvalue_inputline,6,2)
       gridlayout2.addWidget(self.para4_delta_inputline,6,3)
       gridlayout2.addWidget(self.para4_softminvalue_inputline,6,4)
       gridlayout2.addWidget(self.para4_softmaxvalue_inputline,6,5)
       gridlayout2.addWidget(self.para4_hardminvalue_inputline,6,6)
       gridlayout2.addWidget(self.para4_hardmaxvalue_inputline,6,7)


       gridlayout2.setColumnStretch(1, 1)
       gridlayout2.setSpacing(5)

       self.gridGroupBox2.setLayout(gridlayout2)
       layout.addWidget(self.gridGroupBox2)



       #Plot box
       self.gridGroupBox3 =  QGroupBox("Plot setting")
       gridlayout3 = QGridLayout()
       self.ctrvsELabel = QLabel("data")
       self.checkBox_ctrvsE = QCheckBox(self.gridGroupBox3)
       self.residLabel = QLabel("delchi")
       self.checkBox_resid = QCheckBox(self.gridGroupBox3)
       self.modelLabel = QLabel("model")
       self.checkBox_model = QCheckBox(self.gridGroupBox3)
       self.emodelLabel = QLabel("emodel")
       self.checkBox_emodel = QCheckBox(self.gridGroupBox3)
       self.eemodelLabel = QLabel("eemodel")
       self.checkBox_eemodel = QCheckBox(self.gridGroupBox3)
       self.BGLabel = QLabel("BG shape")
       self.checkBox_BG = QCheckBox(self.gridGroupBox3)

       gridlayout3.addWidget(self.ctrvsELabel,1,0)
       gridlayout3.addWidget(self.checkBox_ctrvsE,1,1)
       gridlayout3.addWidget(self.residLabel ,1,2)
       gridlayout3.addWidget(self.checkBox_resid,1,3)
       gridlayout3.addWidget(self.modelLabel ,1,4)
       gridlayout3.addWidget(self.checkBox_model,1,5)
       gridlayout3.addWidget(self.emodelLabel ,1,6)
       gridlayout3.addWidget(self.checkBox_emodel,1,7)
       gridlayout3.addWidget(self.eemodelLabel ,1,8)
       gridlayout3.addWidget(self.checkBox_eemodel,1,9)
       gridlayout3.addWidget(self.BGLabel ,1,10)
       gridlayout3.addWidget(self.checkBox_BG,1,11)

       self.gridGroupBox3.setLayout(gridlayout3)
       layout.addWidget(self.gridGroupBox3)


       # button    
       self.fitBox=QGroupBox("Fit selections")
       fitgridlayout = QGridLayout()

       self.NiterLabel = QLabel("iteration times input:")
       self.Niterinputline=QLineEdit()
       self.Niterinputline.setPlaceholderText('200')
 

       self.fitnetEdeposLabel = QLabel("use netEdepos")
       self.fitnetEdeposCheckbox = QCheckBox(self.fitBox)
   

       self.fitfullEdeposLabel = QLabel("use fullEdepos and BG")
       self.fitfullEdeposCheckbox = QCheckBox(self.fitBox)

       self.btn_startfit = QPushButton()
       self.btn_startfit.setText("start fit")                                   
       self.btn_startfit.clicked.connect(self.startfitEdepos)


       fitgridlayout.addWidget(self.NiterLabel,1,0)
       fitgridlayout.addWidget(self.Niterinputline,1,1)
       fitgridlayout.addWidget(self.fitnetEdeposLabel,1,2)
       fitgridlayout.addWidget(self.fitnetEdeposCheckbox,1,3)
       fitgridlayout.addWidget(self.fitfullEdeposLabel,1,4)
       fitgridlayout.addWidget(self.fitfullEdeposCheckbox,1,5)
       fitgridlayout.addWidget(self.btn_startfit,1,6)
       self.fitBox.setLayout(fitgridlayout) 
       layout.addWidget(self.fitBox)

       #self.btn_fitnetEdepos.clicked.connect(self.startfitEdepos) 


       #button  fitoutput  
       #self.resBox=QGroupBox()
       #resgridlayout = QGridLayout()
       '''
       self.btn_batchfit = QPushButton()
       self.btn_batchfit.setText("batch fit")
       self.btn_batchfit.clicked.connect(self.startbatchfit)

       self.btn_save = QPushButton()
       self.btn_save.setText("save fit results")
       self.btn_save.clicked.connect(self.savefitres)
       '''
       #resgridlayout.addWidget(self.btn_batchfit,1,0)
       #resgridlayout.addWidget(self.btn_save,1,1)
       #self.resBox.setLayout(resgridlayout)

       #layout.addWidget(self.resBox)
       #self.setBtnStatus()
       self.setLayout(layout)



   def plotEdepos(self):
       print('connect success! ')

   def plotmultiEdepos(self):
       self.mplCanvas.clearplot()
       for idetec in glv.detID_selected:
         #if Edepos of this detec
           print('idetec'+str(idetec))
           if glv.selectsource_Edepos[idetec]==0: 
              self.mplCanvas.plotwitherr(glv.lEbin_mid[idetec], glv.netEdepos[idetec], yerr=glv.netEdepos_err[idetec], fmt='.')
           else:
              print('glv.corx_selectsource_fitEdepos[idetec]' +str(glv.corx_selectsource_fitEdepos[idetec]))
              index_e=getindex_GECAM.getindex_le(glv.corx_selectsource_fitEdepos[idetec],idetec)
              ebin_slice=glv.lEbin_mid[idetec][index_e[0]: index_e[1]+1]
              netE_slice=glv.netEdepos[idetec][index_e[0]: index_e[1]+1]
              Eerr_slice=glv.netEdepos_err[idetec][index_e[0]: index_e[1]+1]
              self.mplCanvas.plotwitherr(ebin_slice, netE_slice, Eerr_slice,fmt='.')


       self.mplCanvas.setylog()
       self.mplCanvas.xlabel(LabelString="Edepos/eV")
       self.mplCanvas.ylabel(LabelString="counts/s/eV")
       self.mplCanvas.UpdatePlot()#必须刷新才能显示     


   def setfitmethod(self, btn):
       glv.fitmethod = glv.fitmethodstr.index(btn.text())

   def setfitmodel(self,strfitmodel):
       glv.fitmodel  = glv.fitmodelstr.index(strfitmodel)


   def getRSPdir(self):
       thetaphi_A=strTransforCLI.strTran2list_float(self.locinputline_theta.text())
       thetaphi_B=strTransforCLI.strTran2list_float(self.locinputline_phi.text())
       return thetaphi_A, thetaphi_B 

   def startfitEdeposgui(self):
       if not self.isVisible():
            self.show()


   def setfitpara(self):
       glv.combmodelstr='e.g. phabs*po + ga'
       glv.DIYmodelstr='e.g. Mymodelname'
       for idetec in glv.detID_selected:
           corx=glv.corx_selectsource_fitEdepos[idetec]
           lindex=getindex_GECAM.getindex_le(corx,glv.ebound)
           print('**********in set para**********')
           print(idetec)
           print(corx)
           print(lindex)
           glv.rangeindex_selected[idetec]=lindex  
           print(glv.rangeindex_selected)

       #fitmodel
       strfitmodel=self.fitmodelCombo.currentText()                
       self.setfitmodel(strfitmodel)
       if strfitmodel == 'None':
          if self.combmodelinputline.text()!= '':
             glv.combmodelstr=self.combmodelinputline.text()
          elif self.DIYmodelinputline.text()!= '':
             glv.DIYmodelstr=self.DIYmodelinputline.text()
      

       
       #fitmethod
       #toggle connect fitmethod with set
   
       #parameters setting

       #judge if para is input from GUI
       inputvalue=lambda x,y: float(x) if x !=''else y 

       if self.checkBox_para0.checkState() == 2:
          glv.paralist[0][0]= 'frozen'  
       else:
          glv.paralist[0][1]=inputvalue(self.para0_initialvalue_inputline.text(),glv.paralist[0][1])
          glv.paralist[0][2]=inputvalue(self.para0_delta_inputline.text(), glv.paralist[0][2])
          glv.paralist[0][3]=inputvalue(self.para0_softminvalue_inputline.text(),glv.paralist[0][3])
          glv.paralist[0][4]=inputvalue(self.para0_softmaxvalue_inputline.text(),glv.paralist[0][4])
          glv.paralist[0][5]=inputvalue(self.para0_hardminvalue_inputline.text(),glv.paralist[0][5])
          glv.paralist[0][6]=inputvalue(self.para0_hardmaxvalue_inputline.text(),glv.paralist[0][6])
        

       if self.checkBox_para1.checkState() == 2:
          glv.paralist[1][0]= 'frozen'  
       else:
          glv.paralist[1][1]=inputvalue(self.para1_initialvalue_inputline.text(),glv.paralist[1][1])
          glv.paralist[1][2]=inputvalue(self.para1_delta_inputline.text(),glv.paralist[1][2])
          glv.paralist[1][3]=inputvalue(self.para1_softminvalue_inputline.text(),glv.paralist[1][3])
          glv.paralist[1][4]=inputvalue(self.para1_softmaxvalue_inputline.text(),glv.paralist[1][4])
          glv.paralist[1][5]=inputvalue(self.para1_hardminvalue_inputline.text(),glv.paralist[1][5])
          glv.paralist[1][6]=inputvalue(self.para1_hardmaxvalue_inputline.text(),glv.paralist[1][6])


       if self.checkBox_para2.checkState() == 2:
          glv.paralist[2][0]= 'frozen'  
       else:
          glv.paralist[2][1]=inputvalue(self.para2_initialvalue_inputline.text(),glv.paralist[2][1])
          glv.paralist[2][2]=inputvalue(self.para2_delta_inputline.text(),glv.paralist[2][2])
          glv.paralist[2][3]=inputvalue(self.para2_softminvalue_inputline.text(),glv.paralist[2][3])
          glv.paralist[2][4]=inputvalue(self.para2_softmaxvalue_inputline.text(),glv.paralist[2][4])
          glv.paralist[2][5]=inputvalue(self.para2_hardminvalue_inputline.text(),glv.paralist[2][5])
          glv.paralist[2][6]=inputvalue(self.para2_hardmaxvalue_inputline.text(),glv.paralist[2][6])


       if self.checkBox_para3.checkState() == 2:
          glv.paralist[3][0]= 'frozen'  
       else:
          glv.paralist[3][1]=inputvalue(self.para3_initialvalue_inputline.text(),glv.paralist[3][1])
          glv.paralist[3][2]=inputvalue(self.para3_delta_inputline.text(),glv.paralist[3][2])
          glv.paralist[3][3]=inputvalue(self.para3_softminvalue_inputline.text(),glv.paralist[3][3])
          glv.paralist[3][4]=inputvalue(self.para3_softmaxvalue_inputline.text(),glv.paralist[3][4])
          glv.paralist[3][5]=inputvalue(self.para3_hardminvalue_inputline.text(),glv.paralist[3][5])
          glv.paralist[3][6]=inputvalue(self.para3_hardmaxvalue_inputline.text(),glv.paralist[3][6])



       if self.checkBox_para4.checkState() == 2:
          glv.paralist[4][0]= 'frozen'  
       else:
          glv.paralist[4][1]=inputvalue(self.para4_initialvalue_inputline.text(),glv.paralist[4][1])
          glv.paralist[4][2]=inputvalue(self.para4_delta_inputline.text(),glv.paralist[4][2])
          glv.paralist[4][3]=inputvalue(self.para4_softminvalue_inputline.text(),glv.paralist[4][3])
          glv.paralist[4][4]=inputvalue(self.para4_softmaxvalue_inputline.text(),glv.paralist[4][4])
          glv.paralist[4][5]=inputvalue(self.para4_hardminvalue_inputline.text(),glv.paralist[4][5])
          glv.paralist[4][6]=inputvalue(self.para4_hardmaxvalue_inputline.text(),glv.paralist[4][6])





       #plot setting
       glv.plotselections=[] #clear the old selection
       if self.checkBox_ctrvsE.checkState() ==2: 
          glv.plotselections.append("data")
       if self.checkBox_resid.checkState() ==2:
          glv.plotselections.append("delchi")
       if self.checkBox_model.checkState() ==2:
          glv.plotselections.append("model")
       if self.checkBox_emodel.checkState() ==2:
          glv.plotselections.append("emodel") 
       if self.checkBox_eemodel.checkState() ==2:
          glv.plotselections.append("eemodel")
       if self.checkBox_BG.checkState() ==2:
          glv.plotselections.append("background")

       #iteration times
       if self.Niterinputline.text()!='':  
          glv.Niter=int(self.Niterinputline.text())     
       else:
          glv.Niter=200   
       #fit with net or full spectrum
       if self.fitnetEdeposCheckbox.checkState()==2:
          glv.type_specfit='net'
       if self.fitfullEdeposCheckbox.checkState()==2:
          glv.type_specfit='full'

   def startfitEdepos(self):
       #if 1:
       try:
           rspfiledirlist=[]
           thetaphi_A, thetaphi_B=self.getRSPdir()
           for detID in glv.detID_selected: 
               rspfile=''
               if detID <50:
                  rspfile=glv.rspoutputdir + genRSPname_GECAM.genRSPname(detID, thetaphi_A[0], thetaphi_A[1])
               else:
                  rspfile=glv.rspoutputdir + genRSPname_GECAM.genRSPname(detID, thetaiphi_B[0], thetaphi_B[1])
               if os.path.exists(rspfile):
                   rspfiledirlist.append(rspfile)
               else:
                   self.GUI_message.show_message_warning("warning", "PLEASE CHECK IF RSP FILE EXISTS!")
                   return

           self.setfitpara()
           glv.restype= 'single'
           beginTime = time.time()
           fitres_Edepos_dict = fitspec_xspec_GUI_GECAM.fitxspec(rspfiledirlist)
           self.signal_fitEdepos_to_status_box.emit('Edepos fit results:' +str(fitres_Edepos_dict))
           self.signal_fitEdepos_to_status_box.emit('Edepos fit costs(s):' + str(time.time()-beginTime))
       except:
           self.GUI_message.show_message_warning("warning","PLEASE CHECK INPUT PARAMETER! YOU MAY MISS SOMETHING! OR the channel number of data is not consistent with that of RSP(CALDB v0.3) currently!")
