# -*- coding: utf-8 -*-
"""
Created on Fri Aug 24 11:58:46 2018

@author: songxy
"""

import sys, os
import time

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *

import matplotlib
matplotlib.use('TkAgg')


from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.backends.backend_qt5 import NavigationToolbar2QT as NavigationToolbar
from matplotlib.figure import Figure
from .GUI_plotbase_GECAM import MPLbase 
from .GUI_plotbase_GECAM import MPLwrapper 
from .GUI_mainwidget_GECAM import GECAM_Widget
from .GUI_messagebox_GECAM import GUI_message

sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from tools import *
from fitEdepos import *
from fitBG import fitBG_GECAM, genprojection_GECAM, genfits_forfitBG_GECAM
from .GUI_messagebox_GECAM import GUI_message



class GECAM_MainWindow(QMainWindow):
    signal_main_status_box = pyqtSignal(str)

    def __init__(self,parent=None):
        super().__init__()
        #super(MainWidget,self).__init__(parent)
        self.resize(990, 990) 
        self.centralWidget= GECAM_Widget()
        self.setCentralWidget(self.centralWidget)
        self.create_menubar()


        self.centralWidget.signal_status_box.emit('Welcome to GECAM GRB analysis tools, today is '+str(time.strftime('%Y.%m.%d', time.localtime(time.time()))))
        self.signal_main_status_box.connect(self.signal_to_status_box)
        self.GUI_message = GUI_message(self)

    def signal_to_status_box(self, str_status):
        self.centralWidget.signal_status_box.emit(str_status)
        return

         

    def create_menubar(self):
        menubar = self.menuBar()

        '''
        fit selections
        '''
        BGoperationMenu = menubar.addMenu("BG fit selections")

        fitmodelsMenu = QMenu("BGfitmodels",self)

        selmodelAct0 = QAction("poly0",self)
        selmodelAct1 = QAction("poly1",self)
        selmodelAct2 = QAction("poly2",self)
        selmodelAct3 = QAction("poly3",self)


        selmodelAct0.triggered.connect(lambda:self.fitBGpoly(0)) 
        selmodelAct1.triggered.connect(lambda:self.fitBGpoly(1)) 
        selmodelAct2.triggered.connect(lambda:self.fitBGpoly(2)) 
        selmodelAct3.triggered.connect(lambda:self.fitBGpoly(3)) 


        fitmodelsMenu.addAction(selmodelAct0)
        fitmodelsMenu.addAction(selmodelAct1)
        fitmodelsMenu.addAction(selmodelAct2)
        fitmodelsMenu.addAction(selmodelAct3)


        BGoperationMenu.addMenu(fitmodelsMenu)

        '''
        BG fitresults display
        '''
        BGfitresMenu = menubar.addMenu("BG fitresult display")
        chisqndof = QAction("chisq /n.d.o.f",self)
        chisqndof.triggered.connect(self.plotchisqndof_current)
        BGfitresMenu.addAction(chisqndof)
     
        '''
         select signal region 
        '''
        selsigMenu = menubar.addMenu("select signal source")
        selsig = QAction("select signal region",self)
        plot_comparison = QAction("comparison on Edepos",self)
        plot_projection = QAction("projection on Edepos and generate net/full/BG.fits",self)

        
        selsig.triggered.connect(self.centralWidget.sROI_xycoor)
        plot_comparison.triggered.connect(self.plotcomparison_ROI)
        plot_projection.triggered.connect(self.plotprojection_ROI)


        selsigMenu.addAction(selsig) 
        selsigMenu.addAction(plot_comparison) 
        selsigMenu.addAction(plot_projection) 

          


        '''
        BG fit apply all
        '''
        
        applyallMenu = menubar.addMenu("BG-fit Apply All or restart")
        applyall = QAction("apply same BG-fit procedure to all",self)
        chisqndof_batch = QAction("chisq /n.d.o.f of all",self)
        #selectROI_batch =QAction("apply same ROI to all", self)
        #genfits =QAction("generate .fits file for Xspec ",self)
        erase = QAction("erase and restart BG fit",self)

        applyall.triggered.connect(self.centralWidget.BGfit_applyall)
        chisqndof_batch.triggered.connect(self.plotchisqndof_batch)
        #selectROI_batch.triggered.connect(self.gennetEprojection_batch)
        #genfits.triggered.connect(self.centralWidget.genfits_batch)
        erase.triggered.connect(self.centralWidget.erase_batch) 



        applyallMenu.addAction(applyall) 
        applyallMenu.addAction(chisqndof_batch)
        #applyallMenu.addAction(selectROI_batch)
        #applyallMenu.addAction(genfits)
        #applyallMenu.addAction(erase) 


    def fitBGpoly(self, polyorder):
        #print('before sigl fit3'+str(len(glv.goodness_fit[0])))


        detID=glv.detID_currentselected
        glv.bgpolyorder[detID]=int(polyorder)
        #print('glv.bgpolyorder[detID]:'+ str(glv.bgpolyorder[detID]))

        #BG fit results display values assignment
        BGfit=fitBG_GECAM.fitBG()
        try:
           BGfit.setfitBGpara(glv.bgpolyorder[detID],glv.corx_BG[detID],glv.ltbins[0],
                           glv.tbinwidth, glv.ebins, glv.ebin_edges, glv.lte[detID])
           bgpolyorder, bgpoly, bgpcov, goodness, bgtime, bgcounts, bgcounts_err, bgestinum_e, bgesti_t =BGfit.fitBG_perEbin()
           #20200403bgtime, bgcounts, bgcounts_err, bgesti=fitBG(detID, int(polyorder))
           glv.detID_BGfitted.append(detID)
           glv.bgpolyorder[detID]=bgpolyorder
           glv.bgpoly[detID]=bgpoly
           glv.bgpcov[detID]=bgpcov
           glv.goodness_fit[detID]=goodness
           glv.bgtime[detID]=bgtime
           glv.bgesti[detID]=bgesti_t



           #print('-------------------goodness' +str(goodness))
           bgscr    =bgcounts/glv.tbinwidth
           bgscr_err=bgcounts_err/glv.tbinwidth
           bgesti   =bgesti_t/glv.tbinwidth
           #lc display values assignment
           het2D, fulltime=shape2Dhist(glv.lte[detID],glv.ltbins[0], glv.tbinwidth, glv.ebin_edges)
           at=np.sum(het2D, axis=0)
           scountrate, scountrate_err=gethist_countrate_perT(at, glv.tbinwidth)

           #display
           #print('glv.bgpolyorder[detID]:'+ str(glv.bgpolyorder[detID]))

           self.centralWidget.mplCanvas.clearplot()
           self.centralWidget.mplCanvas.plotwitherr(fulltime, scountrate, yerr=scountrate_err, fmt='.')
           self.centralWidget.mplCanvas.plotwitherr(bgtime,bgscr,yerr=bgscr_err,fmt='g.')
           self.centralWidget.mplCanvas.plot(bgtime,bgesti)
           self.centralWidget.mplCanvas.fixylim()
           self.centralWidget.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][0]+glv.corx_BG[detID][1])/2.0)<(glv.corx_BG[detID][1]-glv.corx_BG[detID][0])/2.0), facecolor='green',  alpha=0.5)
           self.centralWidget.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][2]+glv.corx_BG[detID][3])/2.0)<(glv.corx_BG[detID][3]-glv.corx_BG[detID][2])/2.0), facecolor='green',  alpha=0.5)

           self.centralWidget.mplCanvas.xlabel("time(s)")
           self.centralWidget.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
           self.centralWidget.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')

           #self.centralWidget.mplCanvas.setylog()
           self.centralWidget.mplCanvas.UpdatePlot()#必须刷新才能显示
 
           #fill current selected source 
           glv.flag_plotsource=0
           glv.flag_setylog=1
           glv.plotsource_currentselected=[]#clear the old one
           glv.plotsource_currentselected.append(fulltime)
           glv.plotsource_currentselected.append(scountrate)
           glv.plotsource_currentselected.append(scountrate_err)
           glv.plotsource_currentselected.append(bgtime)
           glv.plotsource_currentselected.append(bgscr)
           glv.plotsource_currentselected.append(bgscr_err)
           glv.plotsource_currentselected.append(bgtime)
           glv.plotsource_currentselected.append(bgesti)
        except:
           self.GUI_message.show_message_warning("warning","please check if you have selected correct BG range!")
          




    def plotcomparison_ROI(self):
        try:
        #if 1:
           self.centralWidget.mplCanvas.clearplot()
           detID=glv.detID_currentselected
           corx_ROI=glv.corx_ROI[detID]
           corx_BG=glv.corx_BG[detID]
           deadtime=glv.deadtime
           lte=glv.lte
           #assign glv.timeinterval_ROI
           timeinterval_ROI=corx_ROI[1]- corx_ROI[0]
           glv.timeinterval_ROI= timeinterval_ROI
           Ebinwidth= glv.lEbin_width[detID]
           Ebinmid=glv.lEbin_mid[detID]
           #get BG fitted number in ROI
           genprojection=genprojection_GECAM.genProjection()
           genprojection.setpara([detID],
                             lte,
                             corx_ROI,
                             corx_BG,
                             glv.ltbins[0], glv.tbinwidth,
                             glv.ebins, glv.ebin_edges,
                             glv.bgpoly,
                             glv.bgpcov,
                             glv.bgpolyorder,
                             deadtime)
           netEcounts, \
           netEcounts_err,\
           nettime_interval,\
           fullEcounts,\
           fullEcounts_err,\
           fulltime_interval, \
           BGEcounts,BGEcounts_err, \
           BGtime_interval=genprojection.genEdepos_projection_single()

           genfits_forfitBG_GECAM.genfitsforfitBG([detID],
                           [netEcounts],
                           [netEcounts_err],
                           [nettime_interval],
                           [fullEcounts],
                           [fullEcounts_err],
                           [fulltime_interval],
                           [BGEcounts],
                           [BGEcounts_err],
                           [BGtime_interval],
                           glv.ebins,
                           glv.genfitsDir,
                           iTR=False)


           BGcountrate_ROI, BGcountrateerr_ROI= BGEcounts/BGtime_interval/Ebinwidth, BGEcounts_err/BGtime_interval/Ebinwidth
           fullcountrate_ROI, fullcountrateerr_ROI= fullEcounts/fulltime_interval/Ebinwidth, fullEcounts_err/fulltime_interval/Ebinwidth
           netcountrate_ROI, netcountrateerr_ROI= netEcounts/nettime_interval/Ebinwidth, netEcounts_err/nettime_interval/Ebinwidth
 

           #net
           glv.netEdepos[detID]     = netcountrate_ROI
           glv.netEdepos_err[detID] = netcountrateerr_ROI
           glv.nettime_interval[detID]=nettime_interval
           #full
           glv.fullEdepos[detID]     = fullcountrate_ROI
           glv.fullEdepos_err[detID] = fullcountrateerr_ROI
           glv.fulltime_interval[detID]=fulltime_interval
           #BG
           glv.BGEdepos[detID]     = BGcountrate_ROI
           glv.BGEdepos_err[detID] = BGcountrateerr_ROI
           glv.BGtime_interval[detID]=BGtime_interval




           #not count rate , count 
           glv.netEcounts[detID]= netEcounts
           glv.netEcounts_err[detID]= netEcounts_err

           glv.fullEcounts[detID]= fullEcounts
           glv.fullEcounts_err[detID]= fullEcounts_err

           glv.BGEcounts[detID]= BGEcounts
           glv.BGEcounts_err[detID]=BGEcounts_err

           '''
           print('***************find nan*************************************')
           print('detID' +str(detID))
           print('edepos' +str(edepos[0:19]))
           print('BGcounterr_ROI' +str(BGcounterr_ROI[0:19]))
           print('netEcounts_err' +str(glv.netEcounts_err[detID][0:19]))
           print('netEcounts' +str(glv.netEcounts[0][0:19]))
           '''
           #for i in range(70):
           #    print('edepos' +str(edepos[i]))
           #    print('BGcount' +str(BGcount_ROI[i]) +' +/- ' +str(BGcounterr_ROI[i]))
           #print('in ROI, total: ' +str(sum(edepos)))
           #print('in ROI, BG: ' +str(sum(BGcount_ROI)))



           #plot display
           self.centralWidget.mplCanvas.plotwitherr(Ebinmid, fullcountrate_ROI, fullcountrateerr_ROI, fmt='.')
           self.centralWidget.mplCanvas.plotwitherr(Ebinmid, BGcountrate_ROI, BGcountrateerr_ROI, fmt='.')
           self.centralWidget.mplCanvas.xlabel(LabelString="Edepos(KeV)")
           self.centralWidget.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
           self.centralWidget.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
           self.centralWidget.mplCanvas.setylog()
           self.centralWidget.mplCanvas.setxlog()
           self.centralWidget.mplCanvas.UpdatePlot()#必须刷新才能显示

           #plot source 
           glv.flag_plotsource=1
           glv.flag_setylog=1
           glv.plotsource_currentselected= []
           glv.plotsource_currentselected.append(Ebinmid)
           glv.plotsource_currentselected.append(fullcountrate_ROI)
           glv.plotsource_currentselected.append(fullcountrateerr_ROI)
           glv.plotsource_currentselected.append(BGcountrate_ROI)
           glv.plotsource_currentselected.append(BGcountrateerr_ROI)
        except:
            self.GUI_message.show_message_warning("warning", "please check if you have selected correct ROI range!")
           





   
    def plotprojection_ROI(self): 
        try:
           self.centralWidget.mplCanvas.clearplot() 
           detID=glv.detID_currentselected
           #print(len(glv.lEbin_mid))
           #print(glv.netEdepos[detID].shape)
           #print(glv.netEdepos_err[detID].shape)

           #self.centralWidget.mplCanvas.plotwitherr(np.array(glv.lEbin_mid[detID]), glv.netEdepos[detID], glv.netEdepos_err[detID], fmt='.')
           #print('signal total:' +str(np.sum(glv.netEcounts[detID])))
           #self.centralWidget.mplCanvas.plotwitherr(np.array(glv.lEbin_mid[detID]), glv.netEcounts[detID], glv.netEcounts_err[detID], fmt='.')
           self.centralWidget.mplCanvas.plotwitherr(np.array(glv.lEbin_mid[detID]), glv.netEdepos[detID], glv.netEdepos_err[detID], fmt='.')
           self.centralWidget.mplCanvas.xlabel(LabelString="Edepos(KeV)")
           self.centralWidget.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
           self.centralWidget.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')


           #MC test BG fitting
           #for mc comparison, MC in ROI
           #et2D,timedges=shape2Dhist(glv.lte[detID],glv.tbins ,glv.tbinwidth, glv.ebin_edges)

           #et2D_MCtruth,time_MCtruth =  shape2Dhist(glv.lte_s[detID],timedges ,glv.tbinwidth, glv.ebin_edges)
           #slice_MCtruth, aedepos_MCtruth, at_MCtruth=toggle_t2e(et2D_MCtruth, glv.corx_ROI[detID]) 
           #print('MC total in plot:' +str(np.sum(aedepos_MCtruth)))
           #timeinterval=glv.corx_ROI[detID][1]-glv.corx_ROI[detID][0]

           #Edepos, cr_perE, cr_perE_err=gethist_e(aedepos_MCtruth, timeinterval, detID)
           #aedepos, cr_perE, cr_perE_err=gethist_countrate_perE(aedepos_MCtruth, timeinterval ,detID)
           #self.centralWidget.mplCanvas.plotwitherr(np.array(glv.lEbin_mid[detID]),cr_perE, cr_perE_err,  fmt='.')
           #self.centralWidget.mplCanvas.plotwitherr(np.array(glv.lEbin_mid[detID]),aedepos_MCtruth, aedepos_MCtruth**0.5,  fmt='.')
           #end of MC
           
           #self.centralWidget.mplCanvas.title_MPL("counts/T vs time(s)")
           self.centralWidget.mplCanvas.setylog()
           self.centralWidget.mplCanvas.setxlog()
           self.centralWidget.mplCanvas.UpdatePlot()#必须刷新才能显示
           #fill plot source
           glv.flag_plotsource=2
           glv.flag_setylog=1
           glv.plotsource_currentselected=[]
           glv.plotsource_currentselected.append(np.array(glv.lEbin_mid[detID]))
           glv.plotsource_currentselected.append(glv.netEcounts[detID])
           glv.plotsource_currentselected.append(glv.netEcounts_err[detID])
        except:
            self.GUI_message.show_message_warning("warning", "please show comparison first!")
        
    def plotchisqndof_current(self):
        detID=glv.detID_currentselected
        #print('glv.lEbin_mid[detID]' +str(glv.lEbin_mid[detID]))
        plotchisq_ndof(glv.lEbin_mid[detID], glv.goodness_fit[detID])

    def plotchisqndof_batch(self):
        plotchisq_ndof_batch(10,10, glv.detID_selected, glv.lEbin_mid,glv.goodness_fit)

    def gennetEprojection_batch(self):
        gennetEtime=genEdepos_projection()
        self.signal_main_status_box.emit('generation on netE variables finished, cost' +str(gennetEtime) +' second!')
        
        
        

