# from data import glv

class MultiPlot:

    def __init__(self, data_x, data_y, error_y, file_path):
        self.data_x = []
        self.data_y = []
        self.error_y = []
        self.file_path = ''
        self.set_save_path(file_path)
        self.set_x_data(data_x)
        self.set_y_data(data_y)
        self.set_y_error(error_y)
        self.plot()

        return

    def set_x_data(self, data_x):
        self.data_x = data_x
        return

    def set_y_data(self, data_y):
        self.data_y = data_y
        return

    def set_y_error(self, error_y):
        self.error_y = error_y
        return

    def set_save_path(self, file_path):
        self.file_path = file_path
        return

    def plot(self):
        import matplotlib.pyplot as plt
        plt.style.use('bmh')
        fig, ax = plt.subplots(nrows=1, ncols=1, figsize=(1.95, 1.15),constrained_layout = True)
        #plt.subplots_adjust(top=0.95, bottom=0.05, right=0.98, left=0.02, hspace=0, wspace=0)
        ax.errorbar(self.data_x, self.data_y, self.error_y, fmt='.', alpha=0.8)
        if 'Edepos' in self.file_path:
            ax.set_yscale('log')
            ax.set_xscale('log')
        #plt.ylim((0.9*min(self.data_y), 1.2*max(self.data_y)))
        plt.savefig(self.file_path)
        plt.close('all')
