import os
import sys

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *

import matplotlib
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.backends.backend_qt5 import NavigationToolbar2QT as NavigationToolbar
from matplotlib.figure import Figure
import matplotlib.animation as animation

from astropy.io import fits
import numpy as np
import threading
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from tools import *
from fitEdepos import *
from fitBG import *
from .GUI_mainframe_GECAM import *
from .GUI_plotbase_GECAM import MPLbase
import matplotlib.pyplot as plt
from matplotlib.pyplot import figure
class multiMPLbase(MPLbase):
      def __init__(self):
          self.fig = Figure()
          self.axes = self.fig.add_axes()
          MPLbase.__init__(self)
          self.mpl_connect2=self.fig.canvas.mpl_connect('button_press_event', self.enter_axes)
          #self.mpl_connect3=self.fig.canvas.mpl_connect('button_press_event', GECAM_Widget.plotlc )



      def subplot(self, *args,**kwargs):
          return self.fig.add_subplot(*args,**kwargs)
          
      def enter_axes(self,event):
          if(event.inaxes.patch.get_facecolor()==(1.0, 1.0, 0.0, 1.0)):
             event.inaxes.patch.set_facecolor('white')
             if glv.detecsel_Edepos == 0: 
                glv.detID_selected.remove(glv.detIDstr.index(str(event.inaxes)))
             else:
                glv.detID_fitEdepos_selected.remove(glv.detIDstr.index(str(event.inaxes)))
          else:
             event.inaxes.patch.set_facecolor('yellow')
             glv.detID_currentselected=glv.detIDstr.index(str(event.inaxes))
             print('glv.detID_currentselected:' +str(glv.detID_currentselected))
             if glv.detecsel_Edepos == 0:
                glv.detID_selected.append(glv.detIDstr.index(str(event.inaxes)))
             else:
                glv.detID_fitEdepos_selected.append(glv.detIDstr.index(str(event.inaxes))) 
             #print(str(event.inaxes))
             #print(type(str(event.inaxes)))
             
          event.canvas.draw()
      def clfsubplot(self,*args,**kwargs):
          self.fig.clf()          
 
       
class multiMPLwrapper(QWidget):
      def __init__(self , parent =None):
        QWidget.__init__(self, parent)
        self.canvas = multiMPLbase()
        self.vbl = QVBoxLayout()
#        self.ntb = NavigationToolbar(self.canvas, parent)
#        self.vbl.addWidget(self.ntb)
        self.vbl.addWidget(self.canvas)
        self.setLayout(self.vbl)
#if __name__=='__main__':
#       app = QApplication(sys.argv)
#       gui = multiMPLwrapper()
#       gui.show()
#       sys.exit(app.exec_())

