"""
Created on Sat Dec 21 15:13:47 2019

@author: Dr. Xinying Song 
"""
import numpy as np
class glvclass:
  def __init__(self): 
      self.filedir_front='none' #file directory front, to launch in other dir
      self.taskID=''
      self.genfitsDir=''
      self.rspoutputdir=''
      self.attfiles=''
      self.datatype        ='DATA' #mc file or data file
      self.satLabel        ='' # datafile for satelite A or B or j
      self.lfilename       =[] # filenamelist, A and/or B dataname
      self.lte             =[] #array-like [t,e] for every detec 
      self.lstarttime       =[] # start time for each satellite, len=2
      self.lendtime         =[]# end time for each satellite, len=2
      self.trigtimeMET      =''
      self.trigtimeUTC      =''
      self.ltimeinterval    =[] #time interval will be the denominator for count rate for Edepos, # the initial value is endtime - starttime, unit is second, len=2
      self.timeinterval     =0
      self.locationJ2000_onSat=[0,0]
      self.Ndetec_tot      =int(25) # number of detector in each satellite * high/low gain
      self.tbinwidth       =1.0  # default bin width 1s 
      self.tbinwidth_DTcor =np.array([1.0])  #  the DT corrected bin width list 
      self.ltbins           = [] #tbins for each satellite, len =2
      self.ltime           =[]  #time x-axis 
      self.lcounts_perT    =[]  #time counts for all detectors 
      self.lcounts_perT_err=[]  #time count err for all detectors
######deadtime corrected################################  
      #self.deadtime=0.003 #
      self.deadtime=0.00 #tentatively
######for MC test BG fitting############################
      self.lte_s=[]
      self.ebins              =256 #data and good MC
      self.ebin_edges        = np.arange(-0.5,self.ebins+0.5, 1.0)
      self.lEbin_width        =[]# list len=18, with element is array(shape 256) 
      self.lEbin_mid          =[] # 18* np.array(shape of 256)
      self.ebound=np.array([0])
######the angle of detec in sat [[theta],[phi]]###############
      self.list_detecAngle_inSat=[[0.0, 40.0, 40.0, 40.0, 40.0,
                                    40.0, 40.0, 73.5, 73.5, 73.5,
                                    73.5, 73.5, 73.5, 73.5, 73.5,
                                    73.5, 73.5, 90.0, 90.0, 90.0,
                                    90.0, 90.0, 90.0, 90.0, 90.0],
                                   [0.0, 332.17, 278.67, 225.17, 152.17,
                                    98.67, 45.17, 350.5, 314.5, 278.5,
                                    242.5, 206.5, 170.5, 134.5, 98.5,
                                    62.5, 26.5, 0.0, 305.0, 270.0,
                                    215.0, 180.0, 125.0, 90.0, 35.0]]

#for muti GUI to main GUI
      self.plotLCflag=0
      self.plotEdeposflag=0


#########plot sum flag#############################
      self.flag_plotsum=0
      
#########toggle variable###########################
      self.detID_currentselected=0  
      self.detID_selected=[]  

      self.flag_currentinmainframe='lightcurve' 
      
      self.toggle_flag=self.Ndetec_tot*4*[0]
      self.time_binned  =[]
      self.et2D_currentselected  =[]
      self.time_currentselected  =[]
      self.edepos_currentselected=[]





      self.selectsource_lc=self.Ndetec_tot*4*[0] # label which detector has been selected lc source
      self.corx_selectsource_lc=self.Ndetec_tot*4*[[]] # the selected lc range for all detectors
      self.selectsource_Edepos=self.Ndetec_tot*4*[0] # label which detector has been selected lc source
      self.corx_selectsource_Edepos=self.Ndetec_tot*4*[[]] # the selected lc range for all detectors

      #slice for all detectors
      self.slice_et2D=self.Ndetec_tot*4*[np.array([0])]
      self.slice_aedepos=self.Ndetec_tot*4*[np.array([0])]
      self.slice_at=self.Ndetec_tot*4*[np.array([0])]

      #bg range selection
      self.count_tmp=int(0)
      self.selectBGrange=self.Ndetec_tot*4*[0]
      self.corx_BG      =self.Ndetec_tot*4*[[]]
      #self.cory_BG            =[]
      

      #ROI range selection
      self.selectROIrange=self.Ndetec_tot*4*[0]
      self.corx_ROI      =self.Ndetec_tot*4*[[]]
      self.timeinterval_ROI=0.0
      self.timeinterval_ROI_cor=self.Ndetec_tot*4*[0.0] #should be a 18 length list

      #current plotsource
      self.flag_plotsource=0 #0, 1, 2... denote different plotsource, which corresponds to different plot codes
      self.plotsource_currentselected=[]

      #BG fit
  
      self.detID_BGfitted=[]
      self.bgpolyorder=self.Ndetec_tot*4*[3]
      self.BG_time=np.array([0])
      self.BG_time_cor=np.array([0])
      self.BG_exp=np.array([0])
      self.bgpoly=self.Ndetec_tot*4*[[0]]
      self.bgpcov=self.Ndetec_tot*4*[[0]]
      self.goodness_fit=self.Ndetec_tot*4*[[0]*self.ebins]
      self.bgtime=self.Ndetec_tot*4*[[0]]
      self.bgesti=self.Ndetec_tot*4*[[0]]

#net Edepos spectrum, BG spectrum, full spectrum 
     
      self.BGEdepos     = self.Ndetec_tot*4*[np.array([0])]
      self.BGEdepos_err = self.Ndetec_tot*4*[np.array([0])]
      self.BGtime_interval = self.Ndetec_tot*4*[np.array([0])]

      self.BGEcounts     = self.Ndetec_tot*4*[np.array([0])]
      self.BGEcounts_err = self.Ndetec_tot*4*[np.array([0])]



      self.netEdepos     = self.Ndetec_tot*4*[np.array([0])]
      self.netEdepos_err = self.Ndetec_tot*4*[np.array([0])]
      self.nettime_interval = self.Ndetec_tot *4* [np.array([0])]

      self.netEcounts    =self.Ndetec_tot*4*[np.array([0])]
      self.netEcounts_err =self.Ndetec_tot*4*[np.array([0])]


      self.fullEdepos     = self.Ndetec_tot*4*[np.array([0])]
      self.fullEdepos_err = self.Ndetec_tot*4*[np.array([0])]
      self.fulltime_interval = self.Ndetec_tot *4* [np.array([0])]

      self.fullEcounts    =self.Ndetec_tot*4*[np.array([0])]
      self.fullEcounts_err =self.Ndetec_tot*4*[np.array([0])]

###########flag denotes which begin with##########
      self.beginwith_fitEdepos=1  #1: by default, begin with fitEdepos, 0:begin with lc BG
      self.search_Edepos=0 #0: means no search Edepos.fits yet 1: already

# for Edepos GUI
      self.detecsel_Edepos =0
      self.detID_fitEdepos_selected=[]
      self.rangeindex_selected=self.Ndetec_tot*4*[[0,0]]
# for multi-detec painting
      self.colorstr=['b','g','r','c','m','y','darkorange', 'yellow','lightgreen','aqua','dodgerblue','slategray','royalblue', 'blueviolate','pink', 'black', 'tan','violate']
   
   
#####for fit Edepos ##########
      self.fitEdepos_runStatus = 0
      self.res_type='single'
      self.flag_resetfit=0 # 0 means no fit is performed
      self.selectsource_fitEdepos=self.Ndetec_tot*4*[0]
      self.corx_selectsource_fitEdepos = self.Ndetec_tot * 4 * [[10,200]]  # the selected lc range for all detectors
      self.fitmethodstr    =['chi square', 'likelihood', 'Cstat','MCMC']
      self.fitmodelstr     =['Power-law','Band\'s GRB','Comptonized','Smoothly Broken Power law', 'Black body','None']#,'Black body']
      self.combmodelstr    ='e.g. phabs*po + ga'
      self.DIYmodelstr    ='e.g. Mymodelname'
      self.fitmethod       =0
      self.fitmodel        =0
      #para set
      self.paralist        =[['none', 0.01,0.01,-100,-100,100000,100000], ['none', 0.01,0.01,-100,-100,100000,100000],['none', 0.01,0.01,-100,-100,100000,100000],['none', 0.01,0.01,-100,-100,100000,100000],['none', 0.01,0.01,-100,-100,100000,100000]]
      #initial para value for each model
      self.inipara_powerlaw=[['none',1,0.01,-100,-100,100000,100000], ['none', 1,0.01,0,0,100000,100000]]
      self.inipara_band=[['none', -1,0.01,-100,-100,1000,1000], ['none', -2.2,0.01,-100,-100,1000,1000],['none', 300,1,0,0,10000,10000],['none', 1,0.01,0,0,100000,100000]]
      self.inipara_Comptonized=[['none', -1,0.01,-100,-100,1000,1000], ['none', 300,0.01,0,0,10000,10000],['none', 1,0.01,0,0,100000,100000]]
      self.inipara_funcSBpowerlaw=[['none', 300,0.1,0,0,10000,10000], ['none', -1,0.01,-10000,-10000,10000,10000],['none', 1,0.01,0,0,100000,100000]]
      self.inipara_bb=[['none', 10,0.1,0,0,10000,10000], ['none', 10,0.01,0,0,1000000,1000000]]
      #plot selections
      self.plotselections=[]
      #iteration times
      self.Niter=200
      self.type_specfit='none'
      self.rspmatrix       =self.Ndetec_tot*4*[np.array([0])]
      self.Nchannel_Ein    =128 #HXMT sets
      self.E_in           =[]
      self.ebinwidth_in   =[]
      self.ebinleft_in    =[]
      self.ebinright_in   =[]
      self.y_exp          =[] #the y value fitted 
      self.yerr           =[] # the err fitted
      self.yEbin_width    =[] # the deposited bin width fitted
      self.fitres_Edepos  =[]
      self.fE             =[]#Ndetec*Nchannel_in, notice that its in 
      self.fEerr          =[]#err for one fit integrate counts         
#####for loc#################
      self.Ndetec_loc      =[]
      self.iter_loc        =[]
      self.Nazi_loc        =[] 
      self.theta_loc       =None
      self.phi_loc         =None
#######for calculation of duration#################
      self.f=[]
      self.LCtype='LC'
      self.tf1=[]
      self.tf2=[]
      self.dtf=[]
      self.dtf_err=[] 

      
glv=glvclass()
#######set install dir ############################
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
glv.filedir_front='/home/songxy/GECAMGRBanatools/'
