import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from tools import genRSPname_GECAM 
from data import *
from xspec import *
import matplotlib.pyplot as plt

class fitEdepos_xspec(object):
      def __init__(self):
          self.type_spec='net'
          self.detID_selected=[0]
          self.rangeindex_selected=[0,127]  
          self.filedir_front='docs/fitsforXspec/'
          self.rspFileDir=''
          self.type_model="powerlaw"
          self.paralist=[]
          self.frozenlabel= False
          self.fitmethod='cstat'
          self.niteration=200
          self.location_J2000=[100,100]
          self.spec=[]*50
          self.lEbinmid=[]
          self.specfitsfilename=[[0]*len(self.detID_selected)]*3

      #def __del__(self):
      #    print('del')


      def setpara_fitEdepos(self, type_spec, detID_selected,
                            rangeindex_selected, filedir_front, rspFileDirlist,
                            type_model, paralist, frozenlabel,
                            fitmethod, niteration, location_J2000,
                            lEbinmid, specfitsfilename):
          self.type_spec= type_spec
          self.detID_selected=  detID_selected
          self.rangeindex_selected= rangeindex_selected
          self.filedir_front= filedir_front
          self.rspFileDirlist=rspFileDirlist
          self.type_model= type_model
          self.paralist= paralist
          self.frozenlabel= frozenlabel
          self.fitmethod= fitmethod
          self.niteration=niteration
          self.location_J2000= location_J2000
          self.lEbinmid=lEbinmid
          self.specfitsfilename = specfitsfilename
          


      def allclear(self):
          AllData.clear()
          AllModels.clear()

      def setspectrum_xspec( self, type_spec, detID_selected,
                             rangeindex_selected, 
                             rspFileDirlist,ra_loc,dec_loc):
          self.spec=[0]*len(detID_selected)
          #detID_selected=[0]
          for i in range(len(detID_selected)):
              idetec=detID_selected[i]
              index=rangeindex_selected[idetec]
              '''make net, BG, full file fits name'''
              sidetec= str(idetec+1) 
              sidetec=sidetec.zfill(3)
              netfitsname = self.specfitsfilename[0][i]
              BGfitsname = self.specfitsfilename[1][i]
              fullfitsname = self.specfitsfilename[2][i]
              '''
              add rsp filename
              '''
              rspfile=rspFileDirlist[i]
              if type_spec == 'net': #net, need to load rsp file
                 self.spec[i]=Spectrum(netfitsname)
                 self.spec[i].response=rspfile
              elif type_spec =='full': #full, need to load rsp file, backfile
                 self.spec[i]=Spectrum(fullfitsname)
                 self.spec[i].response=rspfile 
                 self.spec[i].background=BGfitsname
              #select the range
              str_ignore="**-"+str(index[0]) + " " +  str(index[1])+"-**"     
              self.spec[i].ignore(str_ignore)


      def setmodel_xpec(self,modelname, paralist, frozenlabel):
          '''if use xspec  and GECAM model'''
          self.m=Model(modelname) #in Xspec model       
      
          '''set state, initial value, delta, min, bot, top, max '''
          '''
          for i in range(self.m.nParameters):
              print('i:'+str(i))
              par_i=self.m(i+1)
              if frozenlabel=='frozen':
                 par_i.frozen=True
              else:
                 print(paralist[i][1:])
                 par_i.values=paralist[i][1:]  
          '''
      def setfitmethod_xspec(self,fitmethod):
          Fit.statMethod = fitmethod 
      
      
      def setiteration_xspec(self,niter):
          Fit.nIterations=niter
      
      
      #def setplot(selstr):
      #    Plot.device = "/xs"
      #    if len(selstr)==1:
      #       Plot(selstr[0])
      #    elif len(selstr)==2:
      #       Plot(selstr[0], selstr[1])
      #    elif len(selstr)==3:
      #       Plot(selstr[0], selstr[1], selstr[2])
      
      
      def fillfitres(self, detID_selected, elow, ehigh): #restype= single, batch, best
          #fill para
          fitres_para=[]
          fitres_cov=Fit.covariance
          print('--------------------fitres_cov' +str(fitres_cov))
          npara=self.m.nParameters
          fitstatus='SUC'
          print(int(npara * (npara + 1) / 2))
          print(len(list(fitres_cov)))
          if int(npara * (npara + 1) / 2) > len(list(fitres_cov)):
              fitstatus = 'FAIL'
          print('fitstatus' +str(fitstatus))
          print('fitres_cov' +str(fitres_cov))
          index=[]
          for i in range(npara):
              if i==0:
                 j=0
                 index.append(0) 
              else:
                 j=index[i-1]+i+1 
                 index.append(j)
              '''int(npara * (npara - 1)/2) > len(list(fitres_cov)), 
              cov is OK, or failed, the default value for failed is 99999.9 '''
              if fitstatus == 'SUC':
                 fitres_para.append([self.m(i+1).values[0], fitres_cov[j]**0.5])
              else:
                 fitres_para.append([self.m(i+1).values[0], 99999.9])

          fitres_ndof=Fit.dof
          fitres_reducedChi2=Fit.testStatistic/fitres_ndof
          print('dof' +str(fitres_ndof))
          print('chi2/dof' +str(fitres_reducedChi2/fitres_ndof))
          
          '''cal flux fluence'''
          elimitstr=str(elow) + " " +str(ehigh) + " 3 err"
          fluence_flux_tuple = [0,0,0,0,0,0]
          if fitstatus == 'FAIL':
              pass
          else:
             AllModels.calcFlux(elimitstr)
             specData=AllData(1)
             fluence_flux_tuple=specData.flux

          flux=[fluence_flux_tuple[3], fluence_flux_tuple[4]-fluence_flux_tuple[3], fluence_flux_tuple[5]-fluence_flux_tuple[3]]
          fluence=[fluence_flux_tuple[0], fluence_flux_tuple[1]-fluence_flux_tuple[0], fluence_flux_tuple[2]-fluence_flux_tuple[0]]


          fitres_Edepos_dict={
              'detID_selected':detID_selected,
              'fitmethod':self.fitmethod,
              'fitmodel': self.type_model,
              'fitstatus': fitstatus,
              'para':fitres_para,
              'cov':fitres_cov,
              'n.d.o.f': fitres_ndof,
              'reduced chi2':fitres_reducedChi2,
              'flux(photons)':flux,
              'fluence(ergs/cm^2/s)': fluence
               } 
          
          return fitres_Edepos_dict 
      
      
           
      
      
      def fitxspec(self):
          filedir_front      = self.filedir_front
          rspfiledirlist         = self.rspFileDirlist
          type_specfit       = self.type_spec
          detID_selected     = self.detID_selected
          rangeindex_selected= self.rangeindex_selected 
          modelname          = self.type_model
          paralist           = self.paralist
          fitmethod          = self.fitmethod
          niter              = self.niteration
          ra_loc, dec_loc    = self.location_J2000[0], self.location_J2000[1]
          frozenlabel        = self.frozenlabel
          lEbin_mid = self.lEbinmid

          '''
          logfile
          '''
          '''
          logfilename=filedir_front + 'logfile'
          if os.path.isfile(logfilename):
             os.remove(logfilename)

          Xset.openLog(logfilename)
          Xset.logChatter=10
          '''
          '''
          set arguments
          '''
          self.setspectrum_xspec(type_specfit, detID_selected,
                                 rangeindex_selected,
                                 rspfiledirlist, ra_loc, dec_loc)
          self.setmodel_xpec(modelname, paralist,frozenlabel)
          self.setfitmethod_xspec(fitmethod)
          self.setiteration_xspec(niter)
          
          '''perform fit'''
          Fit.perform()
          '''fitres'''
          elow =lEbin_mid[detID_selected[0]][rangeindex_selected[detID_selected[0]][0]]
          ehigh=lEbin_mid[detID_selected[0]][rangeindex_selected[detID_selected[0]][1]]
          Xset.closeLog()
          dict_fitres=self.fillfitres(self.detID_selected, elow, ehigh)
         
          return dict_fitres
       

