import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from tools import *
from data import *
from xspec import *
from .fitspec_xspec_GECAM import fitEdepos_xspec

class fitEdepos_xspec_batch(fitEdepos_xspec): 
      def __init__(self):
          fitEdepos_xspec.__init__(self)
      def setpara_fitEdepos_batch(self,type_spec,
                                  detID_selected,
                                  rangeindex_selected,
                                  filedir_front,
                                  rspFileDirlist,
                                  modelnamelist,
                                  paralist,
                                  fitmethod,
                                  niteration,
                                  location_J2000,
                                  lEbin_mid,
                                  iTR=False):
          self.type_spec= type_spec
          self.detID_selected=  detID_selected
          self.rangeindex_selected= rangeindex_selected
          self.filedir_front= filedir_front
          self.rspFileDirlist = rspFileDirlist
          self.modelnamelist= modelnamelist
          self.paralist= paralist
          self.fitmethod= fitmethod
          self.niteration=niteration
          self.location_J2000 = location_J2000
          self.lEbinmid=lEbin_mid
          self.iTR=iTR

      def def_specfitsfilename(self, detID_selected, filedir_front,iTR):
          specfitsfilename_net=[0]*len(detID_selected)
          specfitsfilename_BG=[0]*len(detID_selected)
          specfitsfilename_full=[0]*len(detID_selected)
          for i in range(len(detID_selected)):
              idetec=detID_selected[i]
              '''make net, BG, full file fits name'''
              sidetec= str(idetec+1)
              sidetec=sidetec.zfill(3)
              if iTR ==False:
                 netfitsname = filedir_front+'netEdepos'+ sidetec+'.fits'
                 BGfitsname = filedir_front+'BGEdepos'+ sidetec+'.fits'
                 fullfitsname = filedir_front+'fullEdepos'+ sidetec+'.fits'
                 specfitsfilename_net[i]= netfitsname
                 specfitsfilename_BG[i]= BGfitsname
                 specfitsfilename_full[i]= fullfitsname
              else:
                  netfitsname = filedir_front + 'netEdepos' + sidetec +'_tbin'+iTR + '.fits'
                  BGfitsname = filedir_front + 'BGEdepos' + sidetec + '_tbin'+iTR +'.fits'
                  fullfitsname = filedir_front + 'fullEdepos' + sidetec + '_tbin'+iTR +'.fits'
                  specfitsfilename_net[i] = netfitsname
                  specfitsfilename_BG[i] = BGfitsname
                  specfitsfilename_full[i] = fullfitsname


          return [specfitsfilename_net, specfitsfilename_BG,specfitsfilename_full]
 
      def fitEdeposbatchfit(self):
          fitres=[]
          bestfitres=[]
          modelnamelist= self.modelnamelist
          tmpreducedchi2=99999.
          self.specfitsfilename = self.def_specfitsfilename(self.detID_selected, self.filedir_front,self.iTR)
          for model in modelnamelist:
              print(model)
              self.type_model=model
              tmpfitres = self.fitxspec()
              fitres.append(tmpfitres)
              self.allclear()
              if tmpfitres['reduced chi2'] < tmpreducedchi2:
                 tmpreducedchi2 = tmpfitres['reduced chi2'] 
                 bestfitres=tmpfitres
          return  bestfitres, fitres    
  
