#output for Xspec 
from astropy.io import fits 
import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *


def genBGfits_pertbin_perdetID(fitsname, achannel, aBGEdepos, aBGEdepos_err):
    hdu0 = fits.PrimaryHDU()
    #hdu[0].header['SIMPLE']  = ( T ,' file does conform to FITS standard')
    #hdu[0].header['BITPIX']  = (16 ,' number of bits per data pixel')         
    #hdu[0].header['NAXIS']   = ( 0 ,' number of data axes')          
    #hdu[0].header['EXTEND']  = ( T ,' FITS dataset may contain extensions')            
#COMMENT  FITS (Flexible Image Transport System) format is defined in 'Astronomy
#COMMENT   and Astrophysics', volume 376, page 359; bibcode: 2001A&A...376..359H 


    col1 = fits.Column(name='CHANNEL', format='1J', array=achannel)
    col2 = fits.Column(name='COUNTS', format='1D',  array=aBGEdepos)
    col3 = fits.Column(name='STAT_ERR', format='1D',   array=aBGEdepos_err)
    hdu1 = fits.BinTableHDU.from_columns([col1, col2, col3])
    hdu1.header['LONGSTRN'] = ('OGIP 1.0','The HEASARC Long String Convention may be used')
    #hdu1.header['XTENSION']= ('BINTABLE', 'binary table extension')            
    #hdu1.header['BITPIX']= (8 ,'8-bit bytes')                                 
    #hdu1.header['NAXIS']= (2 ,'2-dimensional binary table')                     
    #hdu1.header['NAXIS1']= (16 ,'width of table in bytes')                      
    #hdu1.header['NAXIS2']= (1536 ,'number of rows in table')                    
    #hdu1.header['PCOUNT']= ( 0 ,'size of special data area')                    
    #hdu1.header['GCOUNT']= ( 1 ,'one data group (required keyword)')            
    #hdu1.header['TFIELDS']= ( 3 ,'number of fields in each row')                
    hdu1.header['TTYPE1']= ('CHANNEL ','label for field   1')                   
    hdu1.header['TFORM1']= ('1J','data format of field: 4-byte INTEGER')        
    hdu1.header['TUNIT1']= ('  ','physical unit of field')                      
    hdu1.header['TTYPE2']= ('COUNTS','label for field   2')
    hdu1.header['TFORM2']= ('1J','data format of field: 4-byte INTEGER')
    hdu1.header['TUNIT2']= ('counts','physical unit of field')
    hdu1.header['TTYPE3']= ('STAT_ERR','label for field   3')
    hdu1.header['TFORM3']= ('1D','data format of field: 8-byte DOUBLE')
    hdu1.header['TUNIT3']= ('counts','physical unit of field')
    hdu1.header['EXTNAME']= ('SPECTRUM','name of this binary table extension')
    hdu1.header['DETCHANS']= (achannel.size ,'Total no. detector channels available')
    hdu1.header['TELESCOP']= ('HXMT',' Telescope (mission) name')
    hdu1.header['INSTRUME']= ('LE',' Instrument name')
    hdu1.header['BACKFILE']= ('NONE',' background FITS file for this object')
    hdu1.header['BACKSCAL']= (1.0000000000E+00 ,'background scaling factor') 
    hdu1.header['CORRFILE']= ('NONE',' correlation FITS file for this object') 
    hdu1.header['CORRSCAL']= (1.0000000000E+00 ,'correlation scaling factor')
    hdu1.header['FILTER']= ('NONE','redistribution matrix file(RMF)')          
    hdu1.header['PHAVERSN']= ('1992a','OGIP classification of FITS format')
    #define rsp name
    #detID=fitsname[-7:-5]
    #detID='docs/rspgenerator_CLI_GECAM_FITS/det' +detID
    #hdu1.header['RESPFILE']= (detID+'.rsp' ,'RSP')
    hdu1.header['RESPFILE']= ('NONE' ,'RSP')
    hdu1.header['ANCRFILE']= ('NONE' ,'ARF')
    hdu1.header['STATERR']= (False,'no statisical error specified')
    hdu1.header['SYSERR']= (False,'no systematic error')                            
    hdu1.header['POISSERR']= (False ,'Poissonian statistical errors to be assumed')
    hdu1.header['GROUPING']= (0 ,'grouping of the data has been defined')      
    hdu1.header['QUALITY']= (0 ,'data quality information specified')         
    hdu1.header['AREASCAL']= ( 1 ,'area scaling factor')
    datatype=glv.datatype
    if datatype=='DATA':
       hdu1.header['EXPOSURE']= ( glv.timeinterval_ROI_cor[detID],'exposure time')
    else:
       hdu1.header['EXPOSURE']= ( glv.timeinterval_ROI,'exposure time')

    hdu1.header['LIVETIME']= ( 2.00000E+04 ,'Total spectrum accumulation time')
    hdu1.header['DEADC']= (5.19000E+02 ,' Deadtime correction factor')                 

    temp = []
    temp.append(hdu0)
    temp.append(hdu1)
    hdulists = fits.HDUList(temp)
#    currentdir=os.getcwd()
#    filedir=currentdir +str('/docs/')
    fitsname=glv.filedir_front+'docs/fitsforTimeresolved/' +str(fitsname)
    if( os.path.isfile(fitsname)):
        os.remove(fitsname)


    hdulists.writeto(fitsname) 

