import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
#from RSP_Generator  import rspgenerator
from RSP_Generator  import gen_rsp_fits
import coordtrans
from tools import TTtoUTC, genRSPname_GECAM
import shutil

def GetAngDegstr(ang):
    if ang>0:
       return ('%06d' % (ang*1000.))
    else:
       return ('%06d' % ((360+ang)*1000.))

def genrsp(location_J2000, sttimeMET,attfile,  rspOutputDir, detIDlist,Satlabel='A'):
    [ra,dec]=location_J2000
    sttimeUTC = TTtoUTC.met2utc(sttimeMET)
    angleinSat=[]
    '''calculate the angle in Sat a/b'''
    if Satlabel=='a' or Satlabel=='b':
       angleinSat=coordtrans.J2000_Sat([ra],[dec],start_time=sttimeUTC, end_time=None,step=1,filename=[attfile[0]])
    else:
       print('sat b gen rsp')
       angleinSat=coordtrans.J2000_Sat([ra],[dec],start_time=sttimeUTC, end_time=None,step=1,filename=[attfile[1]])
    theta, phi= angleinSat[0][0], angleinSat[1][0]
    
    
    #'''qiaorui generator'''
    theta, phi= angleinSat[0][0], angleinSat[1][0]
    rspfilenamelist=[]
    for detID in detIDlist:
        '''generate rsp file one by one'''
        detIDname= genRSPname_GECAM.detname_RSPgen(detID)
        gen_rsp_fits(detIDname, theta, phi,
            fits_filepath=None,fits_dir=rspOutputDir,is_overwrite=True,
            event_type='evt', particle='gamma',
            MET=sttimeMET, temp=None, hv=None
            )
        '''generate rsp filename list'''
        rspfilenamelist.append(rspOutputDir + genRSPname_GECAM.genRSPname(detID, theta, phi))

    return [angleinSat[0][0], angleinSat[1][0]], rspfilenamelist


    
    #'''use zhuyue v3p1 tentatively'''
    #os.system('python3 ~/fromZhuyue/GECAMrspgen_v3p1/rspgenerator_v3p1.py '
    #          +str(angleinSat[0][0]) +' ' +str(angleinSat[1][0]))
    #print('GetAngDegstr(angleinSat[0][0])' +str(GetAngDegstr(angleinSat[0][0])))
    #print('GetAngDegstr(angleinSat[1][0])' + str(GetAngDegstr(angleinSat[1][0])))
    #rspdir_fromzhuyue= '/home/songxy/fromZhuyue/GECAMrspgen_v3p1/rspInterp/IncdtDir_theta'+str(GetAngDegstr(angleinSat[0][0]))+ \
    #        '_phi'+str(GetAngDegstr(angleinSat[1][0]))+'interp/'
    #rspdir_dest= rspOutputDir+'gamma_T' + str(GetAngDegstr(angleinSat[0][0])) +'_P'+str(GetAngDegstr(angleinSat[1][0]))
    #if os.path.exists(rspdir_dest):
    #    shutil.rmtree(rspdir_dest)
    #shutil.copytree( rspdir_fromzhuyue,rspdir_dest)
    #''''use zhuyue v3p1 tentatively'''
    #rspfileDir = rspOutputDir + 'gamma_T' + str(GetAngDegstr(angleinSat[0][0])) \
    #             + '_P' + str(GetAngDegstr(angleinSat[1][0])) + '/'
    #return [angleinSat[0][0], angleinSat[1][0]], rspfileDir


def genrspGUI(location_J2000, sttimeMET, attfile, rspOutputDir, detIDlist,Satlabel='A'):
    sttimeUTC = TTtoUTC.met2utc(sttimeMET)
    [ra, dec] = location_J2000
    angleinSat = []
    '''calculate the angle in Sat a/b'''
    if Satlabel == 'a' or Satlabel == 'b':
        print('sat a gen rsp')
        angleinSat = coordtrans.J2000_Sat([ra], [dec], start_time=sttimeUTC, end_time=None, step=1,
                                          filename=[attfile[0]])
    else:
        print('sat b gen rsp')
        if len(attfile) ==2:
           angleinSat = coordtrans.J2000_Sat([ra], [dec], start_time=sttimeUTC, end_time=None, step=1,filename=[attfile[1]])
        else:
           print('only one attfile!') 
    print('angleinSat' + str(angleinSat))
    #'''qiaorui generator'''
    theta, phi= angleinSat[0][0], angleinSat[1][0]
    rspfilenamelist=[]
    for detID in detIDlist:
        '''generate rsp file one by one'''
        detIDname= genRSPname_GECAM.detname_RSPgen(detID)
        gen_rsp_fits(detIDname, theta, phi,
            fits_filepath=None,fits_dir=rspOutputDir,is_overwrite=True,
            event_type='evt', particle='gamma',
            MET=sttimeMET, temp=None, hv=None,
            uid=None, src=None)
        '''generate rsp filename list'''
        rspfilenamelist.append(rspOutputDir + genRSPname_GECAM.genRSPname(detID, theta, phi))

    return [angleinSat[0][0], angleinSat[1][0]], rspfilenamelist


    #'''use zhuyue v3p1 tentatively'''
    #os.system('python3 ~/fromZhuyue/GECAMrspgen_v3p1/rspgenerator_v3p1.py '
    #         +str(angleinSat[0][0]) +' ' +str(angleinSat[1][0]))
    #print('GetAngDegstr(angleinSat[0][0])' +str(GetAngDegstr(angleinSat[0][0])))
    #print('GetAngDegstr(angleinSat[1][0])' + str(GetAngDegstr(angleinSat[1][0])))
    #rspdir_fromzhuyue= '/home/songxy/fromZhuyue/GECAMrspgen_v3p1/rspInterp/IncdtDir_theta'+str(GetAngDegstr(angleinSat[0][0]))+ \
    #       '_phi'+str(GetAngDegstr(angleinSat[1][0]))+'interp/'
    #rspdir_dest= rspOutputDir+'gamma_T' + str(GetAngDegstr(angleinSat[0][0])) +'_P'+str(GetAngDegstr(angleinSat[1][0]))
    #if os.path.exists(rspdir_dest):
    #   shutil.rmtree(rspdir_dest)
    #shutil.copytree( rspdir_fromzhuyue,rspdir_dest)
    #''''use zhuyue v3p1 tentatively'''
    #rspfileDir = rspOutputDir + 'gamma_T' + str(GetAngDegstr(angleinSat[0][0])) \
    #            + '_P' + str(GetAngDegstr(angleinSat[1][0])) + '/'
    #return [angleinSat[0][0], angleinSat[1][0]], rspfileDir



