import numpy as np
import matplotlib
import matplotlib.pyplot as plt
matplotlib.use('TkAgg')

import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))

def chi_ndof(deg,binnum,esti, Y, Yerr):
    dof=binnum-deg
    chi2=(esti-Y)**2
    #sig2=Yerr**2
    sig2= esti
    resid=chi2/sig2
    return resid.sum()/dof


def plotchisq_ndof(ebin_mid, goodness_fit):
    plt.switch_backend("qt5agg")

    plt.plot(ebin_mid, goodness_fit, 'r-', label='fit')
    plt.xlabel('Edepos/keV')
    plt.ylabel('chi2/n.d.o.f')
    print(plt.get_backend())
    plt.show()

def plotchisq_ndof_batch(num_height,num_width, detID_selected, Ebin_mid,goodness_fit):
    
    plt.switch_backend("qt5agg")
    plt.figure(num_height*num_width)
    for detID in detID_selected:
        plt.subplot(num_height,num_width, detID+1)
        string= 'det' + str(detID)
        plt.plot(np.array(Ebin_mid[detID]),goodness_fit[detID], 'r-', label=string)
#        print('detID' +str(detID)+str(glv.goodness_fit[detID][:20])+'\n')
    #plt.xlabel('channel')                   
    plt.xlabel('Edepos/keV')                   
    plt.ylabel('chi2/n.d.o.f')
    print(plt.get_backend())
    plt.show()
        
