import sys
import os
from PyQt5.QtWidgets import *
from PyQt5.QtCore import (Qt, QCoreApplication, QAbstractTableModel, QModelIndex, QVariant, pyqtSignal) 

sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *

class filebrowse_gui(QWidget):
    signal_filebrowse_to_status_box = pyqtSignal(str) 
    def __init__(self, name = 'filebrowse window'):
        super(filebrowse_gui,self).__init__()
        self.setWindowTitle(name)
        self.cwd = os.getcwd() # 获取当前程序文件位置
        self.resize(300,150)   # 设置窗体大小

        self.btn_chooseMultiFile = QPushButton(self)  
        self.btn_chooseMultiFile.setObjectName("btn_chooseMultiFile")  
        self.btn_chooseMultiFile.setText("Browse and select local EVT file")
        self.btn_chooseMultiFile.clicked.connect(self.slot_btn_chooseMultiFile)

        '''
        self.btn_browsefromserver = QPushButton(self)
        self.btn_browsefromserver.setObjectName("btn_browsefromserver")
        self.btn_browsefromserver.setText("Browse and download EVT file")

        self.slot_btn_browsefromserver = BrowseFromServer()
        self.btn_browsefromserver.clicked.connect(self.slot_btn_browsefromserver.handle_click)
        self.slot_btn_browsefromserver.signal_catalog_download.connect(self.signal_filebrowse_to_status_box)
        '''

        layout = QVBoxLayout()
        layout.addWidget(self.btn_chooseMultiFile)
        #layout.addWidget(self.btn_browsefromserver)
        self.setLayout(layout)



    def slot_btn_chooseMultiFile(self):
        files, filetype = QFileDialog.getOpenFileNames(self,  
                                    "多文件选择",  
                                    self.cwd, # 起始路径 
                                    "All Files (*);;FITS Files (*.FITS);; fits Files (*.fits)")  
        files.sort()
        for ifilename in files:
             glv.lfilename.append(ifilename) 
        self.signal_filebrowse_to_status_box.emit('The choosen files are:' + str(files))
        ''' extract the data file dir '''
        if 'gag' in glv.lfilename[0]:
            gagindex=glv.lfilename[0].index('gag')
        elif 'gbg' in glv.lfilename[0]:
            gagindex=glv.lfilename[0].index('gbg')
        else:
            self.signal_filebrowse_to_status_box.emit('the filename is anormal!')
            
        genfitsDir = glv.lfilename[0][0:gagindex]
        '''assignment for filedir_front and  mkdir '''
        if os.path.exists(genfitsDir + 'fitsforXspec/'):
            pass
        else:
            os.mkdir(genfitsDir + 'fitsforXspec/')
        if os.path.exists(genfitsDir + 'rspgenerator_CLI_GECAM_FITS/'):
            pass
        else:
            os.mkdir(genfitsDir + 'rspgenerator_CLI_GECAM_FITS/')
        QCoreApplication.instance().quit
        self.close()


    def startfbgui(self):
        if not self.isVisible():
            self.show()
    def handle_close(self):
        self.close()

class BrowseFromServer(QTableWidget):
    signal_catalog_download = pyqtSignal(str)

    def __init__(self, parent=None):
        super(BrowseFromServer, self).__init__(parent)
        self.resize(600, 400)
        self.setWindowTitle("HXMT GRB Trigger Catelog")
        self.setColumnCount(5)
        self.setRowCount(100)
        column_name = ['Download GRB', 'View Light Curve', 'GRB Name', 'Trigger Time', 'T90']
        self.setHorizontalHeaderLabels(column_name)
        self.setItemDelegateForColumn(0, DownloadButtonDelegate(self))
        self.setItemDelegateForColumn(1, ViewLCButtonDelegate(self))
        self.resizeColumnsToContents()

    def handle_click(self):
        if not self.isVisible():
            self.show()
        self.signal_catalog_download.emit('Begin to download HXMT GRB Catalog, Loading...')

        return

    def handle_close(self):
        self.close()


class GRBTableView(QTableView):
    def __init__(self, parent=None):
        super(GRBTableView, self).__init__(parent)
        # self.setItemDelegateForColumn(0, DownloadButtonDelegate(self))

    def cellButtonClicked(self):
        print("Download GRB", self.sender().index)

class DownloadButtonDelegate(QItemDelegate):
    def __init__(self, parent=None):
        super(DownloadButtonDelegate, self).__init__(parent)

    def paint(self, painter, option, index):
        if not self.parent().indexWidget(index):
            self.button_download = QPushButton()
            self.button_download.setText("Download")
            self.button_download.index = [index.row(), index.column()]
            h_box_layout = QHBoxLayout()
            h_box_layout.addWidget(self.button_download)
            h_box_layout.setContentsMargins(0, 0, 0, 0)
            h_box_layout.setAlignment(Qt.AlignCenter)
            widget = QWidget()
            widget.setLayout(h_box_layout)
            self.parent().setIndexWidget(
                index,
                widget
            )


class ViewLCButtonDelegate(QItemDelegate):
    def __init__(self, parent=None):
        super(ViewLCButtonDelegate, self).__init__(parent)

    def paint(self, painter, option, index):
        if not self.parent().indexWidget(index):
            self.button_download = QPushButton()
            self.button_download.setText("Preview")
            self.button_download.index = [index.row(), index.column()]
            h_box_layout = QHBoxLayout()
            h_box_layout.addWidget(self.button_download)
            h_box_layout.setContentsMargins(0, 0, 0, 0)
            h_box_layout.setAlignment(Qt.AlignCenter)
            widget = QWidget()
            widget.setLayout(h_box_layout)
def download_HXMT_catalog():
    ip = 'lxslc6.ihep.ac.cn'
    port = 22
    user = 'chenwei'
    password = 'cr2032+1s'
    remote_file = '/hxmt/work/GRB/Trigger/2018_08/HEB180803659/HEB180803659_bintime0.2_300s.png'
    local_file = './HEB180803659_bintime0.2_300s.png'
    print('hello world')

    ssh_scp_get(ip, port, user, password, remote_file, local_file)
    return





#if __name__=="__main__":
#    app = QApplication(sys.argv)
#    mainForm = filebrowse_gui('file browse window')
#    mainForm.show()
#    sys.exit(app.exec_())
