import sys
import os
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from PyQt5.QtWidgets import QApplication,QWidget,QFileDialog, QVBoxLayout,QTextEdit
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from .GUI_messagebox_GECAM import GUI_message

class fitreslog_gui(QWidget):
    def __init__(self):
        super(fitreslog_gui, self).__init__()
#        self.setupUi(self)
        self.resize(720,720)
        self.initUI()
        self.GUI_message= GUI_message(self)
    def initUI(self): 
        #layout
        layout=QVBoxLayout()
        self.textEdit=QTextEdit()
        layout.addWidget(self.textEdit)
        self.setLayout(layout)
    def btn_clear(self):
        self.textEdit.clear()
    def btn_open(self):
        filename=glv.genfitsDir + 'logfile'
        try:
           with open(filename,'r') as f:
               my_txt=f.read()
               self.textEdit.setPlainText(my_txt)
        except FileNotFoundError:
               self.GUI_message.show_message_warning("warning","FIT FAILED, HENCEFORTH NO OUTPUT LOG")               
            
    def btn_open_batch(self):
        my_txt='batch fit log:'
        for model in glv.fitmodelstr:
            logfilename=glv.genfitsDir+ 'logfile_' + model +'batch'
            if os.path.isfile(logfilename):
               with open(logfilename,'r') as f:
                    my_txt=my_txt+f.read()                    
               os.rename(logfilename, logfilename +'_results_lasttime') 
            else:
               my_txt=my_txt+'fitting with '+model +'failed! ' 
               self.GUI_message.show_message_warning("warning","FIT with 1st model "+ model +" FAILED, HENCEFORTH NO OUTPUT LOG!")  
        self.textEdit.setPlainText(my_txt)



    def startfitresloggui(self):
        if not self.isVisible():
            self.show()
 
          
#if __name__=='__main__':
#    app=QApplication(sys.argv)
#    w=myform()
#    sys.exit(app.exec_())
