# -*- coding: utf-8 -*-
"""
Created on Fri Aug 24 11:58:46 2018

@author: songxy
"""

import sys, os
import time

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *

import matplotlib
matplotlib.use('TkAgg')
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.backends.backend_qt5 import NavigationToolbar2QT as NavigationToolbar
from matplotlib.figure import Figure
from .GUI_plotbase_GECAM import MPLbase 
from .GUI_plotbase_GECAM import MPLwrapper 
from .GUI_messagebox_GECAM import GUI_message

sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from tools import *
from fitEdepos import *
from fitBG import *

class GECAM_Widget(QWidget):

    signal_status_box = pyqtSignal(str)

    def __init__(self):
        super(GECAM_Widget,self).__init__()
        self.resize(950,900) 
        self.initUi()
        self.signal_status_box.connect(self.receive_status_box)
        self.GUI_message= GUI_message(self)

    def initUi(self):

        self.create_buttonbox1()
        self.create_buttonbox2()
        #self.create_buttonbox3()
        self.create_buttonbox4()
        self.create_mplcanvasbox()
        self.create_statusbox()
        self.setbuttonstatus()


        mainLayout = QVBoxLayout()
        hboxLayout = QHBoxLayout()
        hboxLayout.addStretch()  

        vboxLayout = QVBoxLayout()
        vboxLayout.addWidget(self.vboxGroupBox1)
        vboxLayout.addWidget(self.gridGroupBox)
        #vboxLayout.addWidget(self.vboxGroupBox2)
        vboxLayout.addWidget(self.vboxGroupBox3)

        hboxLayout.addLayout(vboxLayout)
        hboxLayout.addWidget(self.vboxGroupBox4)
        
        mainLayout.addLayout(hboxLayout)
        mainLayout.addWidget(self.formGroupBox)

        self.setLayout(mainLayout)

    #    MainWindow.setCentralWidget(self.centralWidget)
    #    self.retranslateUi(MainWindow)
    #    QMetaObject.connectSlotsByName(MainWindow)





    def create_buttonbox1(self):
        self.vboxGroupBox1 = QGroupBox()
        layout = QVBoxLayout()
        ''' file browse '''
        
        ''' '''

        self.btnstartwebbrowser = QPushButton()
        self.btnstartwebbrowser.setText(" browse and select files")
        layout.addWidget(self.btnstartwebbrowser)


        self.btnloaddata = QPushButton()
        self.btnloaddata.setText("load the selected data")
        layout.addWidget(self.btnloaddata)
        self.btnloaddata.clicked.connect(self.slot_loaddata)

        ''' multi-plot '''

        ''' '''
        self.btnstartmultilc = QPushButton()
        self.btnstartmultilc.setText("start multi-lightcurve display")
        layout.addWidget(self.btnstartmultilc)

        layout.addStretch()
        self.vboxGroupBox1.setLayout(layout)


    def create_buttonbox2(self):    
        '''plot selection box'''

        ''' '''
        self.gridGroupBox = QGroupBox("plotting setup:")       
        gridlayout = QGridLayout()


        self.btnselectsource = QPushButton()
        self.btnselectsource.setText("select source")
        self.btnselectsource.clicked.connect(self.ssc_xycoor)      


        self.btntoggle = QPushButton()            
        self.btntoggle.setText("toggle")
        self.btntoggle.clicked.connect(self.toggle)

    #    self.bininputline=QLineEdit()
    #    self.bininputline.setPlaceholderText('bin:')
    #    self.bininputline.setClearButtonEnabled(True)

        self.binwinputline=QLineEdit()
        self.binwinputline.setPlaceholderText('binwidth:unit/s')
        self.binwinputline.setClearButtonEnabled(True)

        self.btnredraw = QPushButton()  
        self.btnredraw.setText("redraw")
        self.btnredraw.clicked.connect(self.redraw)

        self.btnerase = QPushButton()  
        self.btnerase.setText("erase")
        self.btnerase.clicked.connect(self.eraseselection)


        self.btndrawsetupsave = QPushButton()  
        self.btndrawsetupsave.setText("set ylog or not")
        #self.btndrawsetupsave.clicked.connect(self.applyallselection)
        self.btndrawsetupsave.clicked.connect(self.setylog)

        gridlayout.addWidget(self.btnselectsource,1,0)
        gridlayout.addWidget(self.btntoggle,1,1)
        #gridlayout.addWidget(self.bininputline,2,0)
        gridlayout.addWidget(self.binwinputline,2,0)
        gridlayout.addWidget(self.btnredraw,2,1)
        gridlayout.addWidget(self.btnerase,3,0)
        gridlayout.addWidget(self.btndrawsetupsave,3,1)
        gridlayout.setColumnStretch(1, 1)
        self.gridGroupBox.setLayout(gridlayout)
        
    def create_buttonbox3(self):
        self.vboxGroupBox2 = QGroupBox("already exists, read plotting setup:")
        layout = QVBoxLayout()
        self.btnloadsetup = QPushButton()  
        self.btnloadsetup.setText("load setup")
        layout.addWidget(self.btnloadsetup)
        self.vboxGroupBox2.setLayout(layout)      


    def create_buttonbox4(self): 
        self.vboxGroupBox3 = QGroupBox()
        layout = QVBoxLayout()
        self.gridGroupBox2 = QGroupBox("BG range setup:")
        gridlayout = QGridLayout()

        self.btnBGselect = QPushButton()
        self.btnBGselect.setText("select")
        #layout.addWidget(self.btnBGselect)
        self.btnBGselect.clicked.connect(self.sbg_xycoor)

        self.btnBGerase = QPushButton()
        self.btnBGerase.setText("erase")
        #layout.addWidget(self.btnBGerase)
        self.btnBGerase.clicked.connect(self.BGrange_erase)


        self.inputline_bgx=QLineEdit()
        self.inputline_bgx.setPlaceholderText('BG range input:')
        self.inputline_bgx.setClearButtonEnabled(True)
        self.btnBGreset = QPushButton()
        self.btnBGreset.setText("reset")
        #layout.addWidget(self.btnBGreset)
        self.btnBGreset.clicked.connect(self.BGrange_reset)

        gridlayout.addWidget(self.btnBGselect,1,0)
        gridlayout.addWidget(self.btnBGerase,1,1)
        gridlayout.addWidget(self.inputline_bgx,2,0)
        gridlayout.addWidget(self.btnBGreset,2,1)
        self.gridGroupBox2.setLayout(gridlayout)
        layout.addWidget(self.gridGroupBox2)


        #self.btnBGanapkg = QPushButton()
        #self.btnBGanapkg.setText("use BG analysis package")
        #layout.addWidget(self.btnBGanapkg)

        self.gridGroupBox3 = QGroupBox("ROI setup:")
        gridlayout2 = QGridLayout()
        self.inputline_ROI=QLineEdit()
        self.inputline_ROI.setClearButtonEnabled(True)
        self.inputline_ROI.setPlaceholderText('ROI input:')        
        self.btnROIreset = QPushButton()
        self.btnROIreset.setText("reset")
        #layout.ROIdWidget(self.btnBGreset)
        self.btnROIreset.clicked.connect(self.ROI_reset)
                                                                         
        gridlayout2.addWidget(self.inputline_ROI,1,0)
        gridlayout2.addWidget(self.btnROIreset,1,1)
        self.gridGroupBox3.setLayout(gridlayout2)
        layout.addWidget(self.gridGroupBox3)

        self.btnstartful = QPushButton()
        self.btnstartful.setText("start flux upperlimit calculation")
        layout.addWidget(self.btnstartful)
        

        self.btnstartloc = QPushButton()
        self.btnstartloc.setText("start location")
        #self.btnstartloc.clicked.connect(self.startlocationGUI)
        layout.addWidget(self.btnstartloc)


        self.btnrspgenerator = QPushButton()
        self.btnrspgenerator.setText("RSP generator")
        layout.addWidget(self.btnrspgenerator)

        self.selrangeBox= QGroupBox("Efit range selection:")
        rangeselgridlayout = QGridLayout()
        self.btn_fitEdepos_rangesel = QPushButton()
        self.btn_fitEdepos_rangesel.setText("select")
        self.btn_fitEdepos_rangesel.clicked.connect(self.fitEdepos_rangesel)
       
        self.btn_erase_rangesel = QPushButton()
        self.btn_erase_rangesel.setText("erase")
        self.btn_erase_rangesel.clicked.connect(self.erase_rangesel)
        
   
        self.btn_applyall_rangesel = QPushButton()
        self.btn_applyall_rangesel.setText("apply all")
        self.btn_applyall_rangesel.clicked.connect(self.applyall_rangesel)


        self.inputline_Efitrange=QLineEdit()
        self.inputline_Efitrange.setClearButtonEnabled(True)
        self.inputline_Efitrange.setPlaceholderText('E range input:')
        self.btnEfitrangereset = QPushButton()
        self.btnEfitrangereset.setText("reset")
        #layout.addWidget(self.btnEfitrangereset)
        self.btnEfitrangereset.clicked.connect(self.Efitrange_reset)

        self.btnstartfitEdepos = QPushButton()
        self.btnstartfitEdepos.setText("start Efit")
        #layout.addWidget(self.btnstartfitEdepos)
        
       
        rangeselgridlayout.addWidget(self.btn_fitEdepos_rangesel,1,0)
        rangeselgridlayout.addWidget(self.btn_erase_rangesel,1,1)
        rangeselgridlayout.addWidget(self.btn_applyall_rangesel,1,2)
        rangeselgridlayout.addWidget(self.inputline_Efitrange,2,0)
        rangeselgridlayout.addWidget(self.btnEfitrangereset,2,1)
        rangeselgridlayout.addWidget(self.btnstartfitEdepos,2,2)
        self.selrangeBox.setLayout(rangeselgridlayout)
        layout.addWidget(self.selrangeBox)

        
        

        self.btnstartcalondf = QPushButton()
        self.btnstartcalondf.setText("Start calculation on Duration and Significance")
        #self.btnstartcalondf.clicked.connect(fitxspec)
        layout.addWidget(self.btnstartcalondf)


        self.btnstartcorana = QPushButton()
        self.btnstartcorana.setText("Start correlation analysis")
        layout.addWidget(self.btnstartcorana)

        layout.addStretch()
        self.vboxGroupBox3.setLayout(layout)

        #self.vboxGroupBox3 = QGroupBox()
        #layout = QVBoxLayout()
        #self.btnstartful = QPushButton()
        #self.btnstartful.setText("start flux upperlimit calculation")
        #layout.addWidget(self.btnstartful)


        #self.btnBGselect = QPushButton()
        #self.btnBGselect.setText("select BG range")
        #layout.addWidget(self.btnBGselect)
        #self.btnBGselect.clicked.connect(self.sbg_xycoor)

        #self.btnBGerase = QPushButton()
        #self.btnBGerase.setText("erase BG range")
        #layout.addWidget(self.btnBGerase)
        #self.btnBGerase.clicked.connect(self.BGrange_erase)


        #self.btnBGanapkg = QPushButton()
        #self.btnBGanapkg.setText("use BG analysis package")
        #layout.addWidget(self.btnBGanapkg)

        #self.btnstartloc = QPushButton()
        #self.btnstartloc.setText("start location")
        ##self.btnstartloc.clicked.connect(self.startlocationGUI)
        #layout.addWidget(self.btnstartloc)


        #self.btnrspgenerator = QPushButton()
        #self.btnrspgenerator.setText("RSP generator")
        #layout.addWidget(self.btnrspgenerator)

        #self.selrangeBox= QGroupBox("Efit range selection:")
        #rangeselgridlayout = QGridLayout()
        #self.btn_fitEdepos_rangesel = QPushButton()
        #self.btn_fitEdepos_rangesel.setText("select")
        #self.btn_fitEdepos_rangesel.clicked.connect(self.fitEdepos_rangesel)
       
        #self.btn_erase_rangesel = QPushButton()
        #self.btn_erase_rangesel.setText("erase")
        #self.btn_erase_rangesel.clicked.connect(self.erase_rangesel)
        #
   
        #self.btn_applyall_rangesel = QPushButton()
        #self.btn_applyall_rangesel.setText("apply all")
        #self.btn_applyall_rangesel.clicked.connect(self.applyall_rangesel)
        #
        #

       
        #rangeselgridlayout.addWidget(self.btn_fitEdepos_rangesel,1,0)
        #rangeselgridlayout.addWidget(self.btn_erase_rangesel,1,1)
        #rangeselgridlayout.addWidget(self.btn_applyall_rangesel,1,2)
        #self.selrangeBox.setLayout(rangeselgridlayout)
        #layout.addWidget(self.selrangeBox)



        #self.btnstartfitEdepos = QPushButton()
        #self.btnstartfitEdepos.setText("start Edepos fit")
        #layout.addWidget(self.btnstartfitEdepos)

        #self.btnstartcalondf = QPushButton()
        #self.btnstartcalondf.setText("Start calculation on duration")
        ##self.btnstartcalondf.clicked.connect(fitxspec)
        #layout.addWidget(self.btnstartcalondf)


        #self.btnstartcorana = QPushButton()
        #self.btnstartcorana.setText("Start correlation analysis")
        #layout.addWidget(self.btnstartcorana)

        #layout.addStretch()
        #self.vboxGroupBox3.setLayout(layout)


    def create_mplcanvasbox(self):
        self.vboxGroupBox4 = QGroupBox()
        layout = QVBoxLayout()  
        self.mplCanvas = MPLwrapper()
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.mplCanvas.sizePolicy().hasHeightForWidth())
        self.mplCanvas.setSizePolicy(sizePolicy)
        self.mplCanvas.setObjectName("mplCanvas")
        layout.addWidget(self.mplCanvas) 
        self.vboxGroupBox4.setLayout(layout)
        #self.setWindowTitle('Basic Layout')

    def create_statusbox(self):
        self.formGroupBox= QGroupBox()
        layout = QFormLayout()
        statusLabel = QLabel("running status:")
        self.statusEditor = QTextEdit()
        self.statusEditor.setPlainText("")
        layout.addRow(statusLabel,self.statusEditor)
        self.formGroupBox.setLayout(layout)


    def receive_status_box(self, status_str):
        # self.statusEditor.setPlainText(status_str)
        self.statusEditor.append(status_str)
        return






    '''
    click connected function
    '''
    def slot_loaddata(self):
        #there are two choice for data type
        #label the flag of begin with light curve BG fit
        try:
        #if 1:
          glv.beginwith_fitEdepos=0
          flag = glv.datatype
          st_beginload=time.time()
          if flag == 'DATA':
             setValue_trigdata(glv.lfilename)
          self.signal_status_box.emit('MC data has been loaded! Data-loading + Discrinating H/L Gain cost time:' + str(time.time()-st_beginload)) 
          self.signal_status_box.emit('TrigTimeUTC: ' +str(glv.trigtimeUTC) )
          self.signal_status_box.emit('TrigTimeMET(s): ' +str(glv.trigtimeMET) )
          self.signal_status_box.emit('TrigTime in Fig(s): ' +str(glv.trigtimeMET- glv.lstarttime[0]) )
          self.signal_status_box.emit('location on Sat(J2000, RA, DEC/deg): ' + str(glv.locationJ2000_onSat))
        except IndexError:
             self.GUI_message.show_message_warning("warning","LACK OF INPUT FILENAME! please browse and select file first!")
             '''clear the filenamelist'''
             glv.lfilename=[]
        except:
             self.GUI_message.show_message_warning("warning","INPUT WRONG FILENAME WITH WRONG FORMAT OR KEYWORD! please check the selected file first!")
             '''clear the filenamelist'''
             glv.lfilename=[]

    # select source for lc/Edepos
    def ssc_xycoor(self):
        if glv.flag_currentinmainframe=='lightcurve':
           print('in ssc_xycoor'+str(glv.detID_currentselected))
           glv.selectsource_lc[glv.detID_currentselected]=int(1)
           if len(glv.corx_selectsource_lc[glv.detID_currentselected]) ==2:
              #glv.selectsource_lc[glv.detID_currentselected]=int(0) 
              # release the length limition for lc
              pass
        elif glv.flag_currentinmainframe=='Edepos':     
             glv.selectsource_Edepos[glv.detID_currentselected]=int(1)
             if len(glv.corx_selectsource_Edepos[glv.detID_currentselected]) ==2:
                #if glv.beginwith_fitEdepos==0
                pass
                #else:
                #   glv.selectsource_Edepos[glv.detID_currentselected]=int(0) 

    #select BG 
    def sbg_xycoor(self):
        glv.selectBGrange[glv.detID_currentselected]=int(1)
        if len(glv.corx_BG[glv.detID_currentselected]) ==4:
           glv.selectBGrange[glv.detID_currentselected]=int(0)


    def BGrange_erase(self):
        glv.corx_BG[glv.detID_currentselected]=[]
        self.redraw()
        glv.selectBGrange[glv.detID_currentselected]=int(1)

    def BGrange_reset(self):
        detID=glv.detID_currentselected
        tmpstr=''     
        corx_BG=[] 
        if self.inputline_bgx.text()=='':
           #self.signal_status_box.emit('please input BG range!') 
           self.GUI_message.show_message_warning('warning', 'you DON\'T have input any BG range!')
        else:
            BGrangestr=list(self.inputline_bgx.text())
            print(BGrangestr)
            for x in BGrangestr:
                if x=='[' or x==' ':
                   pass
                elif x==','or x==']' :
                   corx_BG.append(float(tmpstr))
                   tmpstr='' 
                else:
                   tmpstr=tmpstr + x        
            glv.corx_BG[detID]=corx_BG
            self.redraw()  
            self.mplCanvas.fixylim()
            tup=self.mplCanvas.getylim() 
            for x in corx_BG:
                self.mplCanvas.plot([x,x],[tup[0],tup[1]])
                self.mplCanvas.ylim(tup[0],tup[1])

    def ROI_reset(self):
        try:
        #if 1: 
           detID=glv.detID_currentselected
           tmpstr=''     
           corx_ROI=[] 
           if self.inputline_ROI.text()=='':
              self.signal_status_box.emit('please input ROI range!') 
           else:
              ROIrangestr=list(self.inputline_ROI.text())
              for x in ROIrangestr:
                  if x=='[' or x==' ':
                     pass
                  elif x==','or x==']' :
                     corx_ROI.append(float(tmpstr))
                     tmpstr='' 
                  else:
                     tmpstr=tmpstr + x        
           glv.corx_ROI[detID]=corx_ROI
           self.redraw()  
           self.mplCanvas.fixylim()
           tup=self.mplCanvas.getylim() 
           for x in corx_ROI:
               self.mplCanvas.plot([x,x],[tup[0],tup[1]])
               self.mplCanvas.ylim(tup[0],tup[1])
           if len(glv.bgtime[detID])==1:#didn't fitBG in this detID 
              corx_BG=glv.corx_BG[detID]
              if len(corx_BG)!=2: #didn't select BG range 
                 pass
              else:
                 for x in corx_BG:
                     self.mplCanvas.plot([x,x],[tup[0],tup[1]])
                     self.mplCanvas.ylim(tup[0],tup[1])
           else:
                self.mplCanvas.fixylim()
                bgtime=glv.bgtime[detID]
                bgesti=glv.bgesti[detID]
                self.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][0]+glv.corx_BG[detID][1])/2.0)<(glv.corx_BG[detID][1]-glv.corx_BG[detID][0])/2.0), facecolor='green',  alpha=0.5)
                self.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][2]+glv.corx_BG[detID][3])/2.0)<(glv.corx_BG[detID][3]-glv.corx_BG[detID][2])/2.0), facecolor='green',  alpha=0.5, label='BG range')

           self.mplCanvas.xlabel("time(s)")
           self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
           self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')
           self.mplCanvas.UpdatePlot()#必须刷新才能显示    
        except:
        #else:
           self.GUI_message.show_message_warning("warning","WRONG OPERATION! please follow the tutorial exactly!")

     

    def sROI_xycoor(self):
        #print('in sROI_xycoor')
        print('glv.detID_currentselected'+str(glv.detID_currentselected))
        print('glv.corx_ROI[glv.detID_currentselected]'+str(glv.corx_ROI[glv.detID_currentselected]))
        glv.selectROIrange[glv.detID_currentselected]=int(1)
        if len(glv.corx_ROI[glv.detID_currentselected]) ==2:
           glv.selectROIrange[glv.detID_currentselected]=int(0)


        


    def plotlc(self,*args, **kwargs):
        self.mplCanvas.clearplot()
        idetec=glv.detID_currentselected
        if glv.detecsel_Edepos == 0 and glv.plotEdeposflag ==0:
           self.mplCanvas.clearplot()
           self.mplCanvas.plotwitherr(glv.ltime[idetec],glv.lcounts_perT[idetec], glv.lcounts_perT_err[idetec], fmt='.')
           self.mplCanvas.xlabel("time(s)")
           self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
           self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')
           #self.mplCanvas.title_MPL(r'$\alpha$')
           self.mplCanvas.UpdatePlot()#必须刷新才能显示
           glv.flag_plotsource=3
           glv.flag_setylog=1
           glv.plotsource_currentselected=[]
           glv.plotsource_currentselected.append(glv.ltime[idetec])
           glv.plotsource_currentselected.append(glv.lcounts_perT[idetec])
           glv.plotsource_currentselected.append(glv.lcounts_perT_err[idetec])
        else:
          glv.flag_currentinmainframe='Edepos'
          self.mplCanvas.clearplot()
          idetec=glv.detID_currentselected
          self.mplCanvas.plotwitherr(glv.lEbin_mid[idetec],glv.netEdepos[idetec],glv.netEdepos_err[idetec], fmt='.')
          self.mplCanvas.setylog()
          self.mplCanvas.setxlog()
          self.mplCanvas.xlabel(LabelString="Edepos(KeV)")
          self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
          self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
          self.mplCanvas.UpdatePlot()#必须刷新才能显示

          #fill plot source
          glv.flag_plotsource=4
          glv.flag_setylog=1
          glv.plotsource_currentselected=[]
          glv.plotsource_currentselected.append(glv.lEbin_mid[idetec])
          glv.plotsource_currentselected.append(glv.netEdepos[idetec])
          glv.plotsource_currentselected.append(glv.netEdepos_err[idetec])



          #if corx_Edepos has been selected...

#
           #Print('mc'+str(cr_perE[:50]))
           #Print('data'+str(glv.netEdepos[idetec][:50]))

    def plotlcsum(self):
        self.mplCanvas.clearplot()
        length= len(glv.lcounts_perT[0])
        counts_sum=np.zeros(length)
        for idetec in glv.detID_selected:
            counts_sum=counts_sum + glv.lcounts_perT[idetec]     
        self.mplCanvas.plotwitherr(glv.ltime[0],counts_sum, counts_sum**0.5, fmt='.')
        #print('time=' + str(glv.ltime[0])) 
        #print('counts=' +str(counts_sum.tolist()))
        self.mplCanvas.xlabel("time(s)")
        self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
        self.mplCanvas.title_MPL(r'count rate ($s^{-1}$) vs time(s)')
        self.mplCanvas.UpdatePlot()#必须刷新才能显示

        #fill plot source
        glv.flag_plotsource=5
        glv.flag_setylog=1
        glv.plotsource_currentselected=[]
        glv.plotsource_currentselected.append(glv.ltime[0])
        glv.plotsource_currentselected.append(counts_sum)
        glv.plotsource_currentselected.append(counts_sum**0.5)



    #toggle from e to t or vise versa
    def toggle(self):

        detID       =glv.detID_currentselected
        timeinterval=0
        if glv.timeinterval==0:
           if detID < 50:
              timeinterval=glv.ltimeinterval[0]
           else:
              timeinterval=glv.ltimeinterval[1]
        else:
            timeinterval=glv.timeinterval
        tbinwidth   =glv.tbinwidth
        tbins       =timeinterval/tbinwidth
        ebinedges   =glv.ebin_edges 
        lt          =glv.ltime       
 
        #print('ebinarray' +str(ebinarray))


        if glv.toggle_flag[detID]==0: #if detID is not toggled, initial value is assigned.
           tnet=np.array(glv.lte[detID][0])
           totalbins=int((max(tnet.tolist())-min(tnet.tolist()))/tbinwidth)
           glv.et2D_currentselected, glv.time_binned =  shape2Dhist(glv.lte[detID], totalbins,tbinwidth, ebinedges) 

           glv.time_currentselected = glv.time_binned 
           glv.toggle_flag[detID]=1
         
        et2D_currentselected  =glv.et2D_currentselected #already histogram
        time_binned           =glv.time_binned
        time_currentselected  =glv.time_currentselected #current time xbin
        edepos_currentselected=glv.edepos_currentselected #current edepos xbin
        ltindex=[]
        leindex=[] 
        
        at=np.array([0])
        aedepos=np.array([0])


        '''
        means that the lc and/or Edepos source has been selected 

        ''' 
        if glv.selectsource_lc[detID] == 1  and glv.selectsource_Edepos[detID] == 1:      
           corx_currentselected_lc=glv.corx_selectsource_lc[detID]# corx in lc for current selected
           corx_currentselected_Edepos=glv.corx_selectsource_Edepos[detID]# corx in lc for current selected
           slice_et2D, aedepos, at =slice_et(et2D_currentselected, corx_currentselected_lc, corx_currentselected_Edepos,detID)

           timeinterval=corx_currentselected_lc[1]-corx_currentselected_lc[0]
           ltindex=getindex_lt(glv.corx_selectsource_lc[detID],tbinwidth)
           time_currentselected= time_binned[ltindex[0]:ltindex[1]+1]


        elif glv.selectsource_lc[detID] == 1:
             corx_currentselected_lc=glv.corx_selectsource_lc[detID]
             slice_et2D, aedepos,at =toggle_t2e(et2D_currentselected, corx_currentselected_lc, tbinwidth)

             timeinterval=corx_currentselected_lc[1]-corx_currentselected_lc[0]
             ltindex=getindex_lt(glv.corx_selectsource_lc[detID],tbinwidth)
             time_currentselected= time_binned[ltindex[0]:ltindex[1]+1]

        elif glv.selectsource_Edepos[detID] == 1: 
             corx_currentselected_Edepos=glv.corx_selectsource_Edepos[detID]# corx in lc for current selected
             slice_et2D, aedepos,at =toggle_e2t(et2D_currentselected, corx_currentselected_Edepos, detID)


        else: #means lc source has not been selected
             slice_et2D= et2D_currentselected
             aedepos=np.sum(et2D_currentselected, axis=1)
             at=np.sum(et2D_currentselected, axis=0)

      

        if glv.flag_currentinmainframe == 'lightcurve':
           # change display flag
           glv.flag_currentinmainframe = 'Edepos'
           #plot Edepos      
           print('aedepos' +str(aedepos))
           print('timeinterval' +str(timeinterval))
           edepos, counts_perE, err =gethist_countrate_perE(aedepos, timeinterval, detID)
           self.mplCanvas.clearplot()
           self.mplCanvas.plotwitherr(edepos,counts_perE, err, fmt='.')
           self.mplCanvas.xlabel(LabelString='Edepos(KeV)')
           self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
           self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
           self.mplCanvas.UpdatePlot()#必须刷新才能显示

           #self.mplCanvas.setylog()
           #update 
           glv.timeinterval=timeinterval
           glv.time_currentselected=time_currentselected

           #fill plot source
           glv.flag_plotsource=6
           glv.flag_setylog=1
           glv.plotsource_currentselected=[]
           glv.plotsource_currentselected.append(edepos)
           glv.plotsource_currentselected.append(counts_perE)
           glv.plotsource_currentselected.append(err)
 

      




        elif glv.flag_currentinmainframe == 'Edepos':
            #change display flag
             glv.flag_currentinmainframe = 'lightcurve' 
             counts_perT, err =gethist_countrate_perT(at, glv.tbinwidth)
             self.mplCanvas.clearplot()
             self.mplCanvas.plotwitherr(glv.time_currentselected, counts_perT, err, fmt='.')       
             self.mplCanvas.xlabel("time(s)")
             self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
             self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')
             self.mplCanvas.UpdatePlot()





             #self.mplCanvas.setylog()
             #update 
             #fill plot source
             glv.flag_plotsource=7
             glv.flag_setylog=1
             glv.plotsource_currentselected=[]
             glv.plotsource_currentselected.append(glv.time_currentselected)
             glv.plotsource_currentselected.append(counts_perT)
             glv.plotsource_currentselected.append(err)

        else:
            pass 

    def redraw(self):
        detID=glv.detID_currentselected
        newbinwidth=1.0
        if self.binwinputline.text() != '':
           newbinwidth=float(self.binwinputline.text())
        else:
           newbinwidth=1.0 #by default
        #newbinwidth=float(self.binwinputline.text()) 
        tnet=np.array(glv.lte[detID][0])
        timeinterval=max(tnet.tolist())-min(tnet.tolist())
        tbins=int(timeinterval/newbinwidth)
        ebinedges   =glv.ebin_edges            
        #update
        glv.tbinwidth       =newbinwidth  # default bin width 1s 
        glv.tbins           =tbins                                          
        glv.toggle_flag[detID]=0
        #all range source
        het2D, time=shape2Dhist(glv.lte[detID],tbins,newbinwidth, ebinedges)
        #slice according to
        lt=[] #t range selected
        le=[] #e range selected
        slice_et2D=np.array([0])
        aedepos=np.array([0])
        at=np.array([0])
        if glv.selectsource_lc[detID] == 1  and glv.selectsource_Edepos[detID] == 1:
           lt=glv.corx_selectsource_lc[detID]
           le=glv.corx_selectsource_Edepos[detID]
           slice_et2D, aedepos, at =slice_et(het2D, lt, le, detID) 
        elif glv.selectsource_lc[detID] == 1: 
            lt=glv.corx_selectsource_lc[detID]
            slice_et2D, aedepos, at=toggle_t2e(het2D, lt,glv.tbinwidth)
        elif glv.selectsource_Edepos[detID] == 1: 
            le=glv.corx_selectsource_Edepos[detID]
            slice_et2D, aedepos, at=toggle_e2t(het2D, le, detID) 
        else:
            aedepos=np.sum(het2D, axis=1)
            at=np.sum(het2D, axis=0)
 

        if glv.selectsource_lc[detID] == 1: 
           index_t=getindex_GECAM.getindex_lt(lt,glv.tbinwidth)
           slice_time=time[index_t[0]: index_t[1]+1]
        else:
           slice_time=time
        if glv.flag_currentinmainframe == 'lightcurve':
           counts_perT, err =gethist_countrate_perT(at, newbinwidth) 
           self.mplCanvas.clearplot()
           self.mplCanvas.plotwitherr(slice_time, counts_perT, err, fmt='.')
           self.mplCanvas.xlabel("time(s)")
           self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
           self.mplCanvas.title_MPL(r'count rate ($s^{-1}$) vs time(s)')
           self.mplCanvas.UpdatePlot()#必须刷新才能显示

           #self.mplCanvas.setylog()
           #fill plot source
           glv.flag_plotsource=8
           glv.flag_setylog=1
           glv.plotsource_currentselected=[]
           glv.plotsource_currentselected.append(slice_time)
           glv.plotsource_currentselected.append(counts_perT)
           glv.plotsource_currentselected.append(err)


        else:
           edepos, counts_perE, err =gethist_countrate_perE(aedepos, timeinterval, detID)
           self.mplCanvas.clearplot()
           self.mplCanvas.plotwitherr(edepos,counts_perE, err, fmt='.')
           self.mplCanvas.xlabel(LabelString='Edepos(KeV)')
           self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
           self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
           self.mplCanvas.UpdatePlot()#必须刷新才能显示

           #self.mplCanvas.setylog()
           #update 
           glv.timeinterval=timeinterval
           #glv.time_currentselected=time_currentselected

           #fill plot source
           glv.flag_plotsource=9
           glv.flag_setylog=1
           glv.plotsource_currentselected=[]
           glv.plotsource_currentselected.append(edepos)
           glv.plotsource_currentselected.append(counts_perE)
           glv.plotsource_currentselected.append(err)






    def eraseselection(self):
        #clear the selected range 
        detID=glv.detID_currentselected
        glv.selectsource_lc[detID]=[0] # label which detector has been selected lc source
        glv.corx_selectsource_lc[detID]=[] # the selected lc range for all detectors 
        glv.selectsource_Edepos[detID]=[0] # label which detector has been selected lc source
        glv.corx_selectsource_Edepos[detID]=[] # the selected lc range for all detectors 
        #redraw the current lightcurve or Edepos with default selection
        # to be done ...
        self.redraw()


    def setylog(self):
        #self.mplCanvas.setylog() 
        print('glv.flag_setylog' +str(glv.flag_setylog))
        print('glv.flag_plotsource' +str(glv.flag_plotsource))
        if glv.flag_setylog==1:
           glv.flag_setylog=0 #for next time not setylog
           if glv.flag_plotsource==0:
              self.mplCanvas.clearplot()
              fulltime      =glv.plotsource_currentselected[0]
              scountrate    =glv.plotsource_currentselected[1]
              scountrate_err=glv.plotsource_currentselected[2]
              bgtime        =glv.plotsource_currentselected[3]
              bgscr         =glv.plotsource_currentselected[4]
              bgscr_err     =glv.plotsource_currentselected[5]
              bgtime        =glv.plotsource_currentselected[6]
              bgesti        =glv.plotsource_currentselected[7]

              self.mplCanvas.plotwitherr(fulltime, scountrate, yerr=scountrate_err, fmt='.')
              self.mplCanvas.plotwitherr(bgtime,bgscr,yerr=bgscr_err,fmt='g.')
              self.mplCanvas.plot(bgtime,bgesti)
              self.mplCanvas.fixylim()
              self.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][0]+glv.corx_BG[detID][1])/2.0)<(glv.corx_BG[detID][1]-glv.corx_BG[detID][0])/2.0), facecolor='green',  alpha=0.5)
              self.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][2]+glv.corx_BG[detID][3])/2.0)<(glv.corx_BG[detID][3]-glv.corx_BG[detID][2])/2.0), facecolor='green',  alpha=0.5)
              self.mplCanvas.xlabel("time(s)")
              self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
              self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')

              self.mplCanvas.setylog()
              self.mplCanvas.UpdatePlot()#必须刷新才能显示


           if glv.flag_plotsource==1:    
              
              Ebinmid            =glv.plotsource_currentselected[0]
              countrate_perE     =glv.plotsource_currentselected[1]
              countrate_perE_err =glv.plotsource_currentselected[2]
              BGcountrate_ROI    =glv.plotsource_currentselected[3]
              BGcountrateerr_ROI =glv.plotsource_currentselected[4]
              self.mplCanvas.plotwitherr(Ebinmid, countrate_perE, countrate_perE_err, fmt='.')
              self.mplCanvas.plotwitherr(Ebinmid, BGcountrate_ROI, BGcountrateerr_ROI, fmt='.')
              self.mplCanvas.xlabel(LabelString="Edepos(KeV)")
              self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
              self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
              self.mplCanvas.UpdatePlot()#必须刷新才能显示

           if glv.flag_plotsource>=2 and  glv.flag_plotsource<=8:
              self.mplCanvas.clearplot()
              self.mplCanvas.plotwitherr(glv.plotsource_currentselected[0], glv.plotsource_currentselected[1], glv.plotsource_currentselected[2], fmt='.')      
              if glv.flag_plotsource==2 or glv.flag_plotsource==4 or glv.flag_plotsource==6:
                 self.mplCanvas.xlabel(LabelString="Edepos(KeV)")
                 self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
                 self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
              else:
                 self.mplCanvas.xlabel("time(s)")
                 self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
                 self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')


              self.mplCanvas.setylog()
              self.mplCanvas.UpdatePlot()#必须刷新才能显示                                                                                               
        elif glv.flag_setylog==0:
             glv.flag_setylog=1 #for next time not setylog
             if glv.flag_plotsource==0:
                self.mplCanvas.clearplot()
                fulltime      =glv.plotsource_currentselected[0]
                scountrate    =glv.plotsource_currentselected[1]
                scountrate_err=glv.plotsource_currentselected[2]
                bgtime        =glv.plotsource_currentselected[3]
                bgscr         =glv.plotsource_currentselected[4]
                bgscr_err     =glv.plotsource_currentselected[5]
                bgtime        =glv.plotsource_currentselected[6]
                bgesti        =glv.plotsource_currentselected[7]
   
                self.mplCanvas.plotwitherr(fulltime, scountrate, yerr=scountrate_err, fmt='.')
                self.mplCanvas.plotwitherr(bgtime,bgscr,yerr=bgscr_err,fmt='g.')
                self.mplCanvas.plot(bgtime,bgesti)
                self.mplCanvas.fixylim()
                self.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][0]+glv.corx_BG[detID][1])/2.0)<(glv.corx_BG[detID][1]-glv.corx_BG[detID][0])/2.0), facecolor='green',  alpha=0.5)
                self.mplCanvas.fill_between(bgtime,bgesti,0, where=(abs(bgtime-(glv.corx_BG[detID][2]+glv.corx_BG[detID][3])/2.0)<(glv.corx_BG[detID][3]-glv.corx_BG[detID][2])/2.0), facecolor='green',  alpha=0.5)
                self.mplCanvas.xlabel("time(s)")
                self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
                self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')


                self.mplCanvas.UpdatePlot()#必须刷新才能显示
   
   
             if glv.flag_plotsource==1:
                Ebinmid            =glv.plotsource_currentselected[0]
                countrate_perE     =glv.plotsource_currentselected[1]
                countrate_perE_err =glv.plotsource_currentselected[2]
                BGcountrate_ROI    =glv.plotsource_currentselected[3]
                BGcountrateerr_ROI =glv.plotsource_currentselected[4]
                self.mplCanvas.plotwitherr(Ebinmid, countrate_perE, countrate_perE_err, fmt='.')
                self.mplCanvas.plotwitherr(Ebinmid, BGcountrate_ROI, BGcountrateerr_ROI, fmt='.')
                self.mplCanvas.xlabel(LabelString="Edepos(KeV)")
                self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
                self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
                self.mplCanvas.UpdatePlot()#必须刷新才能显示


             if glv.flag_plotsource>=2 and  glv.flag_plotsource<=9:
                self.mplCanvas.clearplot()
                self.mplCanvas.plotwitherr(glv.plotsource_currentselected[0], glv.plotsource_currentselected[1], glv.plotsource_currentselected[2], fmt='.')
                if glv.flag_plotsource==2 or glv.flag_plotsource==4 or glv.flag_plotsource==6:
                   self.mplCanvas.xlabel(LabelString="Edepos(KeV)")
                   self.mplCanvas.ylabel(LabelString=r'count/T/E $s^{-1}kev^{-1}$')
                   self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
                   self.mplCanvas.UpdatePlot()#必须刷新才能显示


                else:
                   self.mplCanvas.xlabel("time(s)")
                   self.mplCanvas.ylabel(r'count rate ($s^{-1}$)')
                   self.mplCanvas.title_MPL(r'count rate($s^{-1}$) vs time(s)')

             self.mplCanvas.UpdatePlot()#必须刷新才能显示
        else:
            pass 


    def applyallselection(self):
        #apply the selection to all detectors   
        detID=glv.detID_currentselected
        if glv.detecsel_Edepos ==0:
           glv.selectsource_lc=glv.Ndetec_tot*[glv.selectsource_lc[detID]] # label which detector has been selected lc source
           glv.corx_selectsource_lc=glv.Ndetec_tot*[glv.corx_selectsource_lc[detID]] # the selected lc range for all detectors 
        else:
           glv.selectsource_Edepos=glv.Ndetec_tot*[glv.selectsource_Edepos[detID]] # label which detector has been selected lc source
           glv.corx_selectsource_Edepos=glv.Ndetec_tot*[glv.corx_selectsource_Edepos[detID]] # the selected lc range for all detectors 




    def BGfit_applyall(self):
        #detID=glv.detID_currentselected
        detID=glv.detID_BGfitted[-1]
        print(glv.detID_selected)
        detID_selected=np.array(glv.detID_selected)
        print(type(detID_selected))
        print('-----------------------detID_selected' + str(detID_selected))
        #devide into two groups gecamA and gecamB
        detAindex = np.where(np.array(detID_selected)<50)[0]
        detID_selected_A = np.array(detID_selected)[detAindex].tolist()
        detBindex = np.where(np.array(detID_selected)>=50)[0]
        detID_selected_B = np.array(detID_selected)[detBindex].tolist()

        detID_selected_A_rm=list(set(detID_selected_A) -set(glv.detID_BGfitted))
        detID_selected_B_rm=list(set(detID_selected_B) -set(glv.detID_BGfitted))

        try:
        #if 1:
           if len(detID_selected_A_rm)>0:
               begintime=time.time()
               goodness_satA=BGfitprocess(detID_selected_A_rm,
                            glv.bgpolyorder[detID],
                            glv.corx_BG[detID],
                            glv.corx_ROI[detID],
                            glv.ltbins[0], glv.tbinwidth,glv.ebins, glv.ebin_edges,
                            glv.lte,
                            glv.genfitsDir,
                            glv.rspoutputdir,
                            glv.deadtime,
                            glv.taskID,
                            satLabel='a')
               for idetec in detID_selected_A_rm:
                   idx=detID_selected_A_rm.index(idetec)
                   glv.goodness_fit[idetec] = goodness_satA[idx]
               glv.detID_BGfitted.extend(detID_selected_A_rm)
               #spendtime=fitBG_batchserial(glv.bgpolyorder[detID_BGfitted_A[-1]], "A", detID_BGfitted_A)
               self.signal_status_box.emit('batch BG fit and generate net/BG/full fits for satellite A detector: ' +str(detID_selected_A)
                                           + ' spend time: ' + str(time.time()-begintime) +' sec')
           if len(detID_selected_B_rm)>0:
               begintime = time.time()
               goodness_satB= BGfitprocess(detID_selected_B_rm,
                            glv.bgpolyorder[detID],
                            glv.corx_BG[detID],
                            glv.corx_ROI[detID],
                            glv.ltbins[1], glv.tbinwidth, glv.ebins, glv.ebin_edges,
                            glv.lte,
                            glv.genfitsDir,
                            glv.rspoutputdir,
                            glv.deadtime,
                            glv.taskID,
                            satLabel='b')
               for idetec in detID_selected_B_rm:
                   idx = detID_selected_B_rm.index(idetec)
                   glv.goodness_fit[idetec] = goodness_satB[idx]
               glv.detID_BGfitted.extend(detID_selected_B_rm)
               # spendtime=fitBG_batchserial(glv.bgpolyorder[detID_BGfitted_A[-1]], "A", detID_BGfitted_A)
               self.signal_status_box.emit('batch BG fit generate net/BG/full fits for satellite B detector: ' + str(detID_selected_B)
                                           + ' spend time: ' + str(time.time() - begintime) + ' sec')
        except:
          self.GUI_message.show_message_warning("warning","please check the range of signal/BG are selected correctly!")
 



    def genfits_batch(self):
        achannel = np.arange(256) #np.array([0,1,2,...255]) 
        t1=time.time()
        binwidth= glv.tbinwidth 
        for idetec in glv.detID_selected:
            print('**************in genfits_batch******************')
            print('detID'+str(idetec))
            sidetec= str(idetec+1) #because idetec 1-18
            sidetec=sidetec.zfill(2)
            netfitsname = 'netEdepos'+ sidetec+'.fits'  
            BGfitsname = 'BGEdepos'+ sidetec+'.fits'  
            fullfitsname = 'fullEdepos'+ sidetec+'.fits'  
#            print('glv.netEdepos[idetec]'+str(glv.netEdepos[idetec][:20]))


            #label the flag of begin with BG fit
            #glv.beginwith_fitEdepos=0
            #net  
            gennetfits(idetec,netfitsname,  achannel, glv.netEcounts[idetec], glv.netEcounts_err[idetec])
            #print('net' +str(glv.netEcounts[idetec][:20])+str(glv.netEcounts_err[idetec][:20]))
            #full
            genfullfits(idetec,fullfitsname,  achannel, glv.fullEcounts[idetec], glv.fullEcounts_err[idetec])
            #print('full' +str(len(glv.fullEcounts[idetec]))+str(len(glv.fullEcounts_err[idetec])))
            #print('full' +str(glv.fullEcounts[idetec][:20])+str(glv.fullEcounts_err[idetec][:20]))
            #BG
            genBGfits(idetec, BGfitsname,  achannel, glv.BGEcounts[idetec], glv.BGEcounts_err[idetec])
            #print('BG' +str(glv.BGEcounts[idetec][:20])+str(glv.BGEcounts_err[idetec][:20]))
           # tlow_timeresolved, thigh_timeresolved=glv.corx_BG[idetec][1], glv.corx_BG[idetec][2]

           # genfitsbybin(idetec, binwidth, tlow_timeresolved, thigh_timeresolved)
        self.signal_status_box.emit('generate .fits for Xspec spen time:' +str(time.time()-t1))


    def erase_batch(self):
        self.eraseselection()

        self.selectBGrange=glv.Ndetec_tot*[0]
        self.corx_BG      =glv.Ndetec_tot*[[]]
        #ROI range selection
        self.selectROIrange=glv.Ndetec_tot*[0]
        self.corx_ROI      =glv.Ndetec_tot*[[]]
        self.timeinterval_ROI=0.0
        self.timeinterval_ROI_cor=glv.Ndetec_tot*[0.0] #should be a glv.Ndetec_tot length list 





    def fitEdepos_rangesel(self):
        try:
           print('glv.detID_currentselected=',glv.detID_currentselected)
           print('len(glv.corx_selectsource_fitEdepos[glv.detID_currentselected])',len(glv.corx_selectsource_fitEdepos[glv.detID_currentselected]))
           glv.selectsource_Edepos[glv.detID_currentselected]=int(1)
           glv.selectsource_fitEdepos[glv.detID_currentselected]=int(1)
           if glv.corx_selectsource_fitEdepos[glv.detID_currentselected][0]==10 and glv.corx_selectsource_fitEdepos[glv.detID_currentselected][0]==200:
              glv.selectsource_Edepos[glv.detID_currentselected]=int(0) 
              glv.selectsource_fitEdepos[glv.detID_currentselected]=int(0) 
        except:
           self.GUI_message.show_message_warning("warning","please follow the correct steps in tutorial, choose the deposited sepectrum from multi-detector page after net/full/BG spectrum files are generated!")

           
    def erase_rangesel(self):
        self.mplCanvas.clearplot() 
        idetec=glv.detID_currentselected 
        glv.corx_selectsource_fitEdepos[idetec]=[]
        self.mplCanvas.plotwitherr(glv.lEbin_mid[idetec],glv.netEdepos[idetec],glv.netEdepos_err[idetec], fmt='.')
        self.mplCanvas.setxlog()
        self.mplCanvas.setylog()
        self.mplCanvas.xlabel(LabelString="Edepos(KeV)")
        self.mplCanvas.ylabel(LabelString=r'count/T/E ($s^{-1}kev^{-1}$)')
        self.mplCanvas.title_MPL(r'count/T/E ($s^{-1}kev^{-1}$)  vs time(s)')
        self.mplCanvas.UpdatePlot()#必须刷新才能显示

        #fill plot source
        glv.flag_plotsource=4
        glv.flag_setylog=1
        glv.plotsource_currentselected=[]
        glv.plotsource_currentselected.append(glv.lEbin_mid[idetec])
        glv.plotsource_currentselected.append(glv.netEdepos[idetec])
        glv.plotsource_currentselected.append(glv.netEdepos_err[idetec])

        
    def applyall_rangesel(self):
        print('glv.corx_selectsource_fitEdepos'+str(glv.corx_selectsource_fitEdepos))
        '''discriminate high/low gain of A/B'''
        corx_fitEdepos_Alow = []
        corx_fitEdepos_Ahig = []
        corx_fitEdepos_Blow = []
        corx_fitEdepos_Bhig = []
        idet= glv.detID_currentselected
        if idet<25:
            corx_fitEdepos_Alow= glv.corx_selectsource_fitEdepos[idet]
        if idet>=25 and idet<50:
            corx_fitEdepos_Ahig = glv.corx_selectsource_fitEdepos[idet]
        if idet>=50 and idet<75:
            corx_fitEdepos_Blow = glv.corx_selectsource_fitEdepos[idet]
        if idet>=75:
            corx_fitEdepos_Bhig = glv.corx_selectsource_fitEdepos[idet]
        glv.corx_selectsource_fitEdepos[0:25]=[corx_fitEdepos_Alow]*glv.Ndetec_tot
        glv.corx_selectsource_fitEdepos[25:50] = [corx_fitEdepos_Ahig] * glv.Ndetec_tot
        glv.corx_selectsource_fitEdepos[50:75] = [corx_fitEdepos_Blow] * glv.Ndetec_tot
        glv.corx_selectsource_fitEdepos[75:100] = [corx_fitEdepos_Bhig] * glv.Ndetec_tot
        print('glv.detID_currentselected' +str(glv.detID_currentselected))
        print('glv.corx_selectsource_fitEdepos'+str(glv.corx_selectsource_fitEdepos))
    def Efitrange_reset(self):
        detID=glv.detID_currentselected
        tmpstr=''
        corx_Efit=[]
        if self.inputline_Efitrange.text()=='':
           self.signal_status_box.emit('please input Efit range!')
        else:
           Efitrangestr=list(self.inputline_Efitrange.text())
           for x in Efitrangestr:
               if x=='[' or x==' ':
                  pass
               elif x==','or x==']' :
                  corx_Efit.append(float(tmpstr))
                  tmpstr=''
               else:
                  tmpstr=tmpstr + x
        glv.corx_selectsource_fitEdepos[detID]=corx_Efit
        self.erase_rangesel()
        self.mplCanvas.fixylim()
        tup=self.mplCanvas.getylim()
        for x in corx_Efit:
            self.mplCanvas.plot([x,x],[tup[0],tup[1]])
            self.mplCanvas.ylim(tup[0],tup[1])

    def setbuttonstatus(self):
        self.btnstartful.setEnabled(False) 
        self.btnstartloc.setEnabled(False) 
        self.btnstartcalondf.setEnabled(False) 
        self.btnstartcorana.setEnabled(False) 

















#        #et2D slice and binning for BG analysis
#        for i in range(glv.Ndetec_tot):
#           het2D, time=shape2Dhist(glv.lte[i],glv.tbins, glv.tbinwidth, glv.ebin_edges) 
#           lt=glv.corx_selectsource_lc[detID]
#           le=glv.corx_selectsource_Edepos[detID]
#           slice_et2D_i, aedepos, at =slice_et(het2D, lt,le,detID]
#           glv.slice_et2D.append(slice_et2D_i)
#           glv.slice_aedepos.append(aedepos)
#           glv.slice_at.append(at)  




        

#    def retranslateUi(self, MainWindow):
#
#        MainWindow.setWindowTitle("MainWindow")
#
#        self.btnStart.setText("start")
#
#        self.btnPause.setText("pause")





#def main():
#    app = QApplication(sys.argv)
#    form = AppForm()
