import sys, os
from . import GUI_multi_lc_frame, GUI_multi_lc_plot
from PyQt5 import QtCore, QtGui, QtWidgets
from data import glv
from astropy.io import fits


class MultiLCGui(QtWidgets.QWidget, GUI_multi_lc_frame.Ui_Form):
    signal_multilc_plot_current_choice = QtCore.pyqtSignal(str)
    signal_filebrowse_to_status_box = QtCore.pyqtSignal(str)

    def __init__(self):
        super(MultiLCGui, self).__init__()
        self.setupUi(self)
        self.select_dets = []
        self.plottype="LC"
        
        #button connected with checkBox 
        # satelite A low      
        self.pushButton_alg01.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg01, self.checkBox_alg01, 1))
        self.pushButton_alg02.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg02, self.checkBox_alg02, 2))
        self.pushButton_alg03.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg03, self.checkBox_alg03, 3))
        self.pushButton_alg04.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg04, self.checkBox_alg04, 4))
        self.pushButton_alg05.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg05, self.checkBox_alg05, 5))
        self.pushButton_alg06.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg06, self.checkBox_alg06, 6))
        self.pushButton_alg07.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg07, self.checkBox_alg07, 7))
        self.pushButton_alg08.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg08, self.checkBox_alg08, 8))
        self.pushButton_alg09.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg09, self.checkBox_alg09, 9))
        self.pushButton_alg10.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg10, self.checkBox_alg10, 10))
        self.pushButton_alg11.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg11, self.checkBox_alg11, 11))
        self.pushButton_alg12.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg12, self.checkBox_alg12, 12))
        self.pushButton_alg13.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg13, self.checkBox_alg13, 13))
        self.pushButton_alg14.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg14, self.checkBox_alg14, 14))
        self.pushButton_alg15.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg15, self.checkBox_alg15, 15))
        self.pushButton_alg16.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg16, self.checkBox_alg16, 16))
        self.pushButton_alg17.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg17, self.checkBox_alg17, 17))
        self.pushButton_alg18.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg18, self.checkBox_alg18, 18))
        self.pushButton_alg19.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg19, self.checkBox_alg19, 19))
        self.pushButton_alg20.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg20, self.checkBox_alg20, 20))
        self.pushButton_alg21.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg21, self.checkBox_alg21, 21))
        self.pushButton_alg22.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg22, self.checkBox_alg22, 22))
        self.pushButton_alg23.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg23, self.checkBox_alg23, 23))
        self.pushButton_alg24.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg24, self.checkBox_alg24, 24))
        self.pushButton_alg25.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_alg25, self.checkBox_alg25, 25))


        # satelite A high      
        self.pushButton_ahg01.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg01, self.checkBox_ahg01,25+ 1))
        self.pushButton_ahg02.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg02, self.checkBox_ahg02,25+ 2))
        self.pushButton_ahg03.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg03, self.checkBox_ahg03,25+ 3))
        self.pushButton_ahg04.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg04, self.checkBox_ahg04,25+ 4))
        self.pushButton_ahg05.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg05, self.checkBox_ahg05,25+ 5))
        self.pushButton_ahg06.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg06, self.checkBox_ahg06,25+ 6))
        self.pushButton_ahg07.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg07, self.checkBox_ahg07,25+ 7))
        self.pushButton_ahg08.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg08, self.checkBox_ahg08,25+ 8))
        self.pushButton_ahg09.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg09, self.checkBox_ahg09,25+ 9))
        self.pushButton_ahg10.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg10, self.checkBox_ahg10,25+ 10))
        self.pushButton_ahg11.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg11, self.checkBox_ahg11,25+ 11))
        self.pushButton_ahg12.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg12, self.checkBox_ahg12,25+ 12))
        self.pushButton_ahg13.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg13, self.checkBox_ahg13,25+ 13))
        self.pushButton_ahg14.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg14, self.checkBox_ahg14,25+ 14))
        self.pushButton_ahg15.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg15, self.checkBox_ahg15,25+ 15))
        self.pushButton_ahg16.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg16, self.checkBox_ahg16,25+ 16))
        self.pushButton_ahg17.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg17, self.checkBox_ahg17,25+ 17))
        self.pushButton_ahg18.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg18, self.checkBox_ahg18,25+ 18))
        self.pushButton_ahg19.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg19, self.checkBox_ahg19,25+ 19))
        self.pushButton_ahg20.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg20, self.checkBox_ahg20,25+ 20))
        self.pushButton_ahg21.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg21, self.checkBox_ahg21,25+ 21))
        self.pushButton_ahg22.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg22, self.checkBox_ahg22,25+ 22))
        self.pushButton_ahg23.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg23, self.checkBox_ahg23,25+ 23))
        self.pushButton_ahg24.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg24, self.checkBox_ahg24,25+ 24))
        self.pushButton_ahg25.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_ahg25, self.checkBox_ahg25,25+ 25))


        #satelite B low

        self.pushButton_blg01.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg01, self.checkBox_blg01, 1+50))
        self.pushButton_blg02.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg02, self.checkBox_blg02, 2+50))
        self.pushButton_blg03.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg03, self.checkBox_blg03, 3+50))
        self.pushButton_blg04.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg04, self.checkBox_blg04, 4+50))
        self.pushButton_blg05.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg05, self.checkBox_blg05, 5+50))
        self.pushButton_blg06.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg06, self.checkBox_blg06, 6+50))
        self.pushButton_blg07.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg07, self.checkBox_blg07, 7+50))
        self.pushButton_blg08.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg08, self.checkBox_blg08, 8+50))
        self.pushButton_blg09.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg09, self.checkBox_blg09, 9+50))
        self.pushButton_blg10.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg10, self.checkBox_blg10, 10+50))
        self.pushButton_blg11.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg11, self.checkBox_blg11, 11+50))
        self.pushButton_blg12.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg12, self.checkBox_blg12, 12+50))
        self.pushButton_blg13.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg13, self.checkBox_blg13, 13+50))
        self.pushButton_blg14.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg14, self.checkBox_blg14, 14+50))
        self.pushButton_blg15.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg15, self.checkBox_blg15, 15+50))
        self.pushButton_blg16.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg16, self.checkBox_blg16, 16+50))
        self.pushButton_blg17.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg17, self.checkBox_blg17, 17+50))
        self.pushButton_blg18.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg18, self.checkBox_blg18, 18+50))
        self.pushButton_blg19.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg19, self.checkBox_blg19, 19+50))
        self.pushButton_blg20.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg20, self.checkBox_blg20, 20+50))
        self.pushButton_blg21.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg21, self.checkBox_blg21, 21+50))
        self.pushButton_blg22.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg22, self.checkBox_blg22, 22+50))
        self.pushButton_blg23.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg23, self.checkBox_blg23, 23+50))
        self.pushButton_blg24.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg24, self.checkBox_blg24, 24+50))
        self.pushButton_blg25.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_blg50, self.checkBox_blg50, 25+50))
        #satelite B high 

        self.pushButton_bhg01.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg01, self.checkBox_bhg01, 1+75))
        self.pushButton_bhg02.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg02, self.checkBox_bhg02, 2+75))
        self.pushButton_bhg03.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg03, self.checkBox_bhg03, 3+75))
        self.pushButton_bhg04.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg04, self.checkBox_bhg04, 4+75))
        self.pushButton_bhg05.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg05, self.checkBox_bhg05, 5+75))
        self.pushButton_bhg06.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg06, self.checkBox_bhg06, 6+75))
        self.pushButton_bhg07.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg07, self.checkBox_bhg07, 7+75))
        self.pushButton_bhg08.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg08, self.checkBox_bhg08, 8+75))
        self.pushButton_bhg09.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg09, self.checkBox_bhg09, 9+75))
        self.pushButton_bhg10.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg10, self.checkBox_bhg10, 10+75))
        self.pushButton_bhg11.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg11, self.checkBox_bhg11, 11+75))
        self.pushButton_bhg12.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg12, self.checkBox_bhg12, 12+75))
        self.pushButton_bhg13.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg13, self.checkBox_bhg13, 13+75))
        self.pushButton_bhg14.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg14, self.checkBox_bhg14, 14+75))
        self.pushButton_bhg15.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg15, self.checkBox_bhg15, 15+75))
        self.pushButton_bhg16.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg16, self.checkBox_bhg16, 16+75))
        self.pushButton_bhg17.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg17, self.checkBox_bhg17, 17+75))
        self.pushButton_bhg18.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg18, self.checkBox_bhg18, 18+75))
        self.pushButton_bhg19.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg19, self.checkBox_bhg19, 19+75))
        self.pushButton_bhg20.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg20, self.checkBox_bhg20, 20+75))
        self.pushButton_bhg21.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg21, self.checkBox_bhg21, 21+75))
        self.pushButton_bhg22.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg22, self.checkBox_bhg22, 22+75))
        self.pushButton_bhg23.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg23, self.checkBox_bhg23, 23+75))
        self.pushButton_bhg24.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg24, self.checkBox_bhg24, 24+75))
        self.pushButton_bhg25.clicked.connect(
            lambda: self.set_pushButton_det_n(self.pushButton_bhg75, self.checkBox_bhg75, 25+75))





        #radio button connect
        '''
        self.LCradiobtn.toggled.connect(lambda: self.set_plottype(self.LCradiobtn))
        self.LCradiobtn.toggle()
        self.Edeposradiobtn.toggled.connect(lambda: self.set_plottype(self.Edeposradiobtn))
        '''
        # plot all/clear all
        self.pushButton_plot.clicked.connect(lambda: self.set_plottype('LC'))
        self.pushButton_plot.clicked.connect(self.set_pushButton_pic)
        #self.pushButton_plotsum.clicked.connect(self.set_pushButton_pic)
        self.pushButton_applyall.clicked.connect(self.set_pushButton_all)
        self.pushButton_clearall.clicked.connect(self.set_pushButton_clear)

        #net/full/BG Edepos display
        self.pushButton_netE.clicked.connect(lambda: self.EdeposDis( 'netEdepos'))
        self.pushButton_fullE.clicked.connect(lambda: self.EdeposDis('fullEdepos'))
        self.pushButton_BGE.clicked.connect(lambda: self.EdeposDis('BGEdepos'))



        

        
        

    def set_pushButton_det_n(self, pushButton_det_n, checkbox_n, value_n):
        print('set_pushButton_det_n.isChecked()' +str(pushButton_det_n.isChecked()) )
        if pushButton_det_n.isChecked():
            #label_n.setStyleSheet("color:#FF7500")
            #label_n.setStyleSheet("color:#e50000")
            checkbox_n.toggle()
            self.lineEdit.setText('detID: '+str(value_n))
            glv.detID_currentselected = value_n-1 #for det index in list
            print("value_n"+str(value_n))
            self.signal_multilc_plot_current_choice.emit('plot')
            print('glv.detID_selected' +str(glv.detID_selected))
            self.select_dets=[x+1 for x in glv.detID_selected]
            print('self.select_dets' +str(self.select_dets))
            if value_n not in self.select_dets:
                self.select_dets.append(value_n)
                glv.detID_selected.append(value_n-1)#for det index in list
                print('after add glv.detID_selected' +str(glv.detID_selected))
                self.select_dets.sort()
            self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
            #self.plainTextEdit.setPlainText(str(glv.detID_selected)[1:-1])
        else:
            #label_n.setStyleSheet("color:black")
            checkbox_n.toggle()
            self.select_dets=[x+1 for x in glv.detID_selected]
            if value_n in self.select_dets:
                self.select_dets.remove(value_n)
                print('before remove glv.detID_selected' +str(glv.detID_selected))
                glv.detID_selected.remove(value_n-1)#for det index in list
                print('after remove glv.detID_selected' +str(glv.detID_selected))
                self.select_dets.sort()
            self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
            #self.plainTextEdit.setPlainText(str(glv.detID_selected)[1:-1])
        return



    def set_pushButton_all(self):
        print('set_pushButton_all') 
        currentsheet=self.tabWidget.currentIndex()
        self.select_dets=[x+1 for x in glv.detID_selected]
        ''' a low '''
        if currentsheet == 0:
           self.select_dets.extend([x+1 for x in range(glv.Ndetec_tot)])
           self.select_dets=list(set(self.select_dets)) # remove repeated elements
           self.select_dets.sort()
           glv.detID_selected=[x-1 for x in self.select_dets]
           #self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           #self.plainTextEdit.setPlainText(str(glv.detID_selected)[1:-1])
           self.pushButton_alg01.setChecked(True)
           self.pushButton_alg02.setChecked(True)
           self.pushButton_alg03.setChecked(True)
           self.pushButton_alg04.setChecked(True)
           self.pushButton_alg05.setChecked(True)
           self.pushButton_alg06.setChecked(True)
           self.pushButton_alg07.setChecked(True)
           self.pushButton_alg08.setChecked(True)
           self.pushButton_alg09.setChecked(True)
           self.pushButton_alg10.setChecked(True)
           self.pushButton_alg11.setChecked(True)
           self.pushButton_alg12.setChecked(True)
           self.pushButton_alg13.setChecked(True)
           self.pushButton_alg14.setChecked(True)
           self.pushButton_alg15.setChecked(True)
           self.pushButton_alg16.setChecked(True)
           self.pushButton_alg17.setChecked(True)
           self.pushButton_alg18.setChecked(True)
           self.pushButton_alg19.setChecked(True)
           self.pushButton_alg20.setChecked(True)
           self.pushButton_alg21.setChecked(True)
           self.pushButton_alg22.setChecked(True)
           self.pushButton_alg23.setChecked(True)
           self.pushButton_alg24.setChecked(True)
           self.pushButton_alg25.setChecked(True)


           self.checkBox_alg01.setChecked(True)
           self.checkBox_alg02.setChecked(True)
           self.checkBox_alg03.setChecked(True)
           self.checkBox_alg04.setChecked(True)
           self.checkBox_alg05.setChecked(True)
           self.checkBox_alg06.setChecked(True)
           self.checkBox_alg07.setChecked(True)
           self.checkBox_alg08.setChecked(True)
           self.checkBox_alg09.setChecked(True)
           self.checkBox_alg10.setChecked(True)
           self.checkBox_alg11.setChecked(True)
           self.checkBox_alg12.setChecked(True)
           self.checkBox_alg13.setChecked(True)
           self.checkBox_alg14.setChecked(True)
           self.checkBox_alg15.setChecked(True)
           self.checkBox_alg16.setChecked(True)
           self.checkBox_alg17.setChecked(True)
           self.checkBox_alg18.setChecked(True)
           self.checkBox_alg19.setChecked(True)
           self.checkBox_alg20.setChecked(True)
           self.checkBox_alg21.setChecked(True)
           self.checkBox_alg22.setChecked(True)
           self.checkBox_alg23.setChecked(True)
           self.checkBox_alg24.setChecked(True)
           self.checkBox_alg25.setChecked(True)
        ''' a high '''
        if currentsheet == 1:
           self.select_dets.extend([x+1+glv.Ndetec_tot for x in range(glv.Ndetec_tot)])
           self.select_dets=list(set(self.select_dets)) # remove repeated elements
           self.select_dets.sort()
           glv.detID_selected=[x-1 for x in self.select_dets]
           #self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           #self.plainTextEdit.setPlainText(str(glv.detID_selected)[1:-1])
           self.pushButton_ahg01.setChecked(True)
           self.pushButton_ahg02.setChecked(True)
           self.pushButton_ahg03.setChecked(True)
           self.pushButton_ahg04.setChecked(True)
           self.pushButton_ahg05.setChecked(True)
           self.pushButton_ahg06.setChecked(True)
           self.pushButton_ahg07.setChecked(True)
           self.pushButton_ahg08.setChecked(True)
           self.pushButton_ahg09.setChecked(True)
           self.pushButton_ahg10.setChecked(True)
           self.pushButton_ahg11.setChecked(True)
           self.pushButton_ahg12.setChecked(True)
           self.pushButton_ahg13.setChecked(True)
           self.pushButton_ahg14.setChecked(True)
           self.pushButton_ahg15.setChecked(True)
           self.pushButton_ahg16.setChecked(True)
           self.pushButton_ahg17.setChecked(True)
           self.pushButton_ahg18.setChecked(True)
           self.pushButton_ahg19.setChecked(True)
           self.pushButton_ahg20.setChecked(True)
           self.pushButton_ahg21.setChecked(True)
           self.pushButton_ahg22.setChecked(True)
           self.pushButton_ahg23.setChecked(True)
           self.pushButton_ahg24.setChecked(True)
           self.pushButton_ahg25.setChecked(True)


           self.checkBox_ahg01.setChecked(True)
           self.checkBox_ahg02.setChecked(True)
           self.checkBox_ahg03.setChecked(True)
           self.checkBox_ahg04.setChecked(True)
           self.checkBox_ahg05.setChecked(True)
           self.checkBox_ahg06.setChecked(True)
           self.checkBox_ahg07.setChecked(True)
           self.checkBox_ahg08.setChecked(True)
           self.checkBox_ahg09.setChecked(True)
           self.checkBox_ahg10.setChecked(True)
           self.checkBox_ahg11.setChecked(True)
           self.checkBox_ahg12.setChecked(True)
           self.checkBox_ahg13.setChecked(True)
           self.checkBox_ahg14.setChecked(True)
           self.checkBox_ahg15.setChecked(True)
           self.checkBox_ahg16.setChecked(True)
           self.checkBox_ahg17.setChecked(True)
           self.checkBox_ahg18.setChecked(True)
           self.checkBox_ahg19.setChecked(True)
           self.checkBox_ahg20.setChecked(True)
           self.checkBox_ahg21.setChecked(True)
           self.checkBox_ahg22.setChecked(True)
           self.checkBox_ahg23.setChecked(True)
           self.checkBox_ahg24.setChecked(True)
           self.checkBox_ahg25.setChecked(True)

        ''' b low '''
        if currentsheet == 2:
           self.select_dets.extend([x+1+glv.Ndetec_tot*2 for x in range(glv.Ndetec_tot)])
           self.select_dets=list(set(self.select_dets)) # remove repeated elements
           self.select_dets.sort()
           glv.detID_selected=[x-1  for x in self.select_dets]
           #self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           self.pushButton_blg01.setChecked(True)
           self.pushButton_blg02.setChecked(True)
           self.pushButton_blg03.setChecked(True)
           self.pushButton_blg04.setChecked(True)
           self.pushButton_blg05.setChecked(True)
           self.pushButton_blg06.setChecked(True)
           self.pushButton_blg07.setChecked(True)
           self.pushButton_blg08.setChecked(True)
           self.pushButton_blg09.setChecked(True)
           self.pushButton_blg10.setChecked(True)
           self.pushButton_blg11.setChecked(True)
           self.pushButton_blg12.setChecked(True)
           self.pushButton_blg13.setChecked(True)
           self.pushButton_blg14.setChecked(True)
           self.pushButton_blg15.setChecked(True)
           self.pushButton_blg16.setChecked(True)
           self.pushButton_blg17.setChecked(True)
           self.pushButton_blg18.setChecked(True)
           self.pushButton_blg19.setChecked(True)
           self.pushButton_blg20.setChecked(True)
           self.pushButton_blg21.setChecked(True)
           self.pushButton_blg22.setChecked(True)
           self.pushButton_blg23.setChecked(True)
           self.pushButton_blg24.setChecked(True)
           self.pushButton_blg25.setChecked(True)


           self.checkBox_blg01.setChecked(True)
           self.checkBox_blg02.setChecked(True)
           self.checkBox_blg03.setChecked(True)
           self.checkBox_blg04.setChecked(True)
           self.checkBox_blg05.setChecked(True)
           self.checkBox_blg06.setChecked(True)
           self.checkBox_blg07.setChecked(True)
           self.checkBox_blg08.setChecked(True)
           self.checkBox_blg09.setChecked(True)
           self.checkBox_blg10.setChecked(True)
           self.checkBox_blg11.setChecked(True)
           self.checkBox_blg12.setChecked(True)
           self.checkBox_blg13.setChecked(True)
           self.checkBox_blg14.setChecked(True)
           self.checkBox_blg15.setChecked(True)
           self.checkBox_blg16.setChecked(True)
           self.checkBox_blg17.setChecked(True)
           self.checkBox_blg18.setChecked(True)
           self.checkBox_blg19.setChecked(True)                                                                                 
           self.checkBox_blg20.setChecked(True)
           self.checkBox_blg21.setChecked(True)
           self.checkBox_blg22.setChecked(True)
           self.checkBox_blg23.setChecked(True)
           self.checkBox_blg24.setChecked(True)
           self.checkBox_blg25.setChecked(True)
        ''' B high '''
        if currentsheet == 3:
           self.select_dets.extend([x+1+glv.Ndetec_tot*3 for x in range(glv.Ndetec_tot)])
           self.select_dets=list(set(self.select_dets)) # remove repeated elements
           self.select_dets.sort()
           glv.detID_selected=[x-1 for x in self.select_dets]
           #self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           self.pushButton_bhg01.setChecked(True)
           self.pushButton_bhg02.setChecked(True)
           self.pushButton_bhg03.setChecked(True)
           self.pushButton_bhg04.setChecked(True)
           self.pushButton_bhg05.setChecked(True)
           self.pushButton_bhg06.setChecked(True)
           self.pushButton_bhg07.setChecked(True)
           self.pushButton_bhg08.setChecked(True)
           self.pushButton_bhg09.setChecked(True)
           self.pushButton_bhg10.setChecked(True)
           self.pushButton_bhg11.setChecked(True)
           self.pushButton_bhg12.setChecked(True)
           self.pushButton_bhg13.setChecked(True)
           self.pushButton_bhg14.setChecked(True)
           self.pushButton_bhg15.setChecked(True)
           self.pushButton_bhg16.setChecked(True)
           self.pushButton_bhg17.setChecked(True)
           self.pushButton_bhg18.setChecked(True)
           self.pushButton_bhg19.setChecked(True)
           self.pushButton_bhg20.setChecked(True)
           self.pushButton_bhg21.setChecked(True)
           self.pushButton_bhg22.setChecked(True)
           self.pushButton_bhg23.setChecked(True)
           self.pushButton_bhg24.setChecked(True)
           self.pushButton_bhg25.setChecked(True)


           self.checkBox_bhg01.setChecked(True)
           self.checkBox_bhg02.setChecked(True)
           self.checkBox_bhg03.setChecked(True)
           self.checkBox_bhg04.setChecked(True)
           self.checkBox_bhg05.setChecked(True)
           self.checkBox_bhg06.setChecked(True)
           self.checkBox_bhg07.setChecked(True)
           self.checkBox_bhg08.setChecked(True)
           self.checkBox_bhg09.setChecked(True)
           self.checkBox_bhg10.setChecked(True)
           self.checkBox_bhg11.setChecked(True)
           self.checkBox_bhg12.setChecked(True)
           self.checkBox_bhg13.setChecked(True)
           self.checkBox_bhg14.setChecked(True)
           self.checkBox_bhg15.setChecked(True)
           self.checkBox_bhg16.setChecked(True)
           self.checkBox_bhg17.setChecked(True)
           self.checkBox_bhg18.setChecked(True)
           self.checkBox_bhg19.setChecked(True)                                                                                 
           self.checkBox_bhg20.setChecked(True)
           self.checkBox_bhg21.setChecked(True)
           self.checkBox_bhg22.setChecked(True)
           self.checkBox_bhg23.setChecked(True)
           self.checkBox_bhg24.setChecked(True)
           self.checkBox_bhg25.setChecked(True)

        glv.detID_selected=list(set(glv.detID_selected))
        self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
        return

    def set_pushButton_clear(self):
        currentsheet=self.tabWidget.currentIndex()
        index_firstB=0
        print('before  clear :glv.detID_selected:' +str(glv.detID_selected)) 
        if currentsheet == 0:
           glv.detID_selected=[x for x in glv.detID_selected if x>= 25]
           self.select_dets=[x+1 for x in glv.detID_selected] 
           print('in clear 0 :glv.detID_selected:' +str(glv.detID_selected)) 
           self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           self.pushButton_alg01.setChecked(False)
           self.pushButton_alg02.setChecked(False)
           self.pushButton_alg03.setChecked(False)
           self.pushButton_alg04.setChecked(False)
           self.pushButton_alg05.setChecked(False)
           self.pushButton_alg06.setChecked(False)
           self.pushButton_alg07.setChecked(False)
           self.pushButton_alg08.setChecked(False)
           self.pushButton_alg09.setChecked(False)
           self.pushButton_alg10.setChecked(False)
           self.pushButton_alg11.setChecked(False)
           self.pushButton_alg12.setChecked(False)
           self.pushButton_alg13.setChecked(False)
           self.pushButton_alg14.setChecked(False)
           self.pushButton_alg15.setChecked(False)
           self.pushButton_alg16.setChecked(False)
           self.pushButton_alg17.setChecked(False)
           self.pushButton_alg18.setChecked(False)
           self.pushButton_alg19.setChecked(False)
           self.pushButton_alg20.setChecked(False)
           self.pushButton_alg21.setChecked(False)
           self.pushButton_alg22.setChecked(False)
           self.pushButton_alg23.setChecked(False)
           self.pushButton_alg24.setChecked(False)
           self.pushButton_alg25.setChecked(False)


           self.checkBox_alg01.setChecked(False)
           self.checkBox_alg02.setChecked(False)
           self.checkBox_alg03.setChecked(False)
           self.checkBox_alg04.setChecked(False)
           self.checkBox_alg05.setChecked(False)
           self.checkBox_alg06.setChecked(False)
           self.checkBox_alg07.setChecked(False)
           self.checkBox_alg08.setChecked(False)
           self.checkBox_alg09.setChecked(False)
           self.checkBox_alg10.setChecked(False)
           self.checkBox_alg11.setChecked(False)
           self.checkBox_alg12.setChecked(False)
           self.checkBox_alg13.setChecked(False)
           self.checkBox_alg14.setChecked(False)
           self.checkBox_alg15.setChecked(False)
           self.checkBox_alg16.setChecked(False)
           self.checkBox_alg17.setChecked(False)
           self.checkBox_alg18.setChecked(False)
           self.checkBox_alg19.setChecked(False)
           self.checkBox_alg20.setChecked(False)
           self.checkBox_alg21.setChecked(False)
           self.checkBox_alg22.setChecked(False)
           self.checkBox_alg23.setChecked(False)
           self.checkBox_alg24.setChecked(False)
           self.checkBox_alg25.setChecked(False)
        if currentsheet == 1:                                                       
           glv.detID_selected=[x for x in glv.detID_selected if (x< 25 or x>=50) ]
           self.select_dets=[x+1 for x in glv.detID_selected] 
           print('in clear 1 :glv.detID_selected:' +str(glv.detID_selected)) 
           self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           self.pushButton_ahg01.setChecked(False)
           self.pushButton_ahg02.setChecked(False)
           self.pushButton_ahg03.setChecked(False)
           self.pushButton_ahg04.setChecked(False)
           self.pushButton_ahg05.setChecked(False)
           self.pushButton_ahg06.setChecked(False)
           self.pushButton_ahg07.setChecked(False)
           self.pushButton_ahg08.setChecked(False)
           self.pushButton_ahg09.setChecked(False)
           self.pushButton_ahg10.setChecked(False)
           self.pushButton_ahg11.setChecked(False)
           self.pushButton_ahg12.setChecked(False)
           self.pushButton_ahg13.setChecked(False)
           self.pushButton_ahg14.setChecked(False)
           self.pushButton_ahg15.setChecked(False)
           self.pushButton_ahg16.setChecked(False)
           self.pushButton_ahg17.setChecked(False)
           self.pushButton_ahg18.setChecked(False)
           self.pushButton_ahg19.setChecked(False)
           self.pushButton_ahg20.setChecked(False)
           self.pushButton_ahg21.setChecked(False)
           self.pushButton_ahg22.setChecked(False)
           self.pushButton_ahg23.setChecked(False)
           self.pushButton_ahg24.setChecked(False)
           self.pushButton_ahg25.setChecked(False)
                                                                              
                                                                              
           self.checkBox_ahg01.setChecked(False)
           self.checkBox_ahg02.setChecked(False)
           self.checkBox_ahg03.setChecked(False)
           self.checkBox_ahg04.setChecked(False)
           self.checkBox_ahg05.setChecked(False)
           self.checkBox_ahg06.setChecked(False)
           self.checkBox_ahg07.setChecked(False)
           self.checkBox_ahg08.setChecked(False)
           self.checkBox_ahg09.setChecked(False)
           self.checkBox_ahg10.setChecked(False)
           self.checkBox_ahg11.setChecked(False)
           self.checkBox_ahg12.setChecked(False)
           self.checkBox_ahg13.setChecked(False)
           self.checkBox_ahg14.setChecked(False)
           self.checkBox_ahg15.setChecked(False)
           self.checkBox_ahg16.setChecked(False)
           self.checkBox_ahg17.setChecked(False)
           self.checkBox_ahg18.setChecked(False)
           self.checkBox_ahg19.setChecked(False)
           self.checkBox_ahg20.setChecked(False)
           self.checkBox_ahg21.setChecked(False)
           self.checkBox_ahg22.setChecked(False)
           self.checkBox_ahg23.setChecked(False)
           self.checkBox_ahg24.setChecked(False)
           self.checkBox_ahg25.setChecked(False)

        if currentsheet == 2:
           glv.detID_selected=[x for x in glv.detID_selected if (x< 50 or x>=75)]
           self.select_dets=[x+1 for x in glv.detID_selected] 
           print('in clear 2 :glv.detID_selected:' +str(glv.detID_selected)) 
           self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           self.pushButton_blg01.setChecked(False)
           self.pushButton_blg02.setChecked(False)
           self.pushButton_blg03.setChecked(False)
           self.pushButton_blg04.setChecked(False)
           self.pushButton_blg05.setChecked(False)
           self.pushButton_blg06.setChecked(False)
           self.pushButton_blg07.setChecked(False)
           self.pushButton_blg08.setChecked(False)
           self.pushButton_blg09.setChecked(False)
           self.pushButton_blg10.setChecked(False)
           self.pushButton_blg11.setChecked(False)
           self.pushButton_blg12.setChecked(False)
           self.pushButton_blg13.setChecked(False)
           self.pushButton_blg14.setChecked(False)
           self.pushButton_blg15.setChecked(False)
           self.pushButton_blg16.setChecked(False)
           self.pushButton_blg17.setChecked(False)
           self.pushButton_blg18.setChecked(False)
           self.pushButton_blg19.setChecked(False)
           self.pushButton_blg20.setChecked(False)
           self.pushButton_blg21.setChecked(False)
           self.pushButton_blg22.setChecked(False)
           self.pushButton_blg23.setChecked(False)
           self.pushButton_blg24.setChecked(False)
           self.pushButton_blg25.setChecked(False)
                                                                        
                                                                        
           self.checkBox_blg01.setChecked(False)
           self.checkBox_blg02.setChecked(False)
           self.checkBox_blg03.setChecked(False)
           self.checkBox_blg04.setChecked(False)
           self.checkBox_blg05.setChecked(False)
           self.checkBox_blg06.setChecked(False)
           self.checkBox_blg07.setChecked(False)
           self.checkBox_blg08.setChecked(False)
           self.checkBox_blg09.setChecked(False)
           self.checkBox_blg10.setChecked(False)
           self.checkBox_blg11.setChecked(False)
           self.checkBox_blg12.setChecked(False)
           self.checkBox_blg13.setChecked(False)
           self.checkBox_blg14.setChecked(False)
           self.checkBox_blg15.setChecked(False)
           self.checkBox_blg16.setChecked(False)
           self.checkBox_blg17.setChecked(False)
           self.checkBox_blg18.setChecked(False)
           self.checkBox_blg19.setChecked(False)
           self.checkBox_blg20.setChecked(False)
           self.checkBox_blg21.setChecked(False)
           self.checkBox_blg22.setChecked(False)
           self.checkBox_blg23.setChecked(False)
           self.checkBox_blg24.setChecked(False)
           self.checkBox_blg25.setChecked(False)
        if currentsheet == 3:
           glv.detID_selected=[x for x in glv.detID_selected if x<75]
           self.select_dets=[x+1 for x in glv.detID_selected] 
           print('in clear 3 :glv.detID_selected:' +str(glv.detID_selected)) 
           self.plainTextEdit.setPlainText(str(self.select_dets)[1:-1])
           self.pushButton_bhg01.setChecked(False)
           self.pushButton_bhg02.setChecked(False)
           self.pushButton_bhg03.setChecked(False)
           self.pushButton_bhg04.setChecked(False)
           self.pushButton_bhg05.setChecked(False)
           self.pushButton_bhg06.setChecked(False)
           self.pushButton_bhg07.setChecked(False)
           self.pushButton_bhg08.setChecked(False)
           self.pushButton_bhg09.setChecked(False)
           self.pushButton_bhg10.setChecked(False)
           self.pushButton_bhg11.setChecked(False)
           self.pushButton_bhg12.setChecked(False)
           self.pushButton_bhg13.setChecked(False)
           self.pushButton_bhg14.setChecked(False)
           self.pushButton_bhg15.setChecked(False)
           self.pushButton_bhg16.setChecked(False)
           self.pushButton_bhg17.setChecked(False)
           self.pushButton_bhg18.setChecked(False)
           self.pushButton_bhg19.setChecked(False)
           self.pushButton_bhg20.setChecked(False)
           self.pushButton_bhg21.setChecked(False)
           self.pushButton_bhg22.setChecked(False)
           self.pushButton_bhg23.setChecked(False)
           self.pushButton_bhg24.setChecked(False)
           self.pushButton_bhg25.setChecked(False)
                                                                        
                                                                        
           self.checkBox_bhg01.setChecked(False)
           self.checkBox_bhg02.setChecked(False)
           self.checkBox_bhg03.setChecked(False)
           self.checkBox_bhg04.setChecked(False)
           self.checkBox_bhg05.setChecked(False)
           self.checkBox_bhg06.setChecked(False)
           self.checkBox_bhg07.setChecked(False)
           self.checkBox_bhg08.setChecked(False)
           self.checkBox_bhg09.setChecked(False)
           self.checkBox_bhg10.setChecked(False)
           self.checkBox_bhg11.setChecked(False)
           self.checkBox_bhg12.setChecked(False)
           self.checkBox_bhg13.setChecked(False)
           self.checkBox_bhg14.setChecked(False)
           self.checkBox_bhg15.setChecked(False)
           self.checkBox_bhg16.setChecked(False)
           self.checkBox_bhg17.setChecked(False)
           self.checkBox_bhg18.setChecked(False)
           self.checkBox_bhg19.setChecked(False)
           self.checkBox_bhg20.setChecked(False)
           self.checkBox_bhg21.setChecked(False)
           self.checkBox_bhg22.setChecked(False)
           self.checkBox_bhg23.setChecked(False)
           self.checkBox_bhg24.setChecked(False)
           self.checkBox_bhg25.setChecked(False)

        glv.detID_selected=[x-1 for x in self.select_dets] 
        print('after clear:glv.detID_selected' +str(glv.detID_selected))
        return

#    def set_pushButton_ok(self):
#        if self.select_dets:
#            emit_message = 'Now Dets: '+str(self.select_dets)[1:-1]+' Have Been Chosen!'
#            self.signal_filebrowse_to_status_box.emit(emit_message)
#            glv.detID_selected = self.select_dets
#            self.close()
#        else:
#            self.plainTextEdit.setPlainText('Please Select At Least One Detetor!')
#        return

    def start_multi_gui(self):
        if not self.isVisible():
            self.show()
        #self.set_pushButton_pic_initial()
    '''    
    def set_plottype(self, btn):
        self.plottype=btn.text()
    '''
    def set_plottype(self, plotType):
        self.plottype=plotType
    def  EdeposDis(self, EdeposType):
         glv.plotEdeposflag = 1
         filelist = os.listdir(glv.genfitsDir)
         list_detID=[]
         path_root = '/tmp'
         print('list_detID' +str(list_detID))
         for f in filelist:
             if 'bin' in f:
                 pass
             else:
                 if EdeposType in f:
                     if '.fits' in f:
                        list_detID.append(int(f[-8:-5]) - 1)
         if len(filelist)>0: #from netEdepos.fits
            detID_selected = list_detID
            for idetec in detID_selected:
                sidetec = str(idetec + 1)  # because idetec 1-18
                sidetec = sidetec.zfill(3)
                netfitsname = glv.genfitsDir+'netEdepos' + sidetec + '.fits'
                hdu = fits.open(netfitsname)
                glv.nettime_interval[idetec] = hdu[1].header['EXPOSURE']  # may be corrected or not, but use it after all
                Ebinwidth = glv.lEbin_width[idetec]
                glv.netEdepos[idetec] = hdu[1].data.field(1) /glv.nettime_interval[idetec] / Ebinwidth
                glv.netEdepos_err[idetec] = hdu[1].data.field(2) / glv.nettime_interval[idetec] / Ebinwidth

                fullfitsname = glv.genfitsDir + 'fullEdepos' + sidetec + '.fits'
                hdu2 = fits.open(fullfitsname)
                glv.fulltime_interval[idetec] = hdu2[1].header['EXPOSURE']
                glv.fullEdepos[idetec] = hdu2[1].data.field(1) / glv.fulltime_interval[idetec]/Ebinwidth
                glv.fullEdepos_err[idetec] = hdu2[1].data.field(2) / glv.fulltime_interval[idetec]/Ebinwidth

                BGfitsname = glv.genfitsDir + 'BGEdepos' + sidetec + '.fits'
                hdu3 = fits.open(BGfitsname)
                glv.BGtime_interval[idetec] = hdu2[1].header['EXPOSURE']
                glv.BGEdepos[idetec] = hdu3[1].data.field(1) / glv.BGtime_interval[idetec]/Ebinwidth
                glv.BGEdepos_err[idetec] = hdu3[1].data.field(2) / glv.BGtime_interval[idetec]/Ebinwidth

                hdu.close()
                hdu2.close()
                hdu3.close()
         for i in detID_selected:
             Edepos = []
             Edeposerr = []
             if EdeposType == 'netEdepos':
                 Edepos = glv.netEdepos[i]
                 Edeposerr = glv.netEdepos_err[i]
             elif EdeposType == 'fullEdepos':
                 Edepos = glv.fullEdepos[i]
                 Edeposerr = glv.fullEdepos_err[i]
             elif EdeposType == 'BGEdepos':
                 Edepos = glv.BGEdepos[i]
                 Edeposerr = glv.BGEdepos_err[i]
             if glv.satLabel == 'j' or glv.satLabel == 'a':
                file_name = 'GECAM_'+ EdeposType + str(i).zfill(2) + '.png'
                file_path = os.path.join(path_root, file_name)
                print('idetec in set_pushbutton_pic' + str(i))
                print(file_path)
                GUI_multi_lc_plot.MultiPlot(glv.lEbin_mid[i], Edepos, Edeposerr, file_path)
             elif glv.satLabel == 'b':
                  file_name = 'GECAM_' +EdeposType + str(i).zfill(2) + '.png'
                  file_path = os.path.join(path_root, file_name)
                  print('idetec in set_pushbutton_pic' + str(i))
                  GUI_multi_lc_plot.MultiPlot(glv.lEbin_mid[i], glv.netEdepos[i], glv.netEdepos_err[i], file_path)
                  print(file_path)
         self.plottype = EdeposType
         self.set_pushButton_pic()


    def set_pushButton_pic(self):
        path_root = '/tmp'
        plottype=self.plottype
        #if glv.plotLCflag ==0 and plottype=='LC':
        #   glv.plotEdeposflag = 0
        if plottype == 'LC':
           #print('-------------------------------------------------------glv.satLabel' +str(glv.satLabel))
           #print('-------------------------------------------------------len(glv.ltime)' +str(len(glv.ltime)))
           for i in range(len(glv.ltime)):
               if glv.satLabel == 'j' or glv.satLabel =='a':
                  file_name = 'GECAM_LC'+str(i).zfill(2)+'.png'
                  file_path = os.path.join(path_root, file_name)                
                  print('idetec in set_pushbutton_pic' + str(i))
                  GUI_multi_lc_plot.MultiPlot(glv.ltime[i], glv.lcounts_perT[i], glv.lcounts_perT_err[i], file_path)
                  print(file_path)
               elif glv.satLabel == 'b':
                  if i<50:
                    continue
                  file_name = 'GECAM_LC'+str(i).zfill(2)+'.png'
                  file_path = os.path.join(path_root, file_name)             
                  print('idetec in set_pushbutton_pic' + str(i))
                  GUI_multi_lc_plot.MultiPlot(glv.ltime[i], glv.lcounts_perT[i], glv.lcounts_perT_err[i], file_path)
                  print(file_path)

               if i== len(glv.ltime)-1:
                  glv.plotLCflag=1
        #print('glv.satLabel' +str(glv.satLabel))
        if glv.satLabel == 'j' or glv.satLabel =='a':
              self.pushButton_alg01.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '00.png)}')
              self.pushButton_alg02.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '01.png)}')
              self.pushButton_alg03.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '02.png)}')
              self.pushButton_alg04.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '03.png)}')
              self.pushButton_alg05.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '04.png)}')
              self.pushButton_alg06.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '05.png)}')
              self.pushButton_alg07.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '06.png)}')
              self.pushButton_alg08.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '07.png)}')
              self.pushButton_alg09.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '08.png)}')
              self.pushButton_alg10.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '09.png)}')
              self.pushButton_alg11.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '10.png)}')
              self.pushButton_alg12.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '11.png)}')
              self.pushButton_alg13.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '12.png)}')
              self.pushButton_alg14.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '13.png)}')
              self.pushButton_alg15.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '14.png)}')
              self.pushButton_alg16.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '15.png)}')
              self.pushButton_alg17.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '16.png)}')
              self.pushButton_alg18.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '17.png)}')
              self.pushButton_alg19.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '18.png)}')
              self.pushButton_alg20.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '19.png)}')
              self.pushButton_alg21.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '20.png)}')
              self.pushButton_alg22.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '21.png)}')
              self.pushButton_alg23.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '22.png)}')
              self.pushButton_alg24.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '23.png)}')
              self.pushButton_alg25.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '24.png)}')


           
              self.pushButton_ahg01.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '25.png)}')
              self.pushButton_ahg02.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '26.png)}')
              self.pushButton_ahg03.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '27.png)}')
              self.pushButton_ahg04.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '28.png)}')
              self.pushButton_ahg05.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '29.png)}')
              self.pushButton_ahg06.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '30.png)}')
              self.pushButton_ahg07.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '31.png)}')
              self.pushButton_ahg08.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '32.png)}')
              self.pushButton_ahg09.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '33.png)}')
              self.pushButton_ahg10.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '34.png)}')
              self.pushButton_ahg11.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '35.png)}')
              self.pushButton_ahg12.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '36.png)}')
              self.pushButton_ahg13.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '37.png)}')
              self.pushButton_ahg14.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '38.png)}')
              self.pushButton_ahg15.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '39.png)}')
              self.pushButton_ahg16.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '40.png)}')
              self.pushButton_ahg17.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '41.png)}')
              self.pushButton_ahg18.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '42.png)}')
              self.pushButton_ahg19.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '43.png)}')
              self.pushButton_ahg20.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '44.png)}')
              self.pushButton_ahg21.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '45.png)}')
              self.pushButton_ahg22.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '46.png)}')
              self.pushButton_ahg23.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '47.png)}')
              self.pushButton_ahg24.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '48.png)}')
              self.pushButton_ahg25.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '49.png)}')

        if glv.satLabel == 'j' or glv.satLabel =='b':
              self.pushButton_blg01.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '50.png)}')
              self.pushButton_blg02.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '51.png)}')
              self.pushButton_blg03.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '52.png)}')
              self.pushButton_blg04.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '53.png)}')
              self.pushButton_blg05.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '54.png)}')
              self.pushButton_blg06.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '55.png)}')
              self.pushButton_blg07.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '56.png)}')
              self.pushButton_blg08.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '57.png)}')
              self.pushButton_blg09.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '58.png)}')
              self.pushButton_blg10.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '59.png)}')
              self.pushButton_blg11.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '60.png)}')
              self.pushButton_blg12.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '61.png)}')
              self.pushButton_blg13.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '62.png)}')
              self.pushButton_blg14.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '63.png)}')
              self.pushButton_blg15.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '64.png)}')
              self.pushButton_blg16.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '65.png)}')
              self.pushButton_blg17.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '66.png)}')
              self.pushButton_blg18.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '67.png)}')
              self.pushButton_blg19.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '68.png)}')
              self.pushButton_blg20.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '69.png)}')
              self.pushButton_blg21.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '70.png)}')
              self.pushButton_blg22.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '71.png)}')
              self.pushButton_blg23.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '72.png)}')
              self.pushButton_blg24.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '73.png)}')
              self.pushButton_blg25.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '74.png)}')



              self.pushButton_bhg01.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '75.png)}')
              self.pushButton_bhg02.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '76.png)}')
              self.pushButton_bhg03.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '77.png)}')
              self.pushButton_bhg04.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '78.png)}')
              self.pushButton_bhg05.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '79.png)}')
              self.pushButton_bhg06.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '80.png)}')
              self.pushButton_bhg07.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '81.png)}')
              self.pushButton_bhg08.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '82.png)}')
              self.pushButton_bhg09.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '83.png)}')
              self.pushButton_bhg10.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '84.png)}')
              self.pushButton_bhg11.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '85.png)}')
              self.pushButton_bhg12.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '86.png)}')
              self.pushButton_bhg13.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '87.png)}')
              self.pushButton_bhg14.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '88.png)}')
              self.pushButton_bhg15.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '89.png)}')
              self.pushButton_bhg16.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '90.png)}')
              self.pushButton_bhg17.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '91.png)}')
              self.pushButton_bhg18.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '92.png)}')
              self.pushButton_bhg19.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '93.png)}')
              self.pushButton_bhg20.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '94.png)}')
              self.pushButton_bhg21.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '95.png)}')
              self.pushButton_bhg22.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '96.png)}')
              self.pushButton_bhg23.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '97.png)}')
              self.pushButton_bhg24.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '98.png)}')
              self.pushButton_bhg25.setStyleSheet('QPushButton{background-image:url(/tmp/GECAM_'+plottype + '99.png)}')

        return


