import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from tools import gen1Dhist_GECAM, proerr_GECAM, getindex_GECAM, toggle_GECAM,chisq_ndof_GECAM
from .polymodel_GECAM import *
from astropy.io import fits
import numpy as np
from scipy.optimize import curve_fit
import math
import time


class fitBG(object):
      def __init__(self):
          '''
          input para
          '''
          self.corx_BG=[100,200]
          self.order=int(1)
          self.tbins=300
          self.tbinwidth=1.0
          self.ebins=128
          self.ebin_edges=[]
          self.het2D=[]
          self.fulltime=[]
          self.lte_detID=[]

          '''
          output para
          '''
          #self.popt=[]
          #self.pcov=[]
          #self.goodness=[] 
          
      def setfitBGpara(self,
                       order,
                       corx_BG,
                       tbins,
                       tbinwidth,
                       ebins,
                       ebin_edges,
                       lte_detID):
          self.order=order
          self.corx_BG=corx_BG
          self.tbins=tbins
          self.tbinwidth=tbinwidth
          self.ebins=ebins
          self.ebin_edges=ebin_edges
          self.lte_detID=lte_detID

      def getindex_lt(self, lx, tbinwidth):
          return getindex_GECAM.getindex_lt(lx, tbinwidth)
      def getindex_le(self, *args,**kwargs):  
          return getindex_GECAM.getindex_le( *args,**kwargs)
      def shape2Dhist(self, *args,**kwargs): 
          return toggle_GECAM.shape2Dhist(*args,**kwargs)
      def proerr(self, *args,**kwargs):
          return proerr_GECAM.proerr(*args,**kwargs)
      def chi_ndof(self, *args,**kwargs):
          return chisq_ndof_GECAM.chi_ndof(*args,**kwargs)
      def calgoodness(self, time, BG_corx, order, popt, pcov, y_measured, yerr_measured):
          polyfunc=np.poly1d(popt) #use fitted para to shape a polynomial
          polyinteg=np.polyint(polyfunc) #the function of integation of BG polynomial
          num=polyinteg(BG_corx[1])+polyinteg(BG_corx[3])-polyinteg(BG_corx[0])-polyinteg(BG_corx[2]) #integration of BG range
          estinum=np.array([polyfunc(x) for x in time]) #in x-axis time,BG the fitted value list
          '''
          print('in cal goodness, estinum' +str(estinum))
          print('in cal goodness, ymeasured' +str(y_measured))
          print('in cal goodness, yerr_measured' +str(yerr_measured))
          print('in cal goodness, order' + str(order))
          print('in cal goodness, binnum' + str(len(time)))
          print('in cal goodness, chi_ndof' +str(self.chi_ndof(order,len(time), estinum, y_measured, yerr_measured)))
          '''
          chi_ndof= self.chi_ndof(order,len(time), estinum, y_measured, yerr_measured)

          if np.sum(y_measured)==0 :
             chi_ndof =1

          #in fact there is a coefficient between num and esti
          #err=math.sqrt(self.proerr(BG_corx, order, pcov))
          #calculate goodness of fit
          return estinum, chi_ndof

#      def fit_selbestgoodness(self, bgtime, bgcount,corx_BG):
#          tmpgoodness=9999.0
#          tmppopt=[]
#          tmppcov=[] 
#          order=0
#          tmpestinum=[]
#          for iorder in range(3):
#              popt, pcov=[],[]
#              #if iorder==3:
#              #  popt,pcov=curve_fit(poly3,bgtime,bgcount)
#              if iorder==2:
#                popt,pcov=curve_fit(poly2,bgtime,bgcount)
#              elif iorder==1:
#                popt,pcov=curve_fit(poly1,bgtime,bgcount)
#              elif iorder==0:
#                popt,pcov=curve_fit(poly0,bgtime,bgcount)
#              estinum, goodness=self.calgoodness(bgtime, corx_BG, iorder, popt, pcov, bgcount, bgcount**0.5)
#              if goodness<tmpgoodness:
#                 tmpgoodness=goodness
#                 tmppopt=popt
#                 tmppcov=pcov
#                 order=iorder
#                 tmpestinum =estinum
#          return order, tmppopt, tmppcov, tmpgoodness, tmpestinum

      def sliceBG(self, corx_BG, tbins, tbinwidth, ebin_edges):
          BGindex=self.getindex_lt(corx_BG, tbinwidth)
          het2D, fulltime=self.shape2Dhist(self.lte_detID, tbins, tbinwidth, ebin_edges)
          '''
          cal bg slice time
          '''
          bgst1=fulltime[BGindex[0]:BGindex[1]+1].tolist()
          bgst2=fulltime[BGindex[2]:BGindex[3]+1].tolist()
          bgst1.extend(bgst2)

          '''
          cal count  and count err
          '''
          counts_perT=np.sum(het2D, axis=0) #counts projection on t
          bgcounts1_perT=counts_perT[BGindex[0]:BGindex[1]+1].tolist()
          bgcounts2_perT=counts_perT[BGindex[2]:BGindex[3]+1].tolist()
          bgcounts1_perT.extend(bgcounts2_perT)
          bgcounts1_perT=np.array(bgcounts1_perT)
          #return het2D, st1, count, count_err 
          return het2D, np.array(bgst1), bgcounts1_perT,(bgcounts1_perT)**0.5 

          '''
          fitBG with total ebins
          '''

      def fitBG_totEbin(self):
          '''
          init para
          '''
          corx_BG= self.corx_BG
          tbins= self.tbins
          tbinwidth= self.tbinwidth
          ebins= self.ebins
          ebin_edges= self.ebin_edges
          order=self.order

          het2D, bgtime, bgcounts, bgcounts_err = self.sliceBG(corx_BG, tbins, tbinwidth, ebin_edges)
          if order == 3:
              popt, pcov = curve_fit(poly3, bgtime, bgcounts)
          elif order == 2:
              popt, pcov = curve_fit(poly2, bgtime, bgcounts)
          elif order == 1:
              popt, pcov = curve_fit(poly1, bgtime, bgcounts)
          elif order == 0:
              popt, pcov = curve_fit(poly0, bgtime, bgcounts)
          return  popt, pcov

          '''
          fit BG with perEbin
          '''  
       
      def fitBG_perEbin(self):
           '''
           init para
           '''
           corx_BG= self.corx_BG
           tbins= self.tbins
           tbinwidth= self.tbinwidth
           ebins= self.ebins
           ebin_edges= self.ebin_edges
           order=self.order

           '''
           time
           '''
           starttime=time.time() 
           '''
           data to fit
           ''' 
           het2D, bgtime, bgcounts, bgcounts_err = self.sliceBG(corx_BG, tbins, tbinwidth, ebin_edges) 
           let2D=het2D.tolist()
           BGindex=self.getindex_lt(corx_BG,tbinwidth)
           polysum=np.poly1d([])
           bgpoly=[]
           bgpcov=[]
           bggoodness=[]
           bgestinum=[]
           #'''
           #decide order
           #'''
           #order, popt, pcov, goodness, estinumtot = self.fitBG_totEbin()
       
           for i in range(ebins):
              bg_edepos_i=let2D[i]
              lbgcount=bg_edepos_i[BGindex[0]:BGindex[1]+1]
              lbgcount2=bg_edepos_i[BGindex[2]:BGindex[3]+1]
              lbgcount.extend(lbgcount2)
              bgcount=np.array(lbgcount)
              # use a best goodness fit
              #popt,pcov, goodness= self.fit_selbestgoodness(bgtime, bgcount,corx_BG )
              if order==3:
                popt,pcov=curve_fit(poly3,bgtime,bgcount)
              elif order==2:
                popt,pcov=curve_fit(poly2,bgtime,bgcount)
              elif order==1:
                popt,pcov=curve_fit(poly1,bgtime,bgcount)
              elif order==0:
                popt,pcov=curve_fit(poly0,bgtime,bgcount)
              estinum, goodness=self.calgoodness(bgtime, corx_BG, order, popt, pcov, bgcount, bgcount**0.5)
              bgpoly.append(popt) 
              bgpcov.append(pcov)
              bggoodness.append(goodness)
              bgestinum.append(estinum) #size 256
              polyfunc_i=np.poly1d(popt)
              polysum=polyfunc_i+polysum
           lesti=[polysum(x) for x in bgtime.tolist()]
       
           #self.bgpoly, self.bgpcov, self.goodness = bgpoly, bgpcov, goodness
           #return the bgpoly per ebin, bgpcov per ebin
           return  order, bgpoly, bgpcov, np.array(bggoodness) , bgtime,bgcounts, bgcounts_err, np.array(bgestinum), np.array(lesti)
