import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import globalvar_GECAM
from .fitBG_GECAM import *
from .genprojection_GECAM import genProjection
from .genfits_forfitBG_GECAM import *
from tools import toggle_GECAM, angle_inSat_GECAM
import numpy as np


def BGfitprocess(detID_selected,
                 order,
                 corx_BG,
                 corx_ROI,
                 tbins,tbinwidth,ebins, ebin_edges,
                 lte,
                 genfitsDir,
                 rspoutputdir,
                 deadtime,
                 taskID,
                 satLabel='a'):
    '''
    BGfit
    '''
    bgpoly_tot=[]
    bgpcov_tot=[]
    bggoodness_tot=[]
    bgpolyorder_tot=[]
    bgestinum_tot=[]
    bgtime_tot=[]
    print('in BGfit process: detID_selected' +str(detID_selected))
    print('in BGfit process: len(lte)' + str(len(lte)))
    for idetec in detID_selected:
        #idx=detID_selected.index(idetec)
        BGfit=fitBG() 
        BGfit.setfitBGpara(order,corx_BG,tbins,tbinwidth, ebins, ebin_edges, lte[idetec])
        bgpolyorder, bgpoly, bgpcov, goodness, bgtime,bgcounts, bgcounts_err, bgestinum, esti_t =BGfit.fitBG_perEbin()
        bgpolyorder_tot.append(bgpolyorder)
        bgpoly_tot.append(bgpoly)
        bgpcov_tot.append(bgpcov) 
        bggoodness_tot.append(goodness)
        bgtime_tot.append(bgtime)
        bgestinum_tot.append(np.sum(bgestinum, axis= 0))

#    ''' gen multi LC bg plot'''
#    lcounts_perT= globalvar_GECAM.glv.getVal('lcounts_perT')
#    lcounts_perT_err= globalvar_GECAM.glv.getVal('lcounts_perT_err')
#    ltime= globalvar_GECAM.glv.getVal('ltime')
#    ''' plotLC'''
#    countrate_perT=np.array(lcounts_perT)/tbinwidth
#    countrate_perT_err=np.array(lcounts_perT_err)/tbinwidth
#    atime=np.array(ltime)
#    at=[]
#    ct=[]
#    cterr=[]
#    bgt=[]
#    bgest=[]
#    satstr= satLabel
#    print('plotbg satLabel:' +str(satLabel))
#    if satLabel =='a' or (satLabel=='b' and len(atime)==50):
#        at = atime[0:50]
#        ct = countrate_perT[0:50]
#        cterr = countrate_perT_err[0:50]
#        bgt = bgtime_tot
#        bgest = np.array(bgestinum_tot)
#    else:
#        if satstr == 'j':
#           satstr ='b'
#        at = atime[50:100]
#        ct = countrate_perT[50:100]
#        cterr = countrate_perT_err[50:100]
#        bgt = bgtime_tot
#        bgest = np.array(bgestinum_tot)
#    print('len(at[0]):'+str(len(at[0])))
#    print('len(bgt[0]):' + str(len(bgest[0])))
#
#    bgplot=genpic_GECAM.genbgplot(at[0:25], ct[0:25], cterr[0:25], bgt[0:25]
#                     ,bgest[0:25]/tbinwidth,
#                     'LC',
#                     'LC and BG curve, low gain , sat'+satstr.upper()+taskID,
#                     rspoutputdir,
#                     'LCandBG_multi_lowGain_sat' +satstr.upper()+'_'+str(taskID)+'.png',
#                     'time(s)',
#                     'count rate($s^{-1}$)',
#                     5,
#                     5)
#    bgplot.plotmultibgcurve()
#
#
#    bgplot=genpic_GECAM.genbgplot(at[25:50], ct[25:50], cterr[25:50], bgt[25:50]
#                     ,bgest[25:50]/tbinwidth,
#                     'LC',
#                     'LC and BG curve, high gain , sat' +satstr.upper()+taskID,
#                     rspoutputdir,
#                     'LCandBG_multi_highGain_sat'+satstr.upper()+'_'+str(taskID)+'.png',
#                     'time(s)',
#                     'count rate($s^{-1}$)',
#                     5,
#                     5)
#    bgplot.plotmultibgcurve()
    
    '''
    gen projection data on ROI
    '''
    genprojection=genProjection()
    genprojection.setpara(detID_selected,
                          lte,
                          corx_ROI,
                          corx_BG,
                          tbins, tbinwidth,ebins, ebin_edges,
                          bgpoly_tot,
                          bgpcov_tot,
                          bgpolyorder_tot,
                          deadtime)
    netEcounts, \
    netEcounts_err,\
    nettime_interval,\
    fullEcounts,\
    fullEcounts_err,\
    fulltime_interval, \
    BGEcounts,BGEcounts_err, \
    BGtime_interval=genprojection.genEdepos_projection()
    print('----------------BGtime_interval' +str(BGtime_interval))
    print('----------------fulltime_interval' + str(fulltime_interval))
    print('----------------nettime_interval' + str(nettime_interval))

    '''
    gen fits file
    '''  
    genfitsforfitBG(detID_selected,
                    netEcounts,
                    netEcounts_err,
                    nettime_interval,
                    fullEcounts,
                    fullEcounts_err,
                    fulltime_interval,
                    BGEcounts,
                    BGEcounts_err,
                    BGtime_interval,
                    ebins,
                    genfitsDir,
                    iTR=False)
    return bggoodness_tot
#20200306    '''gen net/BG fits plot'''
#20200306    lEbinmid= globalvar_GECAM.glv.getVal("lEbin_mid")
#20200306    emid=[]
#20200306    satstr = satLabel
#20200306    if satLabel =='a' or (satLabel=='b' and len(atime)==50):
#20200306         emid= lEbinmid[0:50]
#20200306    else:
#20200306         if satstr =='j':
#20200306             satstr='b'
#20200306         emid= lEbinmid[50:100]
#20200306    ebinw=globalvar_GECAM.glv.getVal('lEbin_width')
#20200306    denom=(corx_ROI[1]-corx_ROI[0])*np.array(ebinw[0])
#20200306
#20200306    #print('-----------------------emid' + str(len(emid)))
#20200306    #print('------------------denom'+str(denom.shape))
#20200306    #print('------netEcounts[0:25]' +str((np.array(netEcounts[0:25])/denom).shape))
#20200306    #print('-----netEcounts[0:25]' + str((np.array(netEcounts[0:25])/denom).shape))
#20200306    #print('----netEcounts_err[0:25]' + str((np.array(netEcounts_err[0:25])/denom).shape))
#20200306
#20200306    netfits_lowGain_satA = genpic_GECAM.genplot(
#20200306                           X=emid[0:25],
#20200306                           Y=np.array(netEcounts[0:25]) / denom,
#20200306                           Yerr=np.array(netEcounts_err[0:25]) / denom,
#20200306                           picType='netEdepos',
#20200306                           picTitle='netEdepos, low gain , sat' + satLabel.upper()+taskID,
#20200306                           xLabel='Edepos(KeV)',
#20200306                           yLabel='count rate($s^{-1}$$KeV^{-1}$)',
#20200306                           multiLabel=True,
#20200306                           picLayout=[5, 5],  # picLayout=[numheight, numwidth]
#20200306                           dir_savepic=rspoutputdir,
#20200306                           picName='netEdepos_lowGain_sat' + satstr.upper() +'_'+str(taskID)+'.png')
#20200306
#20200306    netfits_lowGain_satA.plotmulti()
#20200306    '''
#20200306    netfits_higGain_satA = genpic_GECAM.genplot(
#20200306        X=emid[25:50],
#20200306        Y=np.array(netEcounts[25:50]) / denom,
#20200306        Yerr=np.array(netEcounts_err[25:50]) / denom,
#20200306        picType='netEdepos',
#20200306        picTitle='netEdepos, high gain , sat' + satLabel.upper()+taskID,
#20200306        xLabel='Edepos(KeV)',
#20200306        yLabel='count rate($s^{-1}$$KeV^{-1}$)',
#20200306        multiLabel=True,
#20200306        picLayout=[5, 5],  # picLayout=[numheight, numwidth]
#20200306        dir_savepic=rspoutputdir,
#20200306        picName='netEdepos_highGain_sat' + satstr.upper() + '_'+str(taskID)+'.png')
#20200306
#20200306    netfits_higGain_satA.plotmulti()

#    '''for time resolved analysis'''
#    tbinwidth_forTR= globalvar_GECAM.glv.getVal('tbinwidth_TR')
#    tbins_forTR= int((corx_ROI[1]-corx_ROI[0])/tbinwidth_forTR)
#    print('---------------------------------------tbinwidth_forTR'+ str(tbinwidth_forTR))
#    print('-------------------------------------------tbins_fotTR'+str(tbins_forTR))
#    #os._exit(0)
#    for itbin in range(tbins_forTR):
#        corx_ROI_TR=[corx_ROI[0] + itbin*tbinwidth_forTR, corx_ROI[0]+(itbin+1)*tbinwidth_forTR]
#        print('in fill net fits---------------------------itbin' +str(itbin) +' ' +str(corx_ROI_TR))
#        genprojection.setpara(detID_selected,
#                              lte,
#                              corx_ROI_TR,
#                              corx_BG,
#                              tbins, tbinwidth, ebins, ebin_edges,
#                              bgpoly_tot,
#                              bgpcov_tot,
#                              bgpolyorder_tot,
#                              deadtime)
#        netEcounts_TR, \
#        netEcounts_err_TR, \
#        nettime_interval_TR, \
#        fullEcounts_TR, \
#        fullEcounts_err_TR, \
#        fulltime_interval_TR, \
#        BGEcounts_TR, BGEcounts_err_TR, \
#        BGtime_interval_TR = genprojection.genEdepos_projection()
#        genfitsforfitBG(detID_selected,
#                        netEcounts_TR,
#                        netEcounts_err_TR,
#                        nettime_interval_TR,
#                        fullEcounts_TR,
#                        fullEcounts_err_TR,
#                        fulltime_interval_TR,
#                        BGEcounts_TR,
#                        BGEcounts_err_TR,
#                        BGtime_interval_TR,
#                        ebins,
#                        genfitsDir,
#                        iTR='tbin'+str(itbin))



def fitBG_batch_forsingle(detID_selected,
                          lte,
                          tbins,
                          tbinwidth,
                          ebins,
                          ebin_edges,
                          attfile,
                          sttime,
                          sttimeMET,
                          angleinJ2000,
                          list_detecAngle_inSat,
                          genfitsDir,
                          rspoutputdir,
                          deadtime,
                          taskID,
                          Satlabel='a'):

    print('in BGfit for single: detID_selected' +str(detID_selected))
    #load all data
    #for single or burst 
    '''
    select  a brightest  detec
    angle_insatAB calculates the anglelist between detectors in satA or B
    '''

    langleinSat=angle_inSat_GECAM.angle_insatAB(angleinJ2000, sttimeMET,
                                                attfile, list_detecAngle_inSat, sat=Satlabel).tolist()
    idetec_max=langleinSat.index(min(langleinSat))
    if Satlabel=='j':
        idetec_max = idetec_max + 50
    print('idetec_max:' + str(idetec_max))
    het2D, time = toggle_GECAM.shape2Dhist(lte[idetec_max], tbins, tbinwidth, ebin_edges)
    counts = np.sum(het2D, axis=0)

    '''
    automatically get BG range 
    '''
    corx_BG=auto_getbgslice(time.tolist(), counts.tolist(),sttime )
    '''
    automatically get ROI range, from LC ana  with an unEfit-corrected-LC
    if corxROI has been filled, use former one
    '''
    corx_ROI=[sttime , corx_BG[2]-5.0]

#    if globalvar_GECAM.glv.getVal('corxROI_TR') == 'unfilled':
#        corx_ROItmp=[sttime-5, corx_BG[2]]
#        '''
#        LCana
#        :return dict_Tf, [peakT, peakflux], [significance, Pvalue] 
#        '''
#        f_level_forfullROI = [0]
#        tbinwidth_forLC=1.0
#        twindow=tbinwidth_forLC
#        tbins_forLC=int(globalvar_GECAM.glv.lastTime/tbinwidth_forLC)
#
#
#        dict_TROIforLC, peakTlist_null, siglist_null = LCana_GECAM.LCana_forLC(detID_selected, lte,
#                                                                               corx_BG, corx_ROItmp,
#                                                                               tbins_forLC, tbinwidth_forLC,
#                                                                               ebins, ebin_edges,
#                                                                               f_level_forfullROI, twindow,
#                                                                               ifcalPeak=False,
#                                                                               ifcalSig=False)
#        #print('---------------corx_BG' +str(corx_BG))
#        #print('---------------corx_ROItmp' +str(corx_ROItmp))
#        print('---------------dict_TROIforLC' +str(dict_TROIforLC))
#        globalvar_GECAM.glv.setVal('corxROI_TR', dict_TROIforLC['T100'][:2])
#
#    corx_ROI=globalvar_GECAM.glv.getVal('corxROI_TR')
#    if corx_ROI[0] != sttime:
#       corx_ROI[0]=sttime
#    print('-----------------corx_ROI' +str(corx_ROI))
#    print('---------------corx_BG' + str(corx_BG))

    print(genfitsDir)
    BGfitprocess(detID_selected,
                 corx_BG, corx_ROI,
                 tbins, tbinwidth,
                 ebins, ebin_edges,
                 lte, genfitsDir,rspoutputdir,
                 deadtime,
                 taskID,
                 satLabel=Satlabel)
    return corx_BG, corx_ROI



 
def fitBG_batch_forexternel(taskID, detID_selected,
                            lte, sttimeNet,
                            tbins, tbinwidth,
                            windowROI, windowBG_neb, windowBG_dis,
                            ebins, ebin_edges,
                            genfitsDir, rspoutputdir, deadtime):
    # for externel    
    corx_ROI=[sttimeNet-windowROI, sttimeNet+ windowROI]
    corx_BG=[sttimeNet-windowBG_dis, sttimeNet-windowBG_neb, sttimeNet+windowBG_neb, sttimeNet+windowBG_dis]
    #fit BG for batch
    print(genfitsDir)
    print('corx_ROI=' +str(corx_ROI))
    print('corx_BG='+str(corx_BG))
    corx_ROI = [49.999405704438686, 62.50129262233774]
    corx_BG = [8.328892959748226, 41.63379350497084, 101.2425644507747, 260.21595609231025]
    detAindex = np.where(np.array(detID_selected) < 50)[0]
    detID_selected_A = np.array(detID_selected)[detAindex].tolist()
    detBindex = np.where(np.array(detID_selected)>=50)[0]
    detID_selected_B = np.array(detID_selected)[detBindex].tolist()

    BGfitprocess(detID_selected_A, corx_BG,
                 corx_ROI, tbins, tbinwidth,
                 ebins, ebin_edges, lte,
                 genfitsDir,rspoutputdir, deadtime,taskID,satLabel='a')

    BGfitprocess(detID_selected_B, corx_BG,
                 corx_ROI, tbins, tbinwidth,
                 ebins, ebin_edges, lte,
                 genfitsDir, rspoutputdir, deadtime, taskID, satLabel='j')

