import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
#from RSP_Generator  import rspgenerator
import coordtrans
from tools import TTtoUTC, strTransforCLI,checkdir_GECAM
import argparse
from .genrsp_GECAM import *
import numpy as np
def genRSP():
    #genRSP_GECAM [232.222,80.703] 2020-12-01T05:53:37.141  ['/home/songxy/forGUItn201201_055336/ga_posatt_201201_05_v00.fits','/home/songxy/forGUItn201201_055336/gb_posatt_201201_05_v00.fits'] ~/forGUItn201201_055336/data/fitsforXspec/ a

    #genRSP_GECAM [147.383,31.683] 60509693.80502055 ['/home/songxy/tn201201_081452/ga_posatt_tn201201_081452_v00.fits'] /home/songxy/testforGECAMGRBanatools/data/fitsforXspec/ a

    parser = argparse.ArgumentParser()
    parser.add_argument('location_J2000', 
                        help='location of GRB in Equatorial coordinate system, RA (right ascension) and Dec (declination),e.g.[20,40]',
                        type=str,default=None)

    parser.add_argument('starttime',
                        help='input start time(MET) you want to generate RSP begin with (format:s)',
                        type=str,
                        default=None)
    parser.add_argument('attfile',
                        help='the posture filelist of satelite,e.g.[attfile1]',
                        type=str,
                        default=None)
    parser.add_argument('rspOutputDir',
                        help='the output directory for generated RSP files',
                        type=str,
                        default=None)
    parser.add_argument('satlabel',
                        help='a or b',
                        type=str)
    parser.add_argument('--detID_list',
                        dest='detID_list',
                        help='e.g.[0,1,2,3,4,...n](n<25) denotes the satA detector with low gain; 25-49 ,satA, high gain; 50-74,satB with low gain; 75-99, satB with high gain',
                        type=str,default=False)

    args = parser.parse_args()
    try:
    #if 1:
       location_J2000=strTransforCLI.strTran2list_float(args.location_J2000)
       print(location_J2000)
       sttimeMET=float(args.starttime)
       print(sttimeMET)
       attfile=strTransforCLI.strTran2list_str(args.attfile)
       print(attfile)
       rspOutputDir=checkdir_GECAM.checkdir(args.rspOutputDir)
       print(rspOutputDir)
       satlabel=args.satlabel
       print(satlabel)
       det_list=[]
       #taskID=''
       #if args.taskID != False:
       #   taskID= args.taskID
       if args.detID_list != False:
           det_list= strTransforCLI.strTran2list_float(args.detID_list)
       else:
           if satlabel == 'a':
              det_list=np.arange(25).tolist()
           elif satlabel=='b':
              det_list=np.arange(50,75).tolist()
           else:
              print('the satlabel input is wrong!')

       
       #genrsp(location_J2000, sttimeUTC,attfile,  rspOutputDir, detIDlist,Satlabel='A')
       angleinSat,rspfileDir= genrsp(location_J2000, sttimeMET ,attfile, rspOutputDir, det_list,  Satlabel=satlabel)
       print('angle in Sat' +str(angleinSat))
       print('rsp is generated in ' +str(rspfileDir))

    except:
       print('wrong/lack of arguments!')
 
       
