from astropy.io import fits
import numpy as np
import math
import time
import pathlib
import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from tools import getindex_GECAM, toggle_GECAM 
    
'''
this is for the main procedure

'''
def gethist_t(tnet, timeinterval, tbinw): #with given tbinw, return histogram for t, note that: here the t is a evt data

    ini_bins=int(timeinterval/tbinw)
    hist=np.histogram(tnet, ini_bins)
    time=np.delete(hist[1],ini_bins,axis=0)+tbinw/2.0
    counts_perT=hist[0]/tbinw                                        
    counts_perT_err=np.array([math.sqrt(x) for x in hist[0]])/tbinw
    return time,counts_perT, counts_perT_err

def gethist_countrate_perT(at, tbinw):#with given tbinw, return histogram for t, note that: here the t is a hist already
    counts_perT=at/tbinw
    counts_perT_err=at**0.5/tbinw     
    return counts_perT, counts_perT_err
    

def gethist_e(edepos, t_interval,ebin_array, lEbin_mid, lEbin_width): #with given ebinw, return hist for e, note that: here the e is a evt data
    Edepos= Ebin_mid
    hist=np.histogram(edepos, ebin_array) 
    counts_perE=hist[0]/lEbin_width/t_interval
    counts_perE_err=np.array([math.sqrt(x) for x in hist[0]])/lEbin_width/t_interval
    return np.array(Edepos), counts_perE, counts_perE_err
    
def gethist_countrate_perE(aedepos, timeinterval,detID, Eindex, Ebinwidth,lEbinmid):#with given ebinw, return hist for e, note that: here the e is already hist
    Edepos= lEbin_mid[Eindex[0]:Eindex[1]+1] 
    Ebinwidth= lEbin_width[Eindex[0]:Eindex[1]+1] 
    counts_perE=aedepos/Ebinwidth/timeinterval
    counts_perE_err=aedepos**0.5/Ebinwidth/timeinterval
    return np.array(Edepos), counts_perE, counts_perE_err



          
