'''
get the rsp data after checking if it exits

def rebin1dhist @author Dr. X.Song
'''
from astropy.io import fits
import numpy as np
import math
import os
import sys
sys.path.append(os.path.abspath(os.path.dirname(__file__)+'/'+'..'))
from data import *
from rspgenerator import *
from GUI import *

def getrspData(filename): #here should be a rsp name


    fitsname=glv.filedir_front+ 'docs/rspgenerator_CLI_GECAM_FITS/' + filename


    if os.path.isfile(fitsname):
       print('use already existing rsp files!')

       for idetec in  glv.detID_fitEdepos_selected:
           rspfile=''
           if idetec < 18:
              rspfile='T{:.2f}'.format(glv.theta_loc) + 'P{:.2f}'.format(glv.phi_loc) + 'D{:02d}'.format(idetec)+'.rsp'
           else:
              rspfile='T{:.2f}'.format(glv.theta_loc) + 'P{:.2f}'.format(glv.phi_loc) + 'DM.rsp'
           rsp=fits.open(glv.filedir_front+'docs/rspgenerator_CLI_GECAM_FITS/' +rspfile)
           #get 140 incident energy from the fits file
           spm=rsp[2].data
           E_in=(spm.field(1)-spm.field(0))/2.0
           rspm=spm.field(5)
           ebinwidth_in=spm.field(1)-spm.field(0)
           ebinleft_in=spm.field(0)
           ebinright_in=spm.field(1)

           glv.E_in=E_in
           glv.ebinleft_in=ebinleft_in
           glv.ebinright_in=ebinright_in
           glv.rspmatrix[idetec] =rspm
           print(rspm.shape)
           print('it should be 128*256')
           glv.ebinwidth_in=ebinwidth_in

           rsp.close()
          

    else: # if the rsp fits do not exist, invocate the rsp generator to generate matrix directly
       print('the rsp files don\'t exist, generate!')
       thetaphilist=['NOR']
       thetaphilist.extend([glv.theta_loc, glv.phi_loc])
       #print('glv.detID_selected' +str(glv.detID_selected))
       #print('glv.detID_fitEdepos_selected' +str(glv.detID_fitEdepos_selected))
       main_rspgen_gui(thetaphilist, glv.detID_selected)
